#!/bin/sh

if test $# -eq 0 || test "$1" = "-help"
then
	cat << EOF

Usage: 

		recent.bat filename

	copies all recent *.lsp and */*.lsp files of the calculus directory to
the tempdir. "Recent" is defined as "newer than filename".

	This makes it easy to do some development on one computer, and then
carry only the more recent files to another.

EOF
	exit 1
fi

dir=/home/ael/xlispstat-3-52-0/calculus
testfile=$dir/$1

######################################################################
#
# 			First archive:
#
######################################################################
tmpdir=$HOME/tmp
tmpdir=$tmpdir/calculus
mkdir $tmpdir

cd $dir
cp *.lsp $tmpdir

directories="etc math hulp contrib loop gnuplot graphics examples tutorial tutorial/book"
for i in $directories
do
	cd $dir/$i
	mkdir $tmpdir/$i
	/bin/rm -f $tmpdir/$i/*.lsp
	files=`ls *.lsp`
	for file in $files
	do
		if test $file -nt $testfile
		then
			cp $file $tmpdir/$i
		fi
	done
	cd $dir
done

	
