(defun butterfly ()
"
From majordom@stat.umn.edu Mon Nov  3 15:03 CST 1997
From: kjetil halvorsen <kjetil@caoba.entelnet.bo>

This just for fun, try it!
;; Example:
 (load-calc buttafly)
 (butterfly)
"
  (let* ((theta (rseq 0 (* pi 24) 2000))
         (radius (+
            (exp (cos theta))
            (- (* 2 (cos (* 4 theta))))
            (^ (sin (/ theta 12)) 5)))
         (p (plot-lines (* radius (sin theta))
                        (- (* radius (cos theta)))))
         (radmax (max radius))
         (colors (remove 'white (remove 'black *colors*)))
         (c (length colors))
         (z 20)  ; number of color zones
         (delta (/ radmax z))
        )
  (send p :use-color t)
  (send p :x-axis nil nil 0 :draw nil)
  (send p :y-axis nil nil 0 :draw nil)
  (send p :adjust-to-data :draw nil)
  (send p :menu-title "Butterfly")  ;; doesn't function
  (send p :title "Butterfly")
  (dotimes (j z)
    (let* ((lim0 (* j delta))
           (lim1 (* (+ j 1) delta))
           (ind (which (<= lim0 radius lim1)))
           (cc (first (sample (iseq c) 1)))
          )
       (send p :linestart-color ind (elt colors cc))))
  (send p :linestart-color (which (< radius 0)) 'blue)
  (send p :redraw)
  p
))

;; butterfly function from Ripley &Venables


