;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Start with some function which generates a rank-one matrix A.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(func f(x y) sin(x)*sin(y))
(def m 3)
(title (num-to-string m))
(def xs (rseq 0 1 m))
(def ys xs)
(def A (outer-product xs ys #'f))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Now I'm going to create the interpolating function:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun G(x) (mapcar (lambda(y) (f x y)) ys))
(defun H(y) (mapcar (lambda(x) (f x y)) xs))
(def inv (pseudo-inverse A))
(mprint inv)
(defun skin(x y) (matmult (g x) inv (h y)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Now we'll look at some plots:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(spin-domain -pi pi -pi pi)
(spin-points 21)
(plot skin)
(defun diff(x y) (- (skin x y) (f x y)))
(plot diff)
(print (max (abs (outer-product (rseq -pi pi 21) (rseq -pi pi 21) #'diff))))
