;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                knot stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(lines on)
(func r(x) (1-alpha*sin(3*x/2))/(1+alpha*sin(3*x/2)))
(def theta (rseq 0 4pi 200))

(def alpha .8)
(def x (* (cos theta) (r theta)))
(def y (* (sin theta) (r theta)))
(plot x y)
(send my-plot :range 0 -10 10)

(dolist
 (i (rseq .7 .1 7))
 (def alpha i)
 (def x (* (cos theta) (r theta)))
 (def y (* (sin theta) (r theta)))
 (send my-plot :add-plot-item (list 'lines x y))
 )

(def tt (/ 2 (+ 1 (^ x 2) (^ y 2))))
(def z (- 1 tt))
(def x (* tt x))
(def y (* tt y))
(lines on)
(plot x y z)


(def scale 2)
(func scale(x) (1-alpha/scale*sin(3*x/2+pi/3))/(1+alpha/scale*sin(3*x/2+pi/3)))
(def scales (scale theta))
(plot (* scales x)(* scales y)(* scales z))
#|
	Here's my translation of Dad's stuff, described below:
|#
(def lp 3)
(def n2 91)
(def qp (calc 4*pi/(n2-1)))
(def tt (rseq 0 (* n2 qp) n2))
(def r (+ 2 (cos (* lp tt .5))))
(def x (* r (cos tt)))
(def y (* r (sin tt)))
(def z (sin (* lp tt .5)))
(plot x y z)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
Andy,

The code that I used to place the curve on the torus is as follows:

qp = 4*pi/(n2-1)
t=-qp
for i=1 to n2
  t=t+qp
  call pplt
  x(i,1) = r*cos(t)
  x(i,2) = r*sin(t)
next i
sub pplt
 rem r=2+2*(abs(cos(lp*t/4))^2.4)
 r=2+(cos(lp*t/2))
 rem x(i,3)=(sin(lp*t/2))
 x(i,3)=(sin(lp*t/2))
end sub

I will attach the T Basic program for you to try.  I haven't rethought this
code, but it seemed to give decent pictures.

Love,  Dad

!!!Plotran program for plotting a polar 3d curve in stereo  - Trefoil Dec '92
option nolet
   !!! by Cliff Long 3-26-89
print " plotting of a polar coord. curve "
print "  for example:  r = 2+2*abs((cos(5*t/4))^3) "
print "  or for example:  r = 3 + cos(5*t/2) "
print " input the loop # & the number of pts. used ( 3,91 are OK )"
input lp, n2
dim x(3,3),u(3,3),v(3,3),y(3,3),po(4,5),a(3,3),b(4,3)
mat redim x(n2+1,3),u(n2,3),v(n2+1,3),y(3,3),po(n3,5),a(3,3),b(vertex,3)
qp = 4*pi/(n2-1)
t=-qp
for i=1 to n2
  t=t+qp
  call pplt
  x(i,1) = r*cos(t)
  x(i,2) = r*sin(t)
next i
sub pplt
 rem r=2+2*(abs(cos(lp*t/4))^2.4)
 r=2+(cos(lp*t/2))
 rem x(i,3)=(sin(lp*t/2))
 x(i,3)=(sin(lp*t/2))
end sub
open #3: screen 0,1,0,1
set window 0,480,0,360
set cursor 1,1
k4=120
for rr=1 to 15
  if rr=1 then
   print "input theta, phi for view. 1,1 are OK."
   r=25
   input th,ph
   k4=120
  end if
  call grafset
  call axes
  call plotpts
  rem call plotlines
set cursor 1,1
if rr>1 then print "                                                       "
if rr>1 then print "                                                       "
set cursor 1,1
if a$="s" then th=th-.032
print "input s, t, r, n, or q for stereo, transf, repeat or quit "
input a$
if a$="t" then call transf
if a$="s" then call stereo
if a$="r" then
  call repeat
  box clear 180,480,0,360
  call transf
end if
if a$="n" then call newview
if a$="q" then stop
k4=300
next rr
close #1
stop

sub grafset
  s1=sin(ph)
  c1=cos(ph)
  s2=sin(th)
  c2=cos(th)
  k5=120
  m=20
end sub
sub persp
  f=c2*x1+s2*y1
  u1=s1*f+c1*z1
  v1=-s2*x1+c2*y1
  w1=-c1*f+s1*z1
  dd=1-u1/r
  p=m*v1/dd+k4
  q=k5+m*w1/dd
end sub
sub plotvertex
  for ii=1 to vertex
    x1=b(ii,1)
    y1=b(ii,2)
    z1=b(ii,3)
    call persp
      plot p,q
  next ii
end sub
sub plotpts
  for ii=1 to n2
    x1=x(ii,1)
    y1=x(ii,2)
    z1=x(ii,3)
    call persp
    if ii=n2 then
      plot p,q
    else
      plot lines: p,q;
    end if
  next ii
end sub
sub plotlines
  n22=int(n2/2)
  n22=int(n2/3)
  for ii=1 to n22+1
    x1=x(ii,1)
    y1=x(ii,2)
    z1=x(ii,3)
    call persp
      plot p,q
    x1=x(ii+2*n22+1,1)
    y1=x(ii+2*n22+1,2)
    z1=x(ii+2*n22+1,3)
    call persp
      plot lines: p,q;
  next ii
      plot p,q
end sub
sub transf
  set cursor 1,1
  if a$="t" then
    print "input matrix A                                       "
    mat input a
  end if
  for i=1 to n2
    for k=1 to 3
      v(i,k)=a(k,1)*x(i,1)+a(k,2)*x(i,2)+a(k,3)*x(i,3)
    next k
  next i
  call repeat
  k4=360
end sub
sub repeat
  for i=1 to n2
    for k=1 to 3
      x(i,k)=v(i,k)
    next k
  next i
end sub
sub newview
  set cursor 1,1
  box clear 0,480,0,360
  rr=0
end sub
sub stereo
  k4=300
  th=th+.032
  for i=1 to n2
    for k=1 to 3
      v(i,k)=x(i,k)
    next k
  next i
end sub
sub axes
  x1=0
  y1=0
  z1=0
  call persp
  pp=p
  qq=q
  plot points: pp,qq
  plot lines:pp,qq;
  x1=1.25
  call persp
  plot lines: p,q;
  plot lines: pp,qq;
  x1=0
  y1=1.25
  call persp
  plot lines: p,q;
  plot lines: pp,qq;
  y1=0
  z1=1.25
  call persp
  plot lines: p,q;
  plot points: p,q
end sub
end

|#
