;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 file-to-maple-ms
;;
(defun file-to-maple-ms(infile outfile)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          file-to-maple-ms Doc:
;;
;; Author: Andy Long
;; Created: 10/29/1997
;;
;; Description/Arguments:

       (file-to-maple-ms infile outfile)
  
	Maple didn't seem to have an easy way to turn a text file into a
  worksheet, so I kludged this one up.
"
  (let ((lines (read-file infile)))
    (with-open-file
     (g outfile :direction :output)
     (format g "
{VERSION 1 1 \"MS-Windows\" \"1.0\"}
{GLOBALS 1 2}
{FONT 0 \"Arial\" \"Arial\" \"Helvetica-Bold\" 7 12 0 \"Helvetica-Bold\" 
12{COLOR \"800080\"}}
{FONT 1 \"Times New Roman\" \"Times New Roman\" \"Times-Bold\" 7 12 64 
\"Times-Bold\" 12{COLOR \"000000\"}}
{FONT 2 \"Courier New\" \"Courier New\" \"Courier-Bold\" 7 11 192
\"Courier-Bold\" 11{COLOR \"008080\"}}
{SCP_R 0 0 2
	{SCP_R 1 0 533
")
     (mapcar
      (lambda(x y) (format g "{INP_R ~d 0 \"> \"{TEXT 0 ~d \"~a\"}}~%"
			   x (length y) y))
      (* 3 (iseq (length lines)))
      (mapcar #'replace-braces-with-slash-braces lines)
      )
     (format g "}}{END}")
     )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun replace-braces-with-slash-braces(string)
  "
;; Examples:
 (replace-braces-with-slash-braces \"{a}\")
"
  (let (
	(result
	 (apply
	  #'strcat
	  (mapcar #'(lambda(x) (string (code-char x)))
		  (grep-replace
		   '(1123) '(123) 
		   (grep-replace
		    '(1125) '(125) 
		    (grep-replace
		     '(123) '(92 1123) 
		     (grep-replace
		      '(125) '(92 1125) 
		      (mapcar #'char-int (coerce string 'list))
		      ))))
		  )
	  )
	 )
	)
    (if result result "")))