;; The Manual and its Contents

;; Ingredients, taken from Xlisp-Plus 2.1f Manual

(setq %cloops% 
      (list
       "Xlisp Command Loop" "*startup-functions*"
       "*load-file-arguments*" "*dos-input*"))

(setq %bloops% 
     (list "Break Command Loop" "*breakenable*" "*tracenable*"))

(setq %dtypes% (list "Data Types"))

(setq %evalu% (list "The Evaluator"))

(setq %hook%
      (list "Hooks" "evalhook" "applyhook"
	    "*evalhook*" "*applyhook*" "*gc-hook*"))

(setq %lexical% (list "Lexical Conventions"))

(setq %readtab%
      (list "Readtables" ":white-space" ":tmacro" ":nmacro"
	    ":sescape" ":mescape" ":constituent"))

(setq %casecont%
      (list "Symbol Case Control" "*readtable-case*" "*print-case*"))

(setq %package% (list "Packages"))

(setq %lambda%
      (list "Lambda Lists"
	    "&optional" "&rest" "&key"
	    "&aux"
	    ))

(setq %objects% (list "Objects" "object" "self" ":isnew" ":new" ":show"))

;;(setq %mikintro%
;;  (list "Introduction"))

(setq %eval%
     (list "eval" "apply" "funcall" "quote" "function"
	   "complement" "identity" "backquote" "comma"
	   "comma-at" "lambda" "get-lambda-expression"
	   "macroexpand" "macroexpand-1" "eval-string"
	   ))

(setq %mulval%
      (list
       "multiple-value-bind" "multiple-value-call"
       "multiple-value-list" "multiple-value-prog1"
       "multiple-value-setq" "nth-value" "values" "values-list"
       ))

(setq %symbol%
     (list "set" "setq" "psetq" "setf" "psetf" "defsetf"
	   "push" "pushnew" "pop" "incf" "decf" "defun"
	   "defmacro" "gensym" "intern" "make-symbol"
	   "symbol-name" "symbol-value" "symbol-function"
	   "symbol-plist" "hash" "makunbound" "fmakunbound"
	   "unintern" "defconstant" "defparameter" "defvar"
	   "mark-as-special" "declare" "proclaim"
	   "genvars"
	   ))

(setq %pack%
     (list "apropos" "apropos-list" "defpackage" "delete-package"
	   "do-symbols" "do-external-symbols" "do-all-symbols"
	   "export" "find-all-symbols" "find-package" "find-symbol"
	   "import" "in-package" "list-all-packages" "make-package"
	   "package-name" "package-nicknames" "package-obarray"
	   "package-shadowing-symbols" "package-use-list"
	   "package-used-by-list" "package-valid-p" "rename-package"
	   "shadow" "shadowing-import" "symbol-package" "unexport"
	   "unuse-package" "use-package"))

(setq %prop% (list "get" "getf" "putprop" "remf" "remprop"))

(setq %hash% 
      (list
       "make-hash-table" "gethash" "remhash" "clrhash" "hash" "maphash"))

(setq %array% (list
	       "%*"
	       "aref"
	       "array-dimension"
	       "array-dimensions"
	       "array-in-bounds-p"
	       "array-rank"
	       "array-row-major-index-array"
	       "make-array"
	       "mat"
	       "matrix"
	       "vector"
	       ))

(setq %sequence%
      (list 
       "break-sequence-into-runs"
       "concatenate" "elt" "map" "map-into" "every"
       "notevery" "some" "notany" "length" "reverse"
       "nreverse" "subseq" "sort" "search" 
       "remove" "remove-if" "remove-if-not" 
       "count" "count-if" "count-if-not" 
       "find" "find-if" "find-if-not"
       "position" "position-if" "position-if-not"
       "delete" "delete-if" "delete-if-not"
       "reduce" "remove-duplicates"
       "fill" "replace"))

(setq %list%
      (list
       "append1"
       "tail-chop"
       "head-chop"
       "list-split"
       "car" "ca.r" "ca..r" "ca...r"
       "cdr" "cd.r" "cd..r" "cd...r"
       "first" "second" "third" "fourth" "rest"
       "cons" "acons" "list" "list*" "append"
       "list-length" "last" "butlast" "repeat" "repeater"
       "nth" "nthcdr" "member" "member-if-not" "assoc" "adjoin"
       "mapc" "mapcar" "mapl" "maplist" "mapcan"
       "mapcon" "subst" "nsubst" "sublis" "nsublis"
       "pairlis" "copy-list" "copy-alist" "copy-tree"
       "intersection" "union" "set-difference" "set-exclusive-or"
       "nintersection" "nunion" "nset-difference" "nset-exclusive-or"))

(setq %destruct% (list "rplaca" "rplacd" "nconc" "nsubst-if" "nsubst-if-not"))

(setq %arith% 
      (list
       "+" "-" "*" "/" "1+" "1-"
       "log" "exp" "expt" "sin" "cos" "atan" "asin" "acos"
       "sinh" "cosh" "tanh" "asinh" "acosh" "atanh" "cis"    
       "<" "<=" "=" "/=" ">=" ">"
       "rem" "mod" "min" "max" "abs" "signum"
       "gcd" "lcm" "sqrt"
       "random" "make-random-state"
       "truncate" "round" "floor" "ceiling"
       "float" "rational" "complex"
       "realpart" "imagpart" "conjugate" "phase"
       "numerator" "denominator"))

(setq %logic% (list "logand" "logior" "logxor" "lognot" "logtest" "ash"))

(setq %logical%
      (list 
       "and" "not" "and-function" "or-function" "unless"
       "while" "if"
       ))

(setq %string%
      (list "string" "string-trim" "string-left-trim" "string-right-trim"
	    "string-upcase" "string-downcase" "string-capitalize"
	    "nstring-upcase" "nstring-downcase" "nstring-capitalize"
	    "strcat"
	    "string<" "string<=" "string=" "string/=" "string>" "string>="
	    "string-lessp" "string-greaterp" "string-not-equal"
	    "string-not-greaterp" "string-not-lessp"
	    "space-trim"
	    "snip-string"
	    ))

(setq %character%
      (list "char" "alphanumericp" "upper-case-p" "lower-case-p"
	    "alpha-char-p" "both-case-p" "digit-char-p" 
	    "code-char" "char-code" "char-upcase" "char-downcase"
	    "digit-char" "char-int" "int-char" 
	    "char<" "char<=" "char/=" "char=" "char>=" "char>"
	    "char-lessp" "char-equal" "char-greaterp"
	    "char-not-greaterp" "char-not-lessp"))

(setq %structure% (list "defstruct"))

(setq %object% (list "send" "send-super" "defclass" "defmethod" "definst"))

(setq %predicate% 
      (list "atom" "symbolp" "numberp" "null" "not" "listp"
	    "endp" "consp" "constantp" "specialp" "integerp"
	    "floatp" "rationalp" "complexp" "stringp" 
	    "characterp" "arrayp" "streamp" "open-stream-p"
	    "input-stream-p" "output-stream-p" "objectp" "classp"
	    "boundp" "fboundp" "minusp" "plusp" "zerop" "evenp"
	    "oddp" "susetp" "eq" "eql" "equal" "equalp"
	    "typep"))

(setq %control%
      (list "cond" "and" "not" "or" "if" "when" "unless" "case"
	    "let" "let*" "flet" "labels" "macrolet"
	    "catch" "throw" "unwind-protect"))

(setq %looping% (list "loop" "do" "do*" "dolist" "dotimes"))

(setq %program%
      (list "prog" "prog*" "block" "return" "return-from" "tagbody"
	    "go" "progv" "prog1" "prog2" "progn"))

(setq %iofunc%
      (list "set-macro-character" "get-macro-character"
	    "read" "print" "prin1" "princ" "pprint" "terpri"
	    "fresh-line" "flatsize" "flatc" "y-or-n-p" "format"))

(setq %fileio%
      (combine
       (list
	"read-char" "peek-char" "write-char" "read-line"
	"open" "close" "delete-file" "truename"
	"with-open-file" "read-byte" "write-byte"
	"file-length" "file-position")
       (mapcar #'string-downcase
	       (mapcar #'symbol-name
		       '(
			 matrix-from-file-of-lines 
			 read-file 
			 read-file-as-vector 
			 put-control-m
			 unix-file-to-dos-file
			 open-append
			 )))
       ))


(setq %strstr%
      (list "make-string-input-stream" "make-string-output-stream"
	    "get-output-stream-string" "get-output-stream-list"
	    "with-input-from-string" "with-output-to-string"))

(setq %debug% 
      (list "trace" "untrace" "error" "cerror" "break" "clean-up"
	    "top-level" "continue" "errset" "baktrace" "evalhook"
	    "applyhook" "debug" "nodebug"))

(setq %system%
      (list "load" "restore" "save" "savefun" "dribble" "gc"
	    "expand" "alloc" "room" "time" "get-internal-real-time"
	    "get-internal-run-time" "coerce" 
	    "type-of" "peek" "poke" "address-of" "get-key"
	    "system" "set-stack-mark" "top-level-loop"
	    "reset-system" "exit" "generic" "eval-when"))

;;; Variables

(setq %reader% (list "+" "++" "+++" "*" "**" "***" "-"))

(setq %constants% (list "nil" "t" "internal-time-units-per-second" "pi"))

(setq %specvar%
      (list
       "*obarray*" "*package*" "*terminal-io*" "*standard-input*"
       "*standard-output*" "*error-output*" "*trace-output*"
       "*applyhook*" "*debug-io*" "*breakenable*" "*tracelist*"
       "*traceenable*" "*tracelimit*" "*evalhook*" "*applyhook*"
       "*readtable*" "*gc-flag*" "*gc-hook*" "*integer-format*"
       "*ratio-format*" "*float-format*" "*readtable-case*"
       "*print-case*" "*print-level*"  "*print-length*" "*dos-input*"
       "*displace-macros*" "*random-state*" "*features*"
       "*startup-functions*" "*command-line*"
       "*load-file-arguments*" "*top-level-loop*" "*read-surpress*"))

(setq %protos%
      (list
       "*object*"
       "hardware-object-proto"
       "window-proto"
       "edit-window-proto"
       "listener-proto"
       "menu-proto"
       "apple-menu-proto"
       "menu-item-proto"
       "dialog-proto"
       "dialog-item-proto"
       "button-item-proto"
       "toggle-item-proto"
       "text-item-proto"
       "choice-item-proto"
       "scroll-item-proto"
       "list-item-proto"
       "graph-window-proto"
       "graph-proto"
       "spin-proto"
       "scatmat-proto"
       "name-list-proto"
       "histogram-proto"
       "scatterplot-proto"
       "compound-data-proto"
       "regression-model-proto"
       ))

(setq %ttypes%
      (list
       "subr" "fsubr" "cons" "symbol" "fixnum" "flonum"
       "string" "object" "file-stream" "vector" "closure"
       "character" "unnamed-stream" "complex" "array"
       ))

(setq %keywords%
      (list 
       "&optional"
       "&rest"
       "&key"
       "&aux"
       ":white-space" ":tmacro" ":nmacro" ":sescape"
       ":mesecape" ":constituent"))

(setq %geostats%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			estimate-anisotropic-variogram
			estimate-variogram
			exponential-variogram
			gaussian-variogram
			gaussian-variogram-2d
			global-krig
			kernel-smoother
			kernel-smoother-with-direction
			linear-variogram
			local-krig 
			logistic-variogram
			nugget-variogram
			power-variogram
			spherical-variogram
			test-geostatistics
			variance 
			vario
			vario-binary
			variogram 
			create-geoeas-data 
			create-geoeas-data 
			matrix-to-geoeas-data 
			write-geoeas-data 
			))))


(setq %oop%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			defproto
			change2 
			dispose
			save-object
			show-slots 
			tack-colon-onto-symbol
			ask 
			change 
			new 
			new-accessor-method 
			show 
			uber-proto 
			))))

(setq %misc-functions%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			ceil
			round
			round-to
			floor
			cube
			square
			half
			quadratic
			sinc
			julian
			caldate
			day-of-the-week
			))))			

(setq %sets%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			union
			unions
			intersections
			intersection
			make-all-tuples
			all-subsets
			subset
			subsetp
			))))

(setq %searching%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			grep
			grep-replace
			recursive-grep
			recursive-grep-replace
			find-min
			find-max
			find
			search
			find-duplicates
			gimme
			where
			select-if
			))))


(setq %sorting%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			find-duplicates
			remove-duplicates
			gimme
			remove-dups
			where
			select-if
			subset
			by
			sort-data
			sort
			sort-with-index
			simul-eliminate-value 
			simul-eliminate-zero 
			simul-keep-if 
			simul-keep-value 
			simul-remove-if 
			simul-sort 
			))))

(setq %utility%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			abscissa
			again 
			and-function
			break-string-into-lines
			break-string-into-lines-and-evaluate 
			by 
			catch-keys
			cls
			cm-ft-in 
			compile-function
			date
			dir 
			echo
			edit-pic
			element 
			eval-string
			factor
			final
			find-duplicates
			find-max
			find-min
			firsts 
			ft-in-cm 
			genvars 
			gimme
			gnuplot
			greatest-divisor
			grid 
			grid-over-data
			helplass 
			home 
			indicator
			kg-lb
			lb-kg
			link-all-plots
			lpq 
			lpr 
			matrix-to-sas
			message 
			mvsq
			neq 
			nth-ones 
			or-function
			ordinates
			paws 
			pick
			print-every
			print-pic
			printall 
			quit
			re-standardize
			read-matrix-data 
			read-matrix-with-dimensions 
			redoc
			remove-bunch
			remove-comments
			remove-dups
			remove-keys
			rotation 
			round-down
			round-up
			seconds 
			select-from-end
			select-if 
			sgw
			smoosh
			snip-string
			space-print-num
			space-trim
			string-to-list
			string-to-num 
			subset
			unlink-all-plots
			v-and 
			vcoerce
			weave
			where
			about
			calculus 
			catch-multiple-values
			cd 
			cd-calc
			eltt
			gv
			is-it-bound 
			load-calc
			map-it
			mult-setq 
			mvsetq 
			ou
			try-out 
			compile-and-load-code
			francais
			intersections
			primep
			put-control-m
			redoc-file
			replace-char-by-char
			rough-diff-dates
			system-to-string
			try-file
			unions
			unix-file-to-dos-file
			v-or 
			load-data
			while
			unless
			))))

(setq %misc%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			catch-keys
			remove-keys
			inspect
			history
			get-lambda-expression 
			num-to-string 
			strcat 
			cap
			sgw
			by
			gle
			alias
			macro-alias
			func
			calc
			all-subsets
			prune
			bitmap
			latex-table
			write-latex-table
;;; lost em all! ael
;;;       "dyndiag.readme"
;;;       "expsurv.readme"
;;;       "format.readme"
;;;       "sapaclisp.readme"
;;;	 "hatch.readme"
;;; (list "xlisp.hlp"                                  %xlisp.hlp%)
			))))

(setq %optimize%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			muller-extrema
			2steepest 
			steep-path 
			steepest 
			2steep 
			steep 
			))))

(setq %specfunc%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			bessel-i 
			bessel-j 
			bessel-i
			beta
			beta-naive 
			betacf 
			betai 
			elliptic-cosine 
			elliptic-integral-e 
			elliptic-integral-ec 
			elliptic-integral-k 
			elliptic-integral-kc 
			elliptic-sine 
			gamma* 
			gamma*aux 
			gamma-incomplete 
			log-beta
			bump
			composite
			composition2 
			digamma 
			digamma-general
			erf 
			erfc 
			erfc 
			factorial 
			fib 
			fibonacci 
			gamma
			heaviside
			trigamma 
			trigamma-general
			composition
			))))
(setq %splines%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			b-spline
			b-spline-double-prime
			clamped-spline 
			hermite-spline 
			hermite-spline-derivative
			hermite-spline-function
			hermite-spline-second-derivative
			lagrange-polynomial 
			lagrange-spline 
			lin-spline 
			Lagrange 
			))))

(setq %parametric%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			bezier
			bezier-interp
			bezier-interp-with-cusps
			bezier2
			bezier3
			))))

(setq %epidemio%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			odds-ratio
			relative-risk
			2x2-diagnostic-testing
			probability-to-odds
			odds-to-probability
			update-test-probability
			lr+
			lr-
			post-test-probability
			kaplan-meier
			mantel-haenszel
			summary-mantel-haenszel
			summary-mh-helper
			))))

(setq %series%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			dft
			fourier
			fourier2
			taylor
			taylor2
			s-taylor
			s-taylor-too
			))))

(setq %ode/pde%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			linear-higher-order-ode
			linear-first-order-ode
			generalized-eigenvectors
			jordan-form
			jordan-form-helper
			jordan-associated-t-matrix
			orbitals
			phase-plane
			stiff-ode
			rk-4
			rk-f
			euler
			euler2
			euler-nd
			euler-delay-plot
			eulerplot
			2euler2
			2euler
			slope-field
			slope-field2
			wave-pde
			crank-nicolson
			poisson-pde
			))))
(setq %matrix%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			vector-in-span-of-vectors-p
			span-vectors
			reduce-to-basis
			orthogonal-p
			colinear-p
			projection
			orthogonal-complement
			zero-vector-p
			complete-A-from-subspace-B
			hermitian
			hermitian-p
			matrix-trace
			inverse-of-A-with-one-column-swap
			size
			row
			column
			select-columns
			select-rows
			select-columns-by
			select-rows-by
			average-columns
			average-rows
			submatrix
			change-matrix-value
			setm
			setl
			comp
			set-row
			set-column
			id
			zeros
			ones
			svd
			sv-decomp
			pseudo-inverse
			pseudo-solve
			pca
			pca-factors
			low-rank
			correlation
			matrix-row-stats
			matrix-column-stats
			sort-matrix
			mprint
			print-matrix
			mat
			table
			mat-solve
			dot
			norm
			normalize
			cross
			combine-matrices
			number of columns
			flesh
			flesh2
			matroid
			matroid-to-matrix
			matrix-to-matroid
			plot-matrix-columns
			matrix-multiply
			remove-missing
			mat-fill
			diagonal-to-matrix
			extract-upper-triangular
			extract-lower-triangular
			upper-to-full
			lower-to-full
			make-grid
			inside-nth
			robust-svd
			Householder-triangular-form
			qr-decomp
			polar-decomp
			Householder-qr-decomp
			matrix-equalp
			permutation-matrix
			backsolve
			rotate-clock-wise-matrix
			symmetric-matrix-p
			square-matrix-p
			2-by-2-eigen
			eigen
			eigenvalues
			eigenvectors
			generalized-eigenvectors
			jordan-form
			jordan-associated-t-matrix
			jacobian
			))))

(setq %differentiation% (list
			 "diff"
			 "diff-n"
			 "ndiff"
			 "diffplot"
			 "dplot"
			 "splot"
			 "der"
			 "derfunc"
			 "deriv"
			 "derivfunc"
			 "jacobian"
			 "gradient"
			 "numerical-derivative"
			 "lambda-deriv"
			 ))

(setq %integration%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			simpson
			simpsons-matrix
			lrr
			rrr
			mid
			trap
			integrate-matrix
			integrate-xy2
			integrate2
			hermite
			simp
			simp2
			gauss
			integral
			integral2
			integrate
			integration
			))))

(setq %roots% 
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			linear-roots
			quadratic-roots
			cubic-roots
			quartic-roots
			linear-approximation 
			muller-1 
			muller-2
			muller2
			muller2
			newton-zero
			newton2 
			secant2 
			newton-l 
			newton-root 
			roots 
			tangent 
			newton
			secant
			roots
			muller
			bisection
			))))
			       
(setq %plotting%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			bar-chart
			boxplot
			spreadplot
			contour-levels 
			contour-matrix
			contour-points 
			contour2 
			contour
			section
			plot
			plotit
			diffplot
			dplot
			splot
			fplot
			fpplot
			fppplot
			histo
			histogram
			histogram-proto
			plot-function
			plot-points
			scatterplot-proto
			plot-lines
			postscript
			postscript-3d
			spin-plot
			spin-proto
			scatmat-proto
			graph-window-proto
			graph-proto
			animate
			animate2
			slice
			))))

(setq %math/stat%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			analysis-of-variance
			andrews-pregibon
			binomial-ci
			binomial-coef
			bonferroni
			categorize
			chi-square
			correlated-variables
			de-categorize
			durbin-watson
			fishers-z
			fishers-exact-test
			case-control
			matched-case-control
			grand-stats 
			hochberg 
			holm 
			kernel-density
			density-plot
			kurtosis
			missing-mean
			anova
			geometric-regression 
			logistic
			logistic-maximum-likelihood
			minimize-sum-of-squares
			pca-regression
			press
			regress
			remove-menus-on-menu-bar
			ridge-regression
			step-wise
			backward-step-wise
			one-way-anova
			paired-t
			partial-correlation
			poisson-ci
			power 
			power-difference 
			power-left 
			power-n 
			power-right 
			power-weighted-difference 
			ratio-of-variances-ci
			runs-test
			simulate-runs-test-probability
			skewness
			t-test
			t-test-summary
			two-way-anova
			two-way-regression
			univariate
			value-with-se
			variance-ci
			))))

;;; Statistics
(setq %datcrea%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			one-multinomial-rand
			multinomial-rand
			multiuniform-rand
			logistic-rand
			laplace-rand
			rayleigh-rand
			one-uniform-rand
			rectangular-rand
			independent-normal-rand
			inverse-gaussian-rand
			one-inverse-gaussian-rand
			gaussian-rand
			one-exponential-power-rand
			hyperbolic-secant-rand
			pareto-rand
			power-rand
			weibull-rand
			exponential-rand
			multinormal-rand
			f-rand
			binomial-rand
			make-random-state
			gamma-rand
			t-rand
			normal-rand
			cauchy-rand
			chisq-rand
			uniform-rand
			poisson-rand
			beta-rand
			iseq
			rseq
			repeat
			repeater
			))))
(setq %descrip%
 (list
  "mean"
  "standard-deviation"
  "sd"
  "variance"
  ))
(setq %distrib%
      (mapcar #'string-downcase
	      (mapcar #'symbol-name
		      '(
			negative-binomial-cdf
			rectangular-cdf
			inverse-gaussian-cdf
			gaussian-cdf
			noncentral-chisq-cdf
			laplace-cdf
			hyperbolic-secant-cdf
			power-cdf
			pareto-cdf
			noncentral-f-cdf
			perks-cdf
			rayleigh-cdf
			noncentral-t-cdf
			weibull-cdf
			exponential-power-cdf
			sum-of-uniforms-cdf
			exponential-cdf
			logistic-cdf
			triangular-cdf
			bivnorm-cdf
			f-cdf
			poisson-cdf
			beta-cdf
			binomial-cdf
			t-cdf
			cauchy-cdf
			normal-cdf
			chisq-cdf
			gamma-cdf
			sum-of-uniforms-dens
			independent-normal-dens
			inverse-gaussian-dens
			gaussian-dens
			weibull-dens
			exponential-dens
			exponential-power-dens
			kernel-dens
			multinormal-dens
			extreme-value-dens
			logistic-dens
			hyperbolic-secant-dens
			noncentral-chisq-dens
			power-dens
			multiuniform-dens
			laplace-dens
			perks-dens
			rayleigh-dens
			triangular-dens
			pareto-dens
			noncentral-t-dens
			kernel-density
			noncentral-f-dens
			rectangular-dens
			t-dens
			beta-dens
			chisq-dens
			gamma-dens
			normal-dens
			f-dens
			cauchy-dens
			))))

;;; the parts and their chapters
(setq %ingrets%
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	(list "Xlisp Command Loop"                           %cloops%   ) 
	(list "Break Command Loop"			        %bloops%   )
	(list "Data Types"                                   %dtypes%   )
	(list "The Evaluator"				%evalu%    )
	(list "Hooks"                                        %hook%     )
	(list "Lexical Conventions"                          %lexical%  )
	(list "Readtables"                                   %readtab%  )
	(list "Symbol Case Control"	                        %casecont% )
	(list "Packages"                                     %package%  )
	(list "Lambda Lists"                                 %lambda%   )
	(list "Objects"                                      %objects%  )
	)))

(setq %functions%
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	;;(list "Introduction"                     %mikintro% )
	(list "Arithmetic"                         %arith%    )   
	(list "Array"                              %array%    )
	(list "Bitwise Logical"                    %logic%    ) 
	(list "Character"                          %character%)
	(list "Control Constructs"                 %control%  )
	(list "Debugging/Error Handling"	%debug%    )
	(list "Evaluation"                         %eval%     )
	(list "File I/O"                           %fileio%   )
	(list "Hash Table"                         %hash%     )
	(list "Input/Output"                       %iofunc%   )
	(list "List"                               %list%     )
	(list "List (Destructive)"                   %destruct% )
	(list "Looping"                 %looping%  )
	(list "Multiple Value"                     %mulval%   )
	(list "Object"                             %object%   )
	(list "Package"                            %pack%     )
	(list "Predicate"                          %predicate%)
	(list "Program Feature"                %program%  )
	(list "Property List"                      %prop%     )
	(list "Sequence"                           %sequence% )
	(list "String"                             %string%   )
	(list "String (Stream)"                      %strstr%   )
	(list "Structure"                          %structure%)
	(list "Symbol"                             %symbol%   )
	(list "System"                             %system%   )
	)))

(setq %variables% 
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	(list "Constants"                                  %constants%)
	(list "Keywords"                                   %keywords% )
	(list "Prototypes"                                 %protos%   )
	(list "Reader Variables"                           %reader%   )
	(list "System Variables"                           %specvar%  )
	(list "Types"                                      %ttypes%   )
	)))

(setq %tutor%
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	(list "help" (list "help" "help*" "hulp"))
	(list "tutorial" (list "tutorial" "tutorials"))
	(list "book" (list "book"))
	)))

(setq %statist%
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	(list "Data Creation"                              %datcrea%  )
	(list "Descriptive Statistics"                     %descrip%  )
	(list "Math/Stats"                     %math/stat%  )
	(list "Distributions"                              %distrib%  )
	)))


(setq %andys% 
      (mapcar
       (lambda(xx) (let ((x (first xx)) (y (second xx)))
		     (list x (select y (order y)))))
       (list
	(list "Differential Eqs"                           %ode/pde%)
	(list "Differentiation"                            %differentiation%)
	(list "Geostatistics"                                %geostats%)
	(list "Integration"                                %integration%)
	(list "Logical"                                  %logical%)
	(list "Math/Stat"                                  %math/stat%)
	(list "Matrix operations"                          %matrix%)
	(list "Misc"                      %misc%)
	(list "Misc Math functions"                        %misc-functions%)
	(list "Optimization"                          	   %optimize%)
	(list "Object-Oriented Programming"            	   %oop%)
	(list "Parametric"                          	   %parametric%)
	(list "Plotting"                                   %plotting%)
	(list "Root-finding"                               %roots%)
	(list "Searching"                               %searching%)
	(list "Series"                               %series%)
	(list "Sets"                               %sets%)
	(list "Sorting"                               %sorting%)
	(list "Special Functions"                          %specfunc%)
	(list "Splines"                          	   %splines%)
	(list "Utilities"                          	   %utility%)
	(list "Epidemiology"                          	   %epidemio%)
	)))

;;; the manual and its parts

(setq %manual%
      (list "Manual"
	    (list
	     (list "Ripon Good Math"            %andys%    )
	     (list "Variables/Types"            %variables%)
	     (list "Functions"                  %functions%)
	     (list "Statistics"                 %statist%  )
	     (list "Tutorials/help"                   %tutor%    )
	     ;;(list "Ingredients"              %ingrets%  ) 
	     ;;(list "Introduction"             %intro%    )
	     ;;(list "Graphics"                 %graphics% )
	     ;;(list "Various Add-ons"          %add-ons%  )
	     )))


