;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                data
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; data Doc:    Creation Date:12/18/95        Author: Andy Long
;;
;;
(defmacro data (name &rest stuff)
  "
;; Description:

       (data name &rest stuff)
  
;; Arguments

       name: the name of the object to be defined
       stuff: the stuff that the name will signify

       Creates data (called \"name\") out of a set of coordinates or values
 (\"stuff\"). Thus we're given either numbers or lists (coordinates).

;; Returns: name

;; Examples:
 (data crum 1 2 3 4)
 crum

 (new-plot)
 (data crum (1 2) (3 4) (5 4) (8 2))
 (plot crum)
 (data crum (1 2 0) (3 4 4) (5 4 -2) (8 2 -3))
 (plot crum)
 (data crum (1 2 0 4) (3 4 4 4) (5 4 -2 5) (8 2 -3 6))
 (plot crum)
"
  #|
	I don't like doing things this way: I have to setq a global variable
before I can make this work out right. Definitely not ideal, but all it means
is that I've got an extra copy of stuff floating around.
	I hope that the name andy-is-a-hippo-lover is sufficiently queer that
no one else would accidentally use it by mistake!
|#
  (setq andy-is-a-hippo-lover stuff)
  `(def ,name andy-is-a-hippo-lover)
  )
