(message "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             2-d function stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        You can plot 2-d functions, which are also defined with \"func\":

        (func ff(x y) cos x + sin y)
")
        (func ff(x y) cos x + sin y)

(message "
        Okay, I've taken care of defining it, using the func command: now to
plot it. Note the use of these plotting functions, like (title \"...\") and
(spin-domain -pi pi -pi pi) (which sets the part of the xy-plane of interest):

        (new-plot)
        (spin-points 20)
        (spin-axes nil)
        (title \"f(x y) = cos x + sin y\")
        (spin-domain -pi pi -pi pi)
        (plot ff)
")
        (new-plot)
        (spin-points 20)
        (spin-axes nil)
        (title "f(x y) = cos x + sin y")
        (spin-domain -pi pi -pi pi)
        (plot ff)

(message "")
(message "
        Diffplot also plots a 2-d function and its partial derivatives:

        (title \"cos x + sin y and derivatives\")
        (diffplot ff)

kind of a confusing plot, sometimes, but it might be useful sometime...
")
        (title "cos x + sin y and derivatives")
        (diffplot ff)

(message "")
(message "
        Diffplot also allows you to have a look at the tangent plane to a
function: here it is at (1,1).

        (spin-points 10)
        (title \"cos x + sin y and tangent plane\")
        (diffplot ff -pi/2 pi/2 -pi/2 pi/2 1 1)

(Note that it is the addition of the last two values that indicates to
diffplot that you want the tangent plane.)
")
        (spin-points 10)
        (title "cos x + sin y and tangent plane")
        (diffplot ff -pi/2 pi/2 -pi/2 pi/2 1 1)

(message "")
(message "

        Or, just plot any old bunch of 2-d functions together.

        (title \"Flying Sheets\")
        (func ff3 (x y) (12 + cos x + sin y))
        (func ff2 (x y) (6 + cos x + sin y))
        (plot ff ff2 ff3)
")
        (title "Flying Sheets")
        (func ff3 (x y) (12 + cos x + sin y))
        (func ff2 (x y) (6 + cos x + sin y))
        (plot ff ff2 ff3)

(message "
                                Contour Plots

        If you're into contour plots, you might try the contour function.
Here's the contour plot of a plane (which isn't really too exciting!):

        (new-plot)
        (title \"Contour plots can be nice\")
        (func f(x y) x + y)
        (spin-domain -pi pi -pi pi)
        (contour-points 30)
        (contour-levels 10)
        (contour f)
")
        (new-plot)
        (title "Contour plots can be nice")
        (func f(x y) x + y)
        (spin-domain -pi pi -pi pi)
        (contour-points 30)
        (contour-levels 10)
        (contour f)

(message "")
(message "

        While here's a little more complicated (and pretty) an animal:

        (func g(x y) sin x + cos y)
        (spin-points 20)
        (contour-levels 30)
        (contour g)
")
        (func g(x y) sin x + cos y)
        (spin-points 20)
        (contour-levels 30)
        (contour g)

(message "Back to you, top-level!")
