(message "                                Section  10.1.1")
;;

(message "
(def precipitation
     (list .77 1.74 .81 1.20 1.95 1.20 .47 1.43 3.37 2.20
           3.00 3.09 1.51 2.10 .52 1.62 1.31 .32 .59 .81
           2.81 1.87 1.18 1.35 4.75 2.48 .96 1.89 .90 2.05))
(let ((ranks (rank precipitation)))
  (setf nq (normal-quant (/ (+ ranks 1) 31))))
")
(printall
(def precipitation
     (list .77 1.74 .81 1.20 1.95 1.20 .47 1.43 3.37 2.20
           3.00 3.09 1.51 2.10 .52 1.62 1.31 .32 .59 .81
           2.81 1.87 1.18 1.35 4.75 2.48 .96 1.89 .90 2.05))
(let ((ranks (rank precipitation)))
  (setf nq (normal-quant (/ (+ ranks 1) 31))))
)

(message "
(defun bc (x p)
  (let* (
         (bcx (if (< (abs p) .0001) (log x) (/ (^ x p) p)))
         (min (min bcx))
         (max (max bcx))
         )
    (/ (- bcx min) (- max min))
    ))
(setf w (plot-points nq (bc precipitation 1)))
")
(printall
(defun bc (x p)
  (let* (
         (bcx (if (< (abs p) .0001) (log x) (/ (^ x p) p)))
         (min (min bcx))
         (max (max bcx))
         )
    (/ (- bcx min) (- max min))
    ))
(setf w (plot-points nq (bc precipitation 1)))
)

(message "
(setf indices (iseq 30))
(defun change-power (p)
  (send w :point-coordinate 1 indices (bc precipitation p))
  (send w :redraw-content))
(setf slider
      (interval-slider-dialog '(-1 2) :action #'change-power))
(send slider :value 1)
(send w :add-subordinate slider)
(setf powers (rseq -1 2 31))
")
(printall
(setf indices (iseq 30))
(defun change-power (p)
  (send w :point-coordinate 1 indices (bc precipitation p))
  (send w :redraw-content))
(setf slider
      (interval-slider-dialog '(-1 2) :action #'change-power))
(send slider :value 1)
(send w :add-subordinate slider)
(setf powers (rseq -1 2 31))
)

(message "
(setf data (mapcar #'(lambda (p) (bc precipitation p)) powers))
(flet ((change (x)
               (send w :point-coordinate 1 indices x)
               (send w :redraw-content)))
      (sequence-slider-dialog data
                              :display powers
                              :action #'change))
")
(printall
(def data (mapcar #'(lambda (p) (bc precipitation p)) powers))
(flet ((change (x)
               (send w :point-coordinate 1 indices x)
               (send w :redraw-content)))
      (sequence-slider-dialog data
                              :display powers
                              :action #'change))
)

(message "                                Section  10.1.2")
(message "
(def air '(80 80 75 62 62 62 62 62 58 58 58 58 58 58 50 50 50 50 50 56 70))
(def temp '(27 27 25 24 22 23 24 24 23 18 18 17 18 19 18 18 19 19 20 20 20))
(def conc '(89 88 90 87 87 87 93 93 87 80 89 88 82 93 89 86 72 79 80 82 91))
(def loss '(42 37 37 28 18 18 19 20 15 14 14 13 11 12  8  7  8  8  9 15 15))
(defun standardize (x)
  (let ((x-bar (mean x))
        (s (standard-deviation x)))
    (/ (- x x-bar) s)))
")
(printall
(def air '(80 80 75 62 62 62 62 62 58 58 58 58 58 58 50 50 50 50 50 56 70))
(def temp '(27 27 25 24 22 23 24 24 23 18 18 17 18 19 18 18 19 19 20 20 20))
(def conc '(89 88 90 87 87 87 93 93 87 80 89 88 82 93 89 86 72 79 80 82 91))
(def loss '(42 37 37 28 18 18 19 20 15 14 14 13 11 12  8  7  8  8  9 15 15))
(defun standardize (x)
  (let ((x-bar (mean x))
        (s (standard-deviation x)))
    (/ (- x x-bar) s)))
)

(message "
(setf std-air (standardize air))
(setf std-temp (standardize temp))
(setf std-conc (standardize conc))
(setf std-loss (standardize loss))
")
(printall
(setf std-air (standardize air))
(setf std-temp (standardize temp))
(setf std-conc (standardize conc))
(setf std-loss (standardize loss))
)

(message "
(setf w (plot-points std-air std-temp))
(send w :range '(0 1) -3 3)
(setf indices (iseq (length std-air)))
(defun interpolate (p)
  (let*  ((alpha (* (/ pi 2) p))
          (s (sin alpha))
          (c (cos alpha))
          (x (+ (* c std-air) (* s std-temp)))
          (y (+ (* c std-conc) (* s std-loss))))
    (send w :point-coordinate 0 indices x)
    (send w :point-coordinate 1 indices y)
    (send w :redraw-content)))
")
(printall
(setf w (plot-points std-air std-temp))
(send w :range '(0 1) -3 3)
(setf indices (iseq (length std-air)))
(defun interpolate (p)
  (let*  ((alpha (* (/ pi 2) p))
          (s (sin alpha))
          (c (cos alpha))
          (x (+ (* c std-air) (* s std-temp)))
          (y (+ (* c std-conc) (* s std-loss))))
    (send w :point-coordinate 0 indices x)
    (send w :point-coordinate 1 indices y)
    (send w :redraw-content)))
)

(message "
(dolist (p (rseq 0 1 30)) (interpolate p))
(interval-slider-dialog '(0 1) :action #'interpolate)
(setf w (plot-points (list std-air std-conc std-loss std-temp)
                     :scale-type 'fixed))
")
(printall
(dolist (p (rseq 0 1 30)) (interpolate p))
(interval-slider-dialog '(0 1) :action #'interpolate)
(setf w (plot-points (list std-air std-conc std-loss std-temp)
                     :scale-type 'fixed))
)

(message "
(defun interpolate (p)
  (let*  ((alpha (* (/ pi 2) p))
          (s (sin alpha))
          (c (cos alpha))
          (m (make-array '(4 4) :initial-element 0)))
    (setf (aref m 0 0) c)
    (setf (aref m 0 2) s)
    (setf (aref m 1 1) c)
    (setf (aref m 1 3) s)
    (send w :transformation m)))
")
(printall
(defun interpolate (p)
  (let*  ((alpha (* (/ pi 2) p))
          (s (sin alpha))
          (c (cos alpha))
          (m (make-array '(4 4) :initial-element 0)))
    (setf (aref m 0 0) c)
    (setf (aref m 0 2) s)
    (setf (aref m 1 1) c)
    (setf (aref m 1 3) s)
    (send w :transformation m)))
)

;;
(message "                                Section  10.1.3")
;;
(message "
(min precipitation)
(max precipitation)
(setf w (plot-lines (kernel-dens precipitation :width 1)))
")
(printall
(min precipitation)
(max precipitation)
(setf w (plot-lines (kernel-dens precipitation :width 1)))
)

(message "
(send w :add-slot 'kernel-width 1)
(send w :add-slot 'kernel-type 'b)
(defmeth w :kernel-width (&optional width)
  (when width
        (setf (slot-value 'kernel-width) width)
        (send self :set-lines))
  (slot-value 'kernel-width))
(defmeth w :kernel-type (&optional type)
  (when type
        (setf (slot-value 'kernel-type) type)
        (send self :set-lines))
  (slot-value 'kernel-type))
(defmeth w :set-lines ()
  (let ((width (send self :kernel-width))
        (type (send self :kernel-type)))
    (send self :clear-lines :draw nil)
    (send self :add-lines
          (kernel-dens precipitation
                       :width width :type type))))
")
(printall
(send w :add-slot 'kernel-width 1)
(send w :add-slot 'kernel-type 'b)
(defmeth w :kernel-width (&optional width)
  (when width
        (setf (slot-value 'kernel-width) width)
        (send self :set-lines))
  (slot-value 'kernel-width))
(defmeth w :kernel-type (&optional type)
  (when type
        (setf (slot-value 'kernel-type) type)
        (send self :set-lines))
  (slot-value 'kernel-type))
(defmeth w :set-lines ()
  (let ((width (send self :kernel-width))
        (type (send self :kernel-type)))
    (send self :clear-lines :draw nil)
    (send self :add-lines
          (kernel-dens precipitation
                       :width width :type type))))
)

(message "
(interval-slider-dialog '(.25 1.5)
                        :action
                        #'(lambda (s)
                            (send w :kernel-width s)))
(defmeth w :choose-kernel ()
  (let* ((types '(\"Bisquare\" \"Gaussian\" \"Triangle\" \"Uniform\"))
         (i (choose-item-dialog \"Kernel Type\" types)))
    (if i (send w :kernel-type (select '(b g t u) i)))))
(setf kernel-item
      (send menu-item-proto :new \"Kernel Type\"
            :action #'(lambda () (send w :choose-kernel))))
(send (send w :menu) :append-items kernel-item)
")
(printall
(interval-slider-dialog '(.25 1.5)
                        :action
                        #'(lambda (s)
                            (send w :kernel-width s)))
(defmeth w :choose-kernel ()
  (let* ((types '("Bisquare" "Gaussian" "Triangle" "Uniform"))
         (i (choose-item-dialog "Kernel Type" types)))
    (if i (send w :kernel-type (select '(b g t u) i)))))
(setf kernel-item
      (send menu-item-proto :new "Kernel Type"
            :action #'(lambda () (send w :choose-kernel))))
(send (send w :menu) :append-items kernel-item)
)

(message "
That's all for 10.1!
")
