;; ========
(message "                                Section  3.6.1")
;; ========

(message "
(lambda (x) (+ (* 2 x) (^ x 2)))

((lambda (x) (+ (* 2 x) (^ x 2))) 1)

(plot-function #'(lambda (x) (+ (* 2 x) (^ x 2))) -2 3)
")
(lambda (x) (+ (* 2 x) (^ x 2)))
((lambda (x) (+ (* 2 x) (^ x 2))) 1)
(plot-function #'(lambda (x) (+ (* 2 x) (^ x 2))) -2 3)

;; ========
(message "                                Section  3.6.2")
;; ========

(message "
(defun integral (a b h)
  (do (
       (integral 0 (+ integral (* h (f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(defun f (x) (^ x 2))

(integral 0 1 .01)
")
(defun integral (a b h)
  (do (
       (integral 0 (+ integral (* h (f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(defun f (x) (^ x 2))

(integral 0 1 .01)

(message "
(defun integral (f a b h)
  (do (
       (integral 0 (+ integral (* h (f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(integral #'(lambda (x) (^ x 2)) 0 1 .01)

(funcall #'(lambda (x) (^ x 2)) 2)

(funcall #'+ 1 2)
")
(defun integral (f a b h)
  (do (
       (integral 0 (+ integral (* h (f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(integral #'(lambda (x) (^ x 2)) 0 1 .01)

(funcall #'(lambda (x) (^ x 2)) 2)

(funcall #'+ 1 2)

(message "
(defun integral (f a b h)
  (do (
       (integral 0 (+ integral (* h (funcall f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(apply #'+ (list 1 2))

(apply #'+ (list 1 2 3))

(apply #'+ 1 2 (list 3 4 5))

(defun my-sum (x) (apply #'+ x))

(my-sum (normal-rand 1000))
")
(defun integral (f a b h)
  (do (
       (integral 0 (+ integral (* h (funcall f x))))
       (x (+ a (/ h 2)) (+ x h))
       )
      ((> x b) integral)
      )
  )

(apply #'+ (list 1 2))

(apply #'+ (list 1 2 3))

(apply #'+ 1 2 (list 3 4 5))

(defun my-sum (x) (apply #'+ x))

(my-sum (normal-rand 1000))

;; ========
(message "                                Section  3.6.3")
;; ========

(message "
(defun make-projection (x)
  (flet (
	 (ip (x y) (sum (* x y)))
	 )
	#'(lambda (y) (* x (/ (ip x y) (ip x x))))
	))

(def p (make-projection '(1 1 1 1)))

p

(funcall p '(1 2 3 4))

(funcall p '(-1 1 1 -1))
")
(defun make-projection (x)
  (flet (
	 (ip (x y) (sum (* x y)))
	 )
	#'(lambda (y) (* x (/ (ip x y) (ip x x))))
	))

(def p (make-projection '(1 1 1 1)))

p

(funcall p '(1 2 3 4))

(funcall p '(-1 1 1 -1))

(message "
(defun make-projection (x)
  (labels (
	   (ip (x y) (sum (* x y)))
	   (proj (y) (* x (/ (ip x y) (ip x x))))
	   )
	  #'proj))

(defun make-norm-log-lik (x)
  (let (
	(n (length x))
	(x-bar (mean x))
	(s-2 (^ (standard-deviation x) 2))
	)
    #'(lambda (mu sigma-2)
	(- (* 0.5
	      n
	      (+ (log sigma-2)
		 (/ (^ (- x-bar mu) 2) sigma-2)
		 (/ s-2 sigma-2)))))
    ))
")
(defun make-projection (x)
  (labels (
	   (ip (x y) (sum (* x y)))
	   (proj (y) (* x (/ (ip x y) (ip x x))))
	   )
	  #'proj))

(defun make-norm-log-lik (x)
  (let (
	(n (length x))
	(x-bar (mean x))
	(s-2 (^ (standard-deviation x) 2))
	)
    #'(lambda (mu sigma-2)
	(- (* 0.5
	      n
	      (+ (log sigma-2)
		 (/ (^ (- x-bar mu) 2) sigma-2)
		 (/ s-2 sigma-2)))))
    ))

(message "
(defun make-composition (f g)
  #'(lambda (x) (funcall f (funcall g x)))
  )

(def ident (make-composition #'log #'exp))

(funcall ident 3.7)
")
(defun make-composition (f g)
  #'(lambda (x) (funcall f (funcall g x)))
  )

(def ident (make-composition #'log #'exp))

(funcall ident 3.7)

;; ========
(message "                                Section  3.6.4")
;; ========

(message "
(def expr '(+ 2 3))

(first expr)

(second expr)

(rest expr)

(eval expr)

(def x 3)

(let ((x 5)) (eval 'x))

(def expr2 '(+ x 3))
")
(def expr '(+ 2 3))

(first expr)

(second expr)

(rest expr)

(eval expr)

(def x 3)

(let ((x 5)) (eval 'x))

(def expr2 '(+ x 3))



(message "
(eval (subst 2 'x expr2))

(subst 2 'x '(let ((x 3)) x))

(list 'let '((x 2)) expr2)

(eval (list 'let '((x 2)) expr2))

`(let ((x 2)) ,expr2)

(eval `(let ((x 2)) ,expr2))

`(let ((x , (- 3 1))) ,expr)

")
(eval (subst 2 'x expr2))
(subst 2 'x '(let ((x 3)) x))
(list 'let '((x 2)) expr2)
(eval (list 'let '((x 2)) expr2))
`(let ((x 2)) ,expr2)
(eval `(let ((x 2)) ,expr2))
`(let ((x , (- 3 1))) ,expr)




(message "
(defun plot-expr (expr var low high)
  (flet (
	 (f (X) (eval `(let ((,var ,x)) ,expr)))
	 )
	(plot-function #'f low high)
	))

(plot-expr '(+ (* 2 x) (^ x 2)) 'x -2 3)
")
(defun plot-expr (expr var low high)
  (flet (
	 (f (X) (eval `(let ((,var ,x)) ,expr)))
	 )
	(plot-function #'f low high)
	))

(plot-expr '(+ (* 2 x) (^ x 2)) 'x -2 3)
