;; =================
(message "
                 Section  6.1: Some motivation

")
;; =================

(message "
	We could create functions to describe a family of data sets: for
example, we could create

(defun describe-data (data)
  (cond
   ((single-sample-p data) ...)
   ((multiple-sample-p data) ...)
   ((paired-sample-p data) ...)
   (t (error \"Don't know how to describe this data set yet.\"))))

if we knew that we had only three data set types (single, multiple, and
paired).
")

(message "
	But if we now introduce a time-series type, we are obligated to go back
over old ground, modifying describe data and any other function which doesn't
yet know about the existance of time-series.

	The alternative is to arrange for the data sets themselves to know how
to describe themselves, and to simply ask them to describe themselves. Thus we
will make a simple call to the :describe method of a data set, for
example. This is called MESSAGE-PASSING.

	This way, we don't risk breaking the code for existing data sets when
modifying a function to take a new type into account.
")

(message "
	Furthermore, we introduce the idea of inheritance: we can define a new
object in terms of an old one, adding additional methods as necessary,
changing inherited ones too, if necessary.

	These ideas will be illustrated in the examples that follow.

")