;; =================
(message "

             Section  6.4.1: Creating Objects and Prototypes

")
;; =================

(message "
(setf x (make-object))

(send x :make-prototype 'data-set-proto '(data title))
")
(setf x (make-object))
(send x :make-prototype 'data-set-proto '(data title))

;; =================
(message "

              Section  6.4.2: Additional Methods and Functions

")
;; =================

(message "
(send time-series-proto :precedence-list)

(send time-series-proto :parents)

(kind-of-p time-series-proto data-set-proto)

(kind-of-p data-set-proto time-series-proto)

(send x :reparent time-series-proto)
")
(send time-series-proto :precedence-list)
(send time-series-proto :parents)
(kind-of-p time-series-proto data-set-proto)
(kind-of-p data-set-proto time-series-proto)
(send x :reparent time-series-proto)



;; =================
(message "

                 Section  6.4.3: Shared Slots

") 
;; =================

(message "

(defproto myproto () '(instances))

(defmeth myproto :new (&rest args)
  (let ((object (apply #'call-next-method args)))
    (setf (slot-value 'instances)
	  (cons object (slot-value 'instances)))
    object))

(defmeth myproto :dispose (object)
  (setf (slot-value 'instances)
	(remove object (slot-value 'instances))))

")

(defproto myproto () '(instances))

(defmeth myproto :new (&rest args)
  (let ((object (apply #'call-next-method args)))
    (setf (slot-value 'instances)
	  (cons object (slot-value 'instances)))
    object))

(defmeth myproto :dispose (object)
  (setf (slot-value 'instances)
	(remove object (slot-value 'instances))))

;; =================
(message "

                 Section  6.4.4: The Object Documentation System

") 
;; =================

(message "
(send data-set-proto :documentation :title)

(send data-set-proto :documentation 
      :title \"sets or returns the title\")

(send data-set-proto :help :title)

(send data-set-proto :doc-topics)

(send data-set-proto :help)

(send data-set-proto :documentation
      'proto \"A generic data set.\")

(send data-set-proto :help)
")
(send data-set-proto :documentation :title)
(send data-set-proto :documentation 
      :title "sets or returns the title")
(send data-set-proto :help :title)
(send data-set-proto :doc-topics)
(send data-set-proto :help)
(send data-set-proto :documentation
      'proto "A generic data set.")
(send data-set-proto :help)

;; =================
(message "

                    Section  6.4.5: Saving Objects

") 
;; =================

(message "
(defmeth data-set-proto :save ()
  `(send data-set-proto :new
	 ',(send self :data)
	 :title ',(send self :title)))
(send x :save)
")
(defmeth data-set-proto :save ()
  `(send data-set-proto :new
	 ',(send self :data)
	 :title ',(send self :title)))
(send x :save)

