;; =================
(message "

               Section  6.5.1: Compound Data Objects

") 
;; =================

(message "
(defproto point-proto '(x y) '() compound-data-proto)

(defmeth point-proto :x (&optional (x nil set))
  (if set (setf (slot-value 'x) x))
  (slot-value 'x))

(defmeth point-proto :y (&optional (y nil set))
  (if set (setf (slot-value 'y) y))
  (slot-value 'y))

(defmeth point-proto :isnew (x y)
  (send self :x x)
  (send self :y y))

(defmeth point-proto :data-length () 2)
")
(defproto point-proto '(x y) '() compound-data-proto)

(defmeth point-proto :x (&optional (x nil set))
  (if set (setf (slot-value 'x) x))
  (slot-value 'x))

(defmeth point-proto :y (&optional (y nil set))
  (if set (setf (slot-value 'y) y))
  (slot-value 'y))

(defmeth point-proto :isnew (x y)
  (send self :x x)
  (send self :y y))

(defmeth point-proto :data-length () 2)

(message "
(defmeth point-proto :data-seq ()
  (list (send self :x) (send self :y)))

(defmeth point-proto :make-data (seq)
  (send point-proto :new (select seq 0) (select seq 1)))

(defmeth point-proto :print (&optional (stream t))
  (format stream
	  \"#<a point located at x = ~d and y = ~d>\"
	  (send self :x)
	  (send self :y)))

(setf a (send point-proto :new 3 5))
(+ a a)
(* a 2)
(log a)
")
(defmeth point-proto :data-seq ()
  (list (send self :x) (send self :y)))
(defmeth point-proto :make-data (seq)
  (send point-proto :new (select seq 0) (select seq 1)))
(defmeth point-proto :print (&optional (stream t))
  (format stream
	  "#<a point located at x = ~d and y = ~d>"
	  (send self :x)
	  (send self :y)))
(setf a (send point-proto :new 3 5))
(+ a a)
(* a 2)
(log a)

;; =================
(message "

	Section  6.5.2: Linear Regression Models

") 
;; =================

#|
(defproto regression-model-proto
  '(x y intercept weights included
      predictor-names response-name case-labels
      sweep-matrix basis
      total-sum-of-squares
      residual-sum-of-squares))

This must not be the standard regression-model-proto - or if it is, we don't
want to redefine it here, as it will mess up future regression-models.
|#

;; =================
(message "

	Section  6.5.3: Nonlinear Regression Models

") 
;; =================

(message "
(defproto nreg-model-proto
  '(mean-function theta-hat epsilon count-limit verbose)
  nil
  regression-model-proto)
")
(defproto nreg-model-proto
  '(mean-function theta-hat epsilon count-limit verbose)
  nil
  regression-model-proto)

