;; =================
(message "

	Section  6.8.1: A Rectangular Data Set

") 
;; =================

(message "
(defproto rect-data-proto '(vlabels clabels) () data-set-proto)

(defmeth rect-data-proto :isnew
  (data &key title variable-labels case-labels)
  (let ((n (length (first data)))
	(m (length data)))
    (send self :data data)
    (if title (send self :title title))
    (send self :variable-labels
	  (if variable-labels
	      variable-labels
	    (mapcar #'(lambda (x) (format nil \"X~a\" x))
		    (iseq 0 (- m 1)))))
    (send self :case-labels
	  (if case-labels
	      case-labels
	    (mapcar #'(lambda (x) (format nil \"~a\" x))
		    (iseq 0 (- n 1)))))))
")
(defproto rect-data-proto '(vlabels clabels) () data-set-proto)

(defmeth rect-data-proto :isnew
  (data &key title variable-labels case-labels)
  (let ((n (length (first data)))
	(m (length data)))
    (send self :data data)
    (if title (send self :title title))
    (send self :variable-labels
	  (if variable-labels
	      variable-labels
	    (mapcar #'(lambda (x) (format nil "X~a" x))
		    (iseq 0 (- m 1)))))
    (send self :case-labels
	  (if case-labels
	      case-labels
	    (mapcar #'(lambda (x) (format nil "~a" x))
		    (iseq 0 (- n 1)))))))




(message "
(defmeth rect-data-proto :variable-labels
  (&optional (labels nil set))
  (if set (setf (slot-value 'vlabels) labels))
  (slot-value 'vlabels))

(defmeth rect-data-proto :case-labels
  (&optional (labels nil set))
  (if set (setf (slot-value 'clabels) labels))
  (slot-value 'clabels))

(send rect-data-proto :title \"a rectangular data set\")

(setf stack
      (send rect-data-proto :new (list air temp conc loss)
	    :variable-labels
	    (list \"Air\" \"Temp\" \"Conc\" \"Loss\")))

(defmeth rect-data-proto :plot ()
  (let ((vars (send self :data))
	(labels (send self :variable-labels)))
    (case (length vars)
	  (1 (histogram vars :variable-labels labels))
	  (2 (plot-points vars :variable-labels labels))
	  (3 (spin-plot vars :variable-labels labels))
	  (t (scatterplot-matrix vars :variable-labels labels)))))

(send stack :describe)

(send stack :plot)
")
(defmeth rect-data-proto :variable-labels
  (&optional (labels nil set))
  (if set (setf (slot-value 'vlabels) labels))
  (slot-value 'vlabels))
(defmeth rect-data-proto :case-labels
  (&optional (labels nil set))
  (if set (setf (slot-value 'clabels) labels))
  (slot-value 'clabels))
(send rect-data-proto :title "a rectangular data set")
(setf stack
      (send rect-data-proto :new (list air temp conc loss)
	    :variable-labels
	    (list "Air" "Temp" "Conc" "Loss")))
(defmeth rect-data-proto :plot ()
  (let ((vars (send self :data))
	(labels (send self :variable-labels)))
    (case (length vars)
	  (1 (histogram vars :variable-labels labels))
	  (2 (plot-points vars :variable-labels labels))
	  (3 (spin-plot vars :variable-labels labels))
	  (t (scatterplot-matrix vars :variable-labels labels)))))
(send stack :describe)
(send stack :plot)




;; =================
(message "

	Section  6.8.2: An Alternate Data Representation

") 
;; =================

(message "
(defproto observation-proto '(label))

(defmeth observation-proto :isnew (&rest args)
  (setf (slot-value 'label) (string (gensym \"OBS-\")))
  (apply #'call-next-method args))

(defmeth observation-proto :label () (slot-value 'label))

(defproto stack-obs-proto
  '(air temp conc loss) () observation-proto)

")
(defproto observation-proto '(label))

(defmeth observation-proto :isnew (&rest args)
  (setf (slot-value 'label) (string (gensym "OBS-")))
  (apply #'call-next-method args))

(defmeth observation-proto :label () (slot-value 'label))

(defproto stack-obs-proto
  '(air temp conc loss) () observation-proto)




(message "
(defmeth stack-obs-proto :air () (slot-value 'air))

(defmeth stack-obs-proto :temp () (slot-value 'temp))

(defmeth stack-obs-proto :conc () (slot-value 'conc))

(defmeth stack-obs-proto :loss () (slot-value 'loss))

(defmeth stack-obs-proto :log-loss () (log (send self :loss)))

(defproto data-set-proto '(data))
")
(defmeth stack-obs-proto :air () (slot-value 'air))

(defmeth stack-obs-proto :temp () (slot-value 'temp))

(defmeth stack-obs-proto :conc () (slot-value 'conc))

(defmeth stack-obs-proto :loss () (slot-value 'loss))

(defmeth stack-obs-proto :log-loss () (log (send self :loss)))

(defproto data-set-proto '(data))




(message "
(defmeth data-set-proto :values (var)
  (mapcar #'(lambda (x) (send x var))
	  (slot-value 'data)))

(defmeth data-set-proto :plot (&rest args)
  (let ((vals (mapcar #'(lambda (var) (send self :values var))
		      args))
	(labels (send self :values :label))
	(vlabs (mapcar #'string args)))
    (case (length args)
	  (0 (error \"too few arguments\"))
	  (1 (histogram vals 
			:point-labels labels
			:variable-labels vlabs))
	  (2 (plot-points vals
			  :point-labels labels
			  :variable-labels vlans))
	  (3 (spin-plot vals
			:point-labels labels
			:variable-labels vlabs))
	  (t (scatterplot-matrix vals 
				 :point-labels labels
				 :variable-labels vlabs)))))
")
(defmeth data-set-proto :values (var)
  (mapcar #'(lambda (x) (send x var))
	  (slot-value 'data)))

(defmeth data-set-proto :plot (&rest args)
  (let ((vals (mapcar #'(lambda (var) (send self :values var))
		      args))
	(labels (send self :values :label))
	(vlabs (mapcar #'string args)))
    (case (length args)
	  (0 (error "too few arguments"))
	  (1 (histogram vals 
			:point-labels labels
			:variable-labels vlabs))
	  (2 (plot-points vals
			  :point-labels labels
			  :variable-labels vlans))
	  (3 (spin-plot vals
			:point-labels labels
			:variable-labels vlabs))
	  (t (scatterplot-matrix vals 
				 :point-labels labels
				 :variable-labels vlabs)))))




(message "
(defmeth data-set-proto :describe (var)
  (let ((vals (send self :values var)))
    (format t \"Variable Name: ~a~%\" var)
    (format t \"Mean: ~g~%\" (mean vals))
    (format t \"Median: ~g~%\" (median vals))
    (format t \"Standard Deviation: ~g~%\" (standard-deviation vals))))

(setf stack-list
      (mapcar 
       #'(lambda (air temp conc loss label)
	   (send stack-obs-proto :new
		 :air air
		 :temp temp
		 :conc conc
		 :loss loss
		 :label (format nil \"~d\" label)))
       air temp conc loss (Iseq 0 20)))

(setf stack-loss (send data-set-proto :new :data stack-list))

(send stack-loss :describe :loss)

(send stack-loss :describe :log-loss)

(send stack-loss :plot :log-loss :air :temp)
")
(defmeth data-set-proto :describe (var)
  (let ((vals (send self :values var)))
    (format t "Variable Name: ~a~%" var)
    (format t "Mean: ~g~%" (mean vals))
    (format t "Median: ~g~%" (median vals))
    (format t "Standard Deviation: ~g~%" (standard-deviation vals))))
(setf stack-list
      (mapcar 
       #'(lambda (air temp conc loss label)
	   (send stack-obs-proto :new
		 :air air
		 :temp temp
		 :conc conc
		 :loss loss
		 :label (format nil "~d" label)))
       air temp conc loss (Iseq 0 20)))
(setf stack-loss (send data-set-proto :new :data stack-list))
(send stack-loss :describe :loss)
(send stack-loss :describe :log-loss)
(send stack-loss :plot :log-loss :air :temp)
