;; ==================
(message "                                Section 8.4.1")
;; ==================

(message "
(setf w (send graph-window-proto :new))
(send w :add-slot 'x (/ (send w :canvas-width) 2 ))
(send w :add-slot 'y (/ (send w :canvas-height) 2 ))
(defmeth w :x (&optional (val nil set))
  (if set (setf (slot-value 'x) val))
  (slot-value 'x))
(defmeth w :y (&optional (val nil set))
  (if set (setf (slot-value 'y) val))
  (slot-value 'y))
(defmeth w :resize ()
  (send self :x (/ (send w :canvas-width) 2 ))
  (send self :y (/ (send w :canvas-height) 2 )))
(defmeth w :redraw ()
  (let ((x (round (send self :x)))
        (y (round (send self :y))))
    (send self :erase-window)
    (send self :draw-symbol 'disk t x y)))
")
(setf w (send graph-window-proto :new))
(send w :add-slot 'x (/ (send w :canvas-width) 2 ))
(send w :add-slot 'y (/ (send w :canvas-height) 2 ))
(defmeth w :x (&optional (val nil set))
  (if set (setf (slot-value 'x) val))
  (slot-value 'x))
(defmeth w :y (&optional (val nil set))
  (if set (setf (slot-value 'y) val))
  (slot-value 'y))
(defmeth w :resize ()
  (send self :x (/ (send w :canvas-width) 2 ))
  (send self :y (/ (send w :canvas-height) 2 )))
(defmeth w :redraw ()
  (let ((x (round (send self :x)))
        (y (round (send self :y))))
    (send self :erase-window)
    (send self :draw-symbol 'disk t x y)))

;; ==================
(message "                                Section 8.4.2")
;; ==================
(message "
(defmeth w :do-motion (x y)
  (send self :x x)
  (send self :y y)
  (send self :redraw))
")
(defmeth w :do-motion (x y)
  (send self :x x)
  (send self :y y)
  (send self :redraw))

(message "")
(message "
(send w :delete-method :do-motion)
(defmeth w :do-click (x y m1 m2)
  (send self :x x)
  (send self :y y)
  (send self :redraw))
")
(send w :delete-method :do-motion)
(defmeth w :do-click (x y m1 m2)
  (send self :x x)
  (send self :y y)
  (send self :redraw))

(message "")
(message "
(defmeth w :do-click (x y m1 m2)
  (flet ((set-symbol (x y)
                     (send self :x x)
                     (send self :y y)
                     (send self :redraw)))
	(set-symbol x y)
	(send self :while-button-down #'set-symbol)))
")
(defmeth w :do-click (x y m1 m2)
  (flet ((set-symbol (x y)
                     (send self :x x)
                     (send self :y y)
                     (send self :redraw)))
	(set-symbol x y)
	(send self :while-button-down #'set-symbol)))

(message "")
(message "
(defmeth w :do-click (x y m1 m2)
  (flet ((set-symbol (x y)
                     (send self :x x)
                     (send self :y y)
                     (send self :redraw)))
	(set-symbol x y)
	(send self :while-button-down #'set-symbol nil)))
")
(defmeth w :do-click (x y m1 m2)
  (flet ((set-symbol (x y)
                     (send self :x x)
                     (send self :y y)
                     (send self :redraw)))
	(set-symbol x y)
	(send self :while-button-down #'set-symbol nil)))

(message "")
(message "
(defmeth w :do-click (x y m1 m2)
  (let ((xy (send self :drag-grey-rect x y 5 5)))
    (send self :x (+ 3 (first xy)))
    (send self :y (+ 3 (second xy)))
    (send self :redraw)))
")
(defmeth w :do-click (x y m1 m2)
  (let ((xy (send self :drag-grey-rect x y 5 5)))
    (send self :x (+ 3 (first xy)))
    (send self :y (+ 3 (second xy)))
    (send self :redraw)))

(message "")
(message "
(defmeth w :do-click (x y m1 m2)
  (let ((xy (send self :drag-grey-rect x y 5 5 3 3)))
    (send self :x (+ 3 (first xy)))
    (send self :y (+ 3 (second xy)))
    (send self :redraw)))
")
(defmeth w :do-click (x y m1 m2)
  (let ((xy (send self :drag-grey-rect x y 5 5 3 3)))
    (send self :x (+ 3 (first xy)))
    (send self :y (+ 3 (second xy)))
    (send self :redraw)))

(message "")
(message "
(defmeth w :do-click (x y m1 m2)
  (let ((cursor (send self :cursor)))
    (send self :cursor 'finger)
    (let ((xy (send self :drag-grey-rect x y 5 5)))
      (send self :x (+ 3 (first xy)))
      (send self :y (+ 3 (second xy)))
      (send self :redraw))
    (send self :cursor cursor)))
")
(defmeth w :do-click (x y m1 m2)
  (let ((cursor (send self :cursor)))
    (send self :cursor 'finger)
    (let ((xy (send self :drag-grey-rect x y 5 5)))
      (send self :x (+ 3 (first xy)))
      (send self :y (+ 3 (second xy)))
      (send self :redraw))
    (send self :cursor cursor)))

(message "")
(message "
(cursor-symbols)
")
(print (cursor-symbols))

;; ==================
(message "                                Section 8.4.3")
;; ==================

(message "
(send w :add-slot 'step-size 10)
(defmeth w :step-size (&optional (val nil set))
  (if set (setf (slot-value 'step-size) val))
  (slot-value 'step-size))
(defmeth w :move (x y)
  (send self :x (+ x (send self :x)))
  (send self :y (+ y (send self :y)))
  (send self :redraw))
(defmeth w :do-key (c m1 m2)
  (let ((step (send self :step-size)))
    (case c
          (#\i (send self :move 0 (- step)))
          (#\k (send self :move 0 step))
          (#\l (send self :move step 0))
          (#\j (send self :move (- step) 0)))))
")
(send w :add-slot 'step-size 10)
(defmeth w :step-size (&optional (val nil set))
  (if set (setf (slot-value 'step-size) val))
  (slot-value 'step-size))
(defmeth w :move (x y)
  (send self :x (+ x (send self :x)))
  (send self :y (+ y (send self :y)))
  (send self :redraw))
(defmeth w :do-key (c m1 m2)
  (let ((step (send self :step-size)))
    (case c
          (#\i (send self :move 0 (- step)))
          (#\k (send self :move 0 step))
          (#\l (send self :move step 0))
          (#\j (send self :move (- step) 0)))))

;; ==================
(message "                                Section 8.4.4")
;; ==================

(message "
(defmeth w :do-idle ()
  (let ((step (send self :step-size)))
    (case (random 4)
          (0 (send self :move 0 (- step)))
          (1 (send self :move 0 step))
          (2 (send self :move step 0))
          (3 (send self :move (- step) 0)))))
(send w :idle-on t)
")
(defmeth w :do-idle ()
  (let ((step (send self :step-size)))
    (case (random 4)
          (0 (send self :move 0 (- step)))
          (1 (send self :move 0 step))
          (2 (send self :move step 0))
          (3 (send self :move (- step) 0)))))
(send w :idle-on t)

(message "
(send w :idle-on nil)
")
(send w :idle-on nil)

;; ==================
(message "                                Section 8.4.5")
;; ==================

(message "
(defmeth w :restart ()
  (send self :x (/ (send self :canvas-width) 2))
  (send self :y (/ (send self :canvas-height) 2))
  (send self :redraw))
(setf restart-item
      (send menu-item-proto :new \"Restart\"
            :action #'(lambda () (send w :restart))))
(setf run-item
      (send menu-item-proto :new \"Run\"
            :action
            #'(lambda ()
                (send w :idle-on (not (send w :idle-on))))))
(defmeth run-item :update ()
  (send self :mark (send w :idle-on)))
")
(defmeth w :restart ()
  (send self :x (/ (send self :canvas-width) 2))
  (send self :y (/ (send self :canvas-height) 2))
  (send self :redraw))
(setf restart-item
      (send menu-item-proto :new "Restart"
            :action #'(lambda () (send w :restart))))
(setf run-item
      (send menu-item-proto :new "Run"
            :action
            #'(lambda ()
                (send w :idle-on (not (send w :idle-on))))))
(defmeth run-item :update ()
  (send self :mark (send w :idle-on)))


(message "")
(message "
(setf menu (send menu-proto :new \"Random Walk\"))
(send menu :append-items restart-item run-item)
(send w :menu menu)
(defmeth w :do-click (x y m1 m2)
  (send (send self :menu) :popup x y self))
")
(setf menu (send menu-proto :new "Random Walk"))
(send menu :append-items restart-item run-item)
(send w :menu menu)
(defmeth w :do-click (x y m1 m2)
  (send (send self :menu) :popup x y self))

(message "That's all for 8.4, folks!")

