(message "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             Discrete data sets:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        You may want to plot some data. You can define the data using the
\"data\" command: 

        (data page3 (1 3) (2 4) (3 5) (4 3) (5 7) (6 5))

        (title \"Data from Page 3\")
        (plot page3) ; (Note that plot will profess confusion, but does the
                     ; right thing.)
")
        (data page3 (1 3) (2 4) (3 5) (4 3) (5 7) (6 5))

        (title "Data from Page 3")
        (plot page3) ; (Note that plot will profess confusion, but does the
                     ; right thing.)

(message "")
(message "

        Now suppose you want to pull off the x and y values from the ordered
pair information you gave: use the \"def\" (for define) command, and the x's
and y's commands xs and ys:

        (def page3.x (xs page3))
        (def page3.y (ys page3))
        (plot page3.x page3.y)
")
        (def page3.x (xs page3))
        (def page3.y (ys page3))
        (plot page3.x page3.y)

(message "")
(message "
        You may wonder why you couldn't use the def command for the page3 data
itself: def takes the next thing and assigns it to the name, but only one
thing, while data takes the whole bunch and assigns it to the name.

One may often want to construct a grid of data: grid takes as it's arguments
the endpoints, followed by the number of steps desired from left endpoint to
right endpoint:

        (title \"One-dimensional gridded data\")
        (grid -5 5 20)
        (def gdata (grid -5 5 20))

This will generate a grid of points from -5 to 5, with steps of .5,
{-5, -4.5, ... , 4.5, 5}, and call it \"gdata\". Now we can put those values
into f (f is a cubic defined below), calling that \"fdata\", and, when we plot
it, it should look sort of like our initial plot:

        (func f(x) x ^ 3 - 2 * x + 3) ; f(x)=x^3-2*x+3
        (def fdata (f gdata))
        (plot gdata fdata)
")
        (title "One-dimensional gridded data")
        (grid -5 5 20)
        (def gdata (grid -5 5 20))
        (func f(x) x ^ 3 - 2 * x + 3) ; f(x)=x^3-2*x+3
        (def fdata (f gdata))
        (plot gdata fdata)

(message "")
(message "
        If you have a table of data that you want to enter, then you might
consider the \"table\" command:

        This is the beef data from page 3 of the Harvard Consortium's
Multivariate Calculus text: beef consumption as a function of salary and price.
(Note that the table command defines beef as a 5x4 table of values, given in the
following lines.)

        (data prices 3 3.5 4 4.5) ; these were the prices (in $1)
        (data salaries 20 40 60 80 100) ; these were the salaries (in $1000)
        (table beef 5 4
        2.65 2.59 2.51 2.43
        4.14 4.05 3.94 3.88
        5.11 5.00 4.97 4.84
        5.35 5.29 5.19 5.07
        5.79 5.77 5.60 5.53
        )
        (new-plot)
        (title \"Beef consumption(salary,price)\")
        (plot beef)
")
        (data prices 3 3.5 4 4.5)
        (data salaries 20 40 60 80 100)
        (table beef 5 4
        2.65 2.59 2.51 2.43
        4.14 4.05 3.94 3.88
        5.11 5.00 4.97 4.84
        5.35 5.29 5.19 5.07
        5.79 5.77 5.60 5.53
        )
        (new-plot)
        (title "Beef consumption(salary,price)")
        (plot beef)

(message "Back to you, Bob.")
