(message "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         cool parametric stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	Wherein we show you how to cook up parametric plots, in two and three
dimensions.

	Let's start with two:

        (new-plot)
	(func f(x) cos x)
	(func g(x) sin x)
	(lines on)
	(parametric f g 0 2pi 100)
")
        (new-plot)
	(func f(x) cos x)
 	(func g(x) sin x)
	(lines on)
        (parametric f g 0 2pi 100)
(message "")

(message "
	Here's a three-d example: we add a third function, to give us a spiral:

	(func h(x) x)
	(parametric f g h 0 4pi 200)
")
	(func h(x) x)
        (parametric f g h 0 4pi 200)
(message "")

(message "
        We can create a parametric path from point A to B to C:

 (def a1  4) (def a2 5)
 (def b1  1) (def b2 2)
 (def c1 -1) (def c2 8)
 (func f(x) (heaviside ((x - 0) * (1 - x))) * ((x - 0) * b1 + (1 - x) * a1)
          + (heaviside ((x - 1) * (2 - x))) * ((x - 1) * c1 + (2 - x) * b1))
 (func g(x) (heaviside ((x - 0) * (1 - x))) * ((x - 0) * b2 + (1 - x) * a2)
          + (heaviside ((x - 1) * (2 - x))) * ((x - 1) * c2 + (2 - x) * b2))
 (parametric f g 0 2 200) ;; plots (f(x),g(x)) as x goes from 0 to 2pi in
")
 (def a1  4) (def a2 5)
 (def b1  1) (def b2 2)
 (def c1 -1) (def c2 8)
 (func f(x) (heaviside ((x - 0) * (1 - x))) * ((x - 0) * b1 + (1 - x) * a1)
          + (heaviside ((x - 1) * (2 - x))) * ((x - 1) * c1 + (2 - x) * b1))
 (func g(x) (heaviside ((x - 0) * (1 - x))) * ((x - 0) * b2 + (1 - x) * a2)
          + (heaviside ((x - 1) * (2 - x))) * ((x - 1) * c2 + (2 - x) * b2))
 (send (parametric f g 0 2 200)
       :add-points (list a1 b1 c1) (list a2 b2 c2))
(message "")

(message "
        We can do the same with 'if' functions, rather than with the heaviside
function:

 (func f(x) (if (x < 1) ((x - 0) * b1 + (1 - x) * a1)
                        ((x - 1) * c1 + (2 - x) * b1)))
 (func g(x) (if (x < 1) ((x - 0) * b2 + (1 - x) * a2)
                        ((x - 1) * c2 + (2 - x) * b2)))
 (parametric f g 0 2 200) ;; plots (f(x),g(x)) as x goes from 0 to 2pi in
")
 (func f(x) (if (x < 1) ((x - 0) * b1 + (1 - x) * a1)
                        ((x - 1) * c1 + (2 - x) * b1)))
 (func g(x) (if (x < 1) ((x - 0) * b2 + (1 - x) * a2)
                        ((x - 1) * c2 + (2 - x) * b2)))
 (send (parametric f g 0 2 200)
       :add-points (list a1 b1 c1) (list a2 b2 c2))

(message "")

(message "
        Here's a parameterization of half of a paraboloid, using the polar
command: note that we only get half a paraboloid, as we've restricted the theta
angle to [0,pi]:

        (title \"Paraboloid!\")
        (func f (r th) r ^ 2)
        (polar f :thmax pi)

We'll follow that up with a cone:

        (title \"Want ice cream with that?\")
        (func f (r th) r)
        (polar f)

and a strange fan:

        (title \"I'm your fan\")
        (func f (r th) cos th)
        (polar f)
")
        (new-plot)
        (title "Paraboloid!")
        (func f (r th) r ^ 2)
        (polar f :thmax pi)
        (title "Want ice cream with that?")
        (func f (r th) r)
        (polar f)
        (title "I'm your fan.")
        (func f (r th) cos th)
        (polar f)

(message "Back to you, top-level.")





