;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Learn Statistics with Andy!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(message "
	I'm reading Herbert Friedman's book Introduction to Statistics, and
want to look (with the computer) at a few things as I do so.

	He starts with Hypothesis testing, and examples of binomials. What does
xlispstat have for me in that department?

(about bino)
BINOMIALREG-MODEL
RAND.BINOMIAL
BINOMIAL-RAND
BINOMIAL-CDF
BINOMIAL-QUANT
BINOMIAL-PMF

BINOMIAL-RAND                                                     [function-doc]
Args: (k n p)
Returns list of K draws from the Binomial(N, P) distribution. Vectorized.

BINOMIAL-CDF                                                      [function-doc]
Args (x n p)
Returns value of the Binomial(N, P) distribution function at X. Vectorized.

BINOMIAL-QUANT                                                    [function-doc]
Args: (x n p)
Returns x-th quantile (left continuous inverse) of Binomial(N, P) cdf.
Vectorized.

BINOMIAL-PMF                                                      [function-doc]
Args (k n p)
Returns value of the Binomial(N, P) pmf function at integer K. Vectorized.

(defun f(x) (binomial-cdf x 50 .5))
(plot f 0 50)
(defun f(x) (binomial-quant x 50 .5))
(plot f 0.0001 (calc 1 - .0001))

")
(defun f(x) (binomial-cdf x 50 .5))
(plot f 0 50)
(defun f(x) (binomial-quant x 50 .5))
(plot f 0.0001 (calc 1 - .0001))

(message "
	Here is a list of draws from a binomial distribution. This represents
40 trials in which we draw 50 from a bin where p=.3:

 (plot (binomial-rand 40 50 .3))

")
 (plot (binomial-rand 40 50 .3))
(message "
	Here are the probabilities all possible draws from a binomial
distribution. This represents the case where we draw 50 from a bin where p=.3:

 (plot (binomial-pmf (iseq 50) 50 .3))
")
 (plot (binomial-pmf (iseq 50) 50 .3))
(message "
	According to our author we can approximate this by the normal
distribution of the variable

			(def p .3)
			(def n 50)
			(def q (- 1 p))
			(func z(x) ((abs (x - n * p)) - .5)/(sqrt (n * p * q)))
			(plot z 0 50)

			(plot (normal-dens (z (iseq 0 50))))
 			(plot (binomial-pmf (iseq 50) 50 .3))
")
			(def p .3)
			(def n 50)
			(def q (- 1 p))
			(func z(x) ((abs (x - n * p)) - .5)/(sqrt (n * p * q)))
			(plot z 0 50)

			(plot (normal-dens (z (iseq 0 50))))
 			(plot (binomial-pmf (iseq 50) 50 .3))

(message "
	Chisquares: pointed out a serious problem! If there is a function
defined as chisq-dens, for example, then

		(func f(x y) (chisq-dens x y))

causes serious problems: it is re-written as 

		(LAMBDA (X Y) ((+ CHISQ (- DENS)) X Y))

so I use

		(defun f(x y) (chisq-dens x y))

instead.
 		(spin-points 20)
		(spin-domain 0.1 5 0.1 5)
		(plot f)
")
 		(spin-points 20)
		(spin-domain 0.1 5 0.1 5)
		(plot f)
		(defun f(x y) (chisq-dens x y))



(message "
	According to our author we can approximate this by the normal
distribution of the variable

			(def n 50)
			(func z(x) sqrt(2*(rand.chisq x n)) - sqrt(2*n-1))
			(plot z 0 50)

			(plot (normal-dens (z (iseq 0 50))))
 			(plot (chisq-dens (iseq 100) 50))
")
			(def n 50)
			(func z(x) sqrt(2*(rand.chisq x n)) - sqrt(2*n-1))
			(plot z 0 50)

			(plot (normal-dens (z (iseq 0 50))))
 			(plot (chisq-dens (iseq 100) 50))

