#|
	Where am I: I've just finished doing some testing of the B/F stuff.
|#
#|

				f77-2-xl

	This is work on the f2cl stuff of the New Zealand folks, in an attempt
to turn it into something useful for xlispstat. I've managed to extend their
efforts in a number of ways, as well as to doctor up some things to make their
common lisp into something amenable to xlispstat.

	I've tried to reduce the number of my own functions which I've
included, although I found it necessary to add several utilities which I find
tremendously useful, including grep-replace and parser, as well as some
backward compatible features of xlispstat like strcat.

	Fortran 77 is our standard, although where it is easy to add
non-standard topics which I myself use (e.g. include) I have added them. The
Kiwis took f77 as theirs - the following abstract is from their latex
documentation (f2cldoc.latex), found in the f2cl/doc directory. I'm
simultaneously doctoring up that documentation, as the work progresses.

	I tried gamely to contact the New Zealanders, without success. I also
tried years ago and failed. They've surely gone on to bigger and better
things. I hope that they won't mind my trying to keep the ball rolling....

				Andy Long
				Institute de Mathematiques et
					  de Sciences Physiques
				Porto-Novo, Benin, West Africa
				December, 1997
 					-
				February, 1998

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		Fortran to Lisp Translation using f2cl

K.A. Broughan and D.M.K. Willcock

	University of Waikato, Hamilton, New Zealand

	The need for both algebraic and numerical capabilities within single
mathematical computation systems has highlighted the need to translate
numerical software written in Fortran77 to Common Lisp, a language favoured by
the algebraic computation community.

This paper reports the current state of f2cl, a translator written to
achieve that end.  We describe the translation process giving details of Lisp
equivalents of Fortran expressions, as well as discussing those peculiarities
of Fortran that have no straightforward equivalent in Lisp.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Andy's Preamble:

	The overwelming caveat, in my mind, is that diligence and vigilance are
essential: there are lots of potential problems with the conversion (see
restrictions below), some of which we can anticipate (and warn about), and
others which are unknown to us. I've carried out tests using the fortran code
of Numerical Recipes, hoping that they exercised fortran over a broad swath,
but they surely ignored certain structures (e.g. file I/O, the entry statement)
and may not have really pressed many others.


----------------------------------------------------------------------

			PROBLEMS/RESTRICTIONS:

13) There is now difference between pre-3.52 and 3.52 versions of
xlispstat. I've added a variable (pre-3.52) to change one or two definitions as
necessary. Pain in the arse! The reason is that I'd created a kludgy
replacement for a common lisp function, which now exists properly
(read-preserving-whitespace). My kludgy fix doesn't work in 3.52.

12)

(set-working-directory "/home/ael/tmp/numanal")
(let () (f2cl "simplex.f" "f2clout.lsp") (load "f2clout") (D10R12))
	Trying to get this working, I discovered two problems:
1)
c ael - caused nasty problem:      character txt(nm1m2)*2,alpha(np)*2
      character txt*2,alpha*2
      dimension txt(nm1m2),alpha(np)
c lea

which didn't work either: we had to get this explicit:

      character*2 alpha
      character*2 txt
      dimension alpha(np)
      dimension txt(nm1m2)



3) I removed an "extraneous" () in a write statement:

            write(*,'(1x,a3,(5f10.2))') alpha(1),
became
            write(*,'(1x,a3,5f10.2)') alpha(1),

and this worked, although badly (printing a list where a bunch of numbers was
more appropriate).

c-ael            write(*,'(1x,a3,(5f10.2))') alpha(1),
c-ael            write(*,'(1x,a3,5f10.2)') alpha(1),
            write(*,'(1x,a3,(f10.2))') alpha(1),

As noted below, removing the number in front of the parentheses works wonders!
This suggests a strategy for solution....


	Once all these problems were fixed, the code worked right.

----------------------------------------------------------------------

11) one code had a .gt . in it, rather than .gt. - this compiled and worked in
fortran (f2c took care of that?), but not in lisp

----------------------------------------------------------------------

10) This back to our format problems: from alg043.for, in the ~/tmp/dos_fortran
directory:

2     FORMAT(1X,(6(3X,E15.8)))

gets translated (with my crude fix) as:

        (FFORMAT I/O 6
         (QUOTE
          ("~1@T"
           ;; ael("~{~6{~3@T~15,8,2,0,,'*E~}~}")
	   ("~a")
           ;; lea
            "~%")
          )

It works (a little) if I lose one of the parentheses in the fortran format:
2     FORMAT(1X,6(3X,E15.8))

        (FFORMAT I/O 6
         (QUOTE
          ("~1@T"
           ("~6{~3@T~15,8,2,0,,'*E~}")
            "~%")
          )
and if I remove the 6 from the fortran statement, it works properly even:
        (FFORMAT I/O 6
         (QUOTE
          ("~1@T"
           ("~{~3@T~15,8,2,0,,'*E~}")
            "~%")
          )

Wrote out some examples that work in the fformat1 command. I'll have to take
care of this someday, but not today! Just have to rethink the whole format
business. If I use a pair of ~{~{, then lisp assumes I have lists of lists to
format, while fortran may not assume that at all.

	Here's an old problem, from alg046: we lost a final 'i3 because of that
missing comma:

3     FORMAT(1X,'obtained with M = ',I3,', N = ',I3,' and P = 'I3)

      (FFORMAT I/O 6
       (QUOTE
        ("~1@T" "obtained with M = "
         ("~3D")
          ", N = "
         ("~3D")
          " and P = " "~%")
        )

       (LIST M N P)
       )

	Here's one that works: from sfroid,

100   FORMAT(1X,I4,2F12.6,(/5X,I5,F12.6))

      (FFORMAT I/O T
       (QUOTE
        ("~1@T"
         ("~4D")

         ("~12,6,0,,F")

         ("~12,6,0,,F")

         ("~{~%~5@T~5D~12,6,0,,F~}")
          "~%")
        )

----------------------------------------------------------------------

9) This back to our type problems: from alg042.for, in the ~/tmp/dos_fortran
directory:

                    L(I) = V(8) + 1

Gets translated as

          (FSET
           (FREF L I)

           (+
            (FREF V 8)
             1)
           )

which I fixed up as

          (FSET
           (FREF L I)

           (int (+
            (FREF V 8)
             1))
           )

But L is of type fixnum, and when it gets assigned a float, all hell breaks
loose (well, actually, we get the error

Error: bad argument type - 2.0
Happened in: #<Subr-%SET-AREF: #810b3e8>), which is short of all hell....

----------------------------------------------------------------------

8) An array reference inside a function call doesn't get translated into an
fref (example from rk.f, in the ~/tmp/numrec file).

       (BESSJ 3
               (Xp I)
rather than
       (BESSJ 3
               (fref Xp I)

in the translation of

         write(*,'(1x,f10.4,2x,2f14.6)') xp(i),yp(4,i),bessj(3,xp(i))

----------------------------------------------------------------------

7)	A related problem occurs if different names are given to the same
item in a common statement. for example, in the runge-kutta stuff of the
numerical recipes program, the driver they give (d15r4) uses

      common /path/ kmax,kount,dxsav,x(200),y(10,200)

while the actual routine (odeint) uses

      common /path/ kmax,kount,dxsav,xp(200),yp(10,200)

This led to an error: variable undefined.

	Currently I'm throwing away the name of the common block (i.e. path): I
guess that the way to handle this is to actually define a variable path, and
let it be a list containing the variables. Then I can assign the variables
where they are to the elements of path, i.e.

	(setq kmax (aref path 0))

	I've got a start on this: I've defined variable common-names to hold
the common names and the variable list. I just don't have the courage to get
started on it....

----------------------------------------------------------------------

6) If you create a lisp program from a fortran code, and then try running it,
you may have trouble with the readtable upon abort. In particular, the
*readtable* may not permit you to read parentheses correctly (a serious problem
in lisp!).

	This problem can be resolved by simply exitting xlispstat, then coming
back in, loading in f2cl, and then running.

----------------------------------------------------------------------

5) Some fortrans require that one "open the console", e.g. the Burden and
Faires Dos fortran files:

      OPEN(UNIT=5,FILE='CON',ACCESS='SEQUENTIAL')
      OPEN(UNIT=6,FILE='CON',ACCESS='SEQUENTIAL')

I just comment these out: 6, if not openned, is assumed to be standard out, and
if a read to an unopened unit occurs, read assumes standard in. Thus these are
automagically covered.

----------------------------------------------------------------------

4) Equivalence, block data, entry, and other features are completely
ignored. Some are considered bad form, others are little used/known, and others
are too tough to handle!

----------------------------------------------------------------------

3) READ statements are currently incompletely supported. In particular,
formatted reading is non-existent.

	I've taken care of the simple cases by adding a parse-read command:

	Read *, a, b
	Read (*,*) a, b

and later added these:

	Read (5,*) a, b
	Read (2+3,*) a, b, v(1)

Now I can read something like

	Read (2+3,*) (v(i), i=1,4)

as I added parse-implicit-do-loop; this could also be extended to write
statements, but I haven't done it yet. For the moment if an array is
encountered, it's simply printed.

----------------------------------------------------------------------

2) SAVE stmts restricted
     SAVE a,b,...
 or  SAVE /label/a,b,..
 (haven't tested this at all to see how it works!)

----------------------------------------------------------------------

1) DATA stmts

           DATA nlist/clist/,nlist2/clist2/,...

restricted to one vble name per nlist, unless all variables are scalar and
there are exactly as many values as variables: e.g.

      data a,b,c/1,2,3/

no implied do's; in clist either an alist or a repetition (not a combination of
both).

	There is a good reason for such a restriction: if not, then you can
define an array, e.g. a(2), and write

      data a,b/1,2,3/

which requires that we figure out array dimensions as well, yuck!

	Data statements with names and indices will also fail, e.g.

	DATA NTOP,A(1)/0,1./

	I added a "fix" for repeated data values, i.e. 4*1.0 to indicate 4
1.0s. Added the function id-data.

	I've also added a new fix for the data statement

	DATA NTOP,A/0,1/,B/3/

I added the routine parse-data-helper. I think that these should work now, but
watch out for new problems from new fixes!

----------------------------------------------------------------------

0) Trailing comments (at the end of the file) are currently lost.

----------------------------------------------------------------------
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

			Are these standard?

^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

400   CLOSE(UNIT=5) ;; when unit 5 hasn't been opened!

       IF(OUP.NE.6) CLOSE(UNIT=6) ;; same deal

^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

			BUG/non-standard FIXES:

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

27)	a matrix A, initialized in a data statement, is created in the
opposite sense from lisp (that is, columns first, then rows). I added this
right after the (setq A ....) in the program:

	Appeared in
(set-working-directory "/home/ael/tmp/numanal")
(let () (f2cl "simplex.f" "f2clout.lsp") (load "f2clout") (D10R12))

	Added a line to parse-data1 which took care of this particular
problem.
	    ;;ael - Sun Feb 8 14:38:27 1998

26) Problems in alg054.for of the ~/tmp/dos_fortran directory:

           CALL RK4(H,TT(I),W(I),TT(I+1),W(I+1))

Translated as

        (MULTIPLE-VALUE-SETQ
         (H *DUMMY_VAR* *DUMMY_VAR* *DUMMY_VAR* *DUMMY_VAR*)

         (RK4 H
          (FREF TT I)

          (FREF W I)

          (FREF TT
           (+ I 1)
           )

          (FREF W
           (+ I 1)
           )
          )
         )

which didn't work. I manhandled that as follows, creating numbered dummy
variables, and using them to set to actual named values after:

        (MULTIPLE-VALUE-SETQ
	 (H *DUMMY_VAR1* *DUMMY_VAR2* *DUMMY_VAR3* *DUMMY_VAR4*)

         (RK4 H
          (FREF TT I)

          (FREF W I)

          (FREF TT
           (+ I 1)
           )

          (FREF W
           (+ I 1)
           )
          )
         )

	(setf (fref tt i) *DUMMY_VAR1*
	      (FREF W I) *DUMMY_VAR2*
	      (FREF TT (+ I 1)) *DUMMY_VAR3*
	      (FREF W (+ I 1)) *DUMMY_VAR4*
	      )

Solution: Manhandled parse-subroutine-call in the appropriate way, and hope
that that will take care of the problem. Used gensym to generate some new
symbols, that I could identify with the array elements and ....

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

25) Problems in alg054.for of the ~/tmp/dos_fortran directory. T was used as an
array, and in most places it underwent a transformation to become T_, but in
many cases (of fset and fref) it wasn't transformed, e.g.

      T(1) = A

was translated by

      (FSET
       (FREF T 1)
        A)

Solution: I've added checks in the two places where 'fref
(parse-arrayref-or-stmtfn and id-factor) is used; we'll see what breaks as a
consequence! I found a self-inflicted bug as a consequence, in
insert-declarations. I'd done something "just for fun"...

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

24) fixed a further data problem: negative values in the data
values caused a punt. See parse-data.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

23) remove-if evidently doesn't work the same in common-lisp as xlispstat. In
xlispstat, it requires an explicit t/nil to remove, whereas it was just being
handed a non-null value.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

22) PROBLEM: "doesn't recognize elseif as implying else if!"

   ;;ael - fixed this so it recognizes both else if and elseif. See also
   ;;changes to id-elseif.
   (if (id-elseif x)
       (return
	(if (eq (first x) 'elseif)
	    `((elseif_place_holder ,(id-logical (cadr (check_new_vbles x)))))
	  `((elseif_place_holder ,(id-logical (caddr (check_new_vbles x)))))
	  )
	)
     )
   ;;lea
;;ael
;;(defun id-elseif (x) (and (eq (car x) 'else) (cadr x) (eq (cadr x) 'if)))
(defun id-elseif (x)
  (or
   (and (eq (car x) 'else) (cadr x) (eq (cadr x) 'if))
   (eq (car x) 'elseif)
   )
  )
;;lea

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

21) PROBLEM: "I don't want to string-downcase whole lines sometime, e.g.

      AA = 'y'
09    IF(( AA .EQ. 'Y' ) .OR. ( AA .EQ. 'y' )) THEN

        (or
         (equalp aa "y")
         (equalp aa "y")
         )

	I need to preserve strings in files exactly as they are: this is
especially important for filenames, as in the case of include.

	I also need to do all my preprocessing just leaving strings alone! I'm
currently up-casing and down-casing them, which will cause UNIX problems."

Took care of the upcase/downcase story: everything except comments that
starts as a string keeps its case, as it should be. This has meant some
modifications: for example, equal-> equalp in replace-str (as it assumed
capital letters by default).

	trial3.f is a test of importance of case in include statements.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

20) PROBLEM: "Need to add

	(setf a (float (read nil)))

etc., when it's a matter of a float variable.

	Especially, I guess, in the case of read statements. In fact, I think
that, at least as a first pass, I could just add the type to any
reads. Currently I'm doing a

	(setq a (rread i/o t)),

whereas I should be checking the type of the variable, and issuing the
appropriate command, i.e.,

	(setq a (float (rread i/o t)))"

	This entailed another problem: I can't input pi and have it understood
as a number (it's understood as a symbol).

	Did this and went a step further. I changed parse-read so that the
arguments are split using list-split (rather than simply removing commas), and
simultaneously started parsing through parse assignment. This has the advantage
of allowing me to handle

      read *, v(1), l

Furthermore, I can now handle

      read *, (v(i), i=1,10)

etc. Except for formatting, we're almost there. Added an "eval" to rread1, as
otherwise giving values like pi caused errors because they were treated as
symbols.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

19) PROBLEMS: (from numanal/dalg051.f) Is this standard?

       WRITE(OUP,*) 'EULER''S METHOD'

Evidently yes: I find in (the otherwise useless) "Structuring Fortran 77 for
Business and General Applications", by Harice L. Seeds, that this is indeed the
proper way to indicate an apostrophe. I'm going to represent it by a pair of
apostrophes, for the moment.... I altered adjust_nrs to watch for this, and to
just go ahead and write them if it sees two in a row. This could obviously
cause problems for a line like

       WRITE(OUP,*) ''

there'd better be a space in there!

       WRITE(OUP,*) ' '

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

18) PROBLEMS: "write(*,fmt) isn't working as it should.", and "figure out how
the formating is working, and fix it up! It's often pretty bad, and sometimes
just wrong."

	SOLUTION: Wasted a Sunday on it, and think that I've finally got it
pretty well hammered down. f2cl wasn't parsing fmt in the first case (so I
added some to get_format_stmt), and what can I say about the second problem?
It's not finished, of course, but I've got a start on the ~4{ stuff (but it's
not perfect).

	In particular, the current strategy (as implemented in fformat) in
dealing with ~n{ is to see if there are at least n objects listed as arguments,
and to eat n if so; otherwise, to take all that one can. This can obviously
break down.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

17) PROBLEM: "Have a goto problem in

(set-working-directory "/home/ael/tmp/numanal")
(f2cl-file "crap.f")
"y" .0 2.0 10 1 1

Error: The variable LABEL400 is unbound.
Happened in: #<FSubr-PROG: #80eb7c8>

	The problem is that
(prog ()
      (labels ()
	      (print 'hi)
	      (if (= 2 2) (go loop))
	      (print 'lo)
	      )
      loop
      )
works, but we've bumped into a case where instead we have
(prog ()
      (labels ()
	      label400
	      (print 'hi)
	      (if (= 2 2) (go label400))
	      (print 'lo)
	      )
      )
Error: The variable LABEL400 is unbound.

doesn't work. The loop would work within the prog, but the labels statement
doesn't permit go targets (evidently).

(prog ()
      (labels ()
	      (tagbody
	       label400
	       (print 'hi)
	       (if (= 2 2) (go label400))
	       (print 'lo)
	       )
	      )
      )

works. Looks to me like we just need to change a labels command to include a
tagbody at the top. That's what I've done. We risk to  consequently break the
program that follows:

(prog ()
      (labels ()
	      (tagbody
	       label400
	       (print 'hi)
	       (if (= 1 2) (go label400))
	       (print 'lo)
	       )
	      )
      (go label400)
      )

fortunately for us, this shouldn't happen, as make-labels-form is only called
(i.e. we only establish a labels form) if we encounter stmt functions, which
should only occur at the top of a file. We'll see!

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

16) PROBLEM: include not supported

	SOLUTION: Inline include code; involves adding a parse-include, and
adding an option to f2cl to give the output stream, rather than a filename.
Include is evidently non-standard, but I use it so much that I found it worth
supporting.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

15) PROBLEM: "no file i/o!"

	SOLUTION: Did a lot of what seemed like fruitless work on this, then
suddenly had success at around midnight; that success wasn't generalizable,
however, so I took a different route.

1) array of 100 "units" (of which 1 to 99 are generally used in fortran)

	This was the key: defining the array i/o, then passing it to the i/o
commands to be used. It has permitted easy flexibility. I can check, for
example, when I open a file as unknown, to see if a program is trying to write
to it. If so, then the status can be changed.

2) unwind-protect, to avoid a file-bleed (i.e. "too many open files" errors) by
   closing files at the end of the program

	This may prove to be very wasteful/inefficient, however, so that I
might want to check for i/o commands - if there are none, then skip it.

	I also check to see if a file was defined as scratch, and if so, delete
it (although I haven't yet had the courage to actually delete files - for the
moment I'm just writing their names to output, so one sees what would have
happened!

3) in general replacing all i/o functions (format, read, open, and close) by
   macros calling functions.

4) replacing (setf out (open ....)) statements with a macro (oopen ....) (in
   other words, avoid the definition of file streams, which is very lispy.

5) provided some contingency for cases of computed units: e.g.

	write(3+2,fmt) n

6) provided for various status values: files can be opened with status new,
   old, unknown, or scratch. In the case of unknown, it's not certain what a
   programmer had in mind (although it's probably safe to guess output,
   although not to assume it! Thus I've assumed input, unless I find the code
   trying to write to the file, in which case we reopen as output.


	One key trick was to avoid calling format from within macro fformat,
and instead work entirely with the function fformat1, replacing format with
fformat1, and having fformat1 inspect the destination unit.

	This idea was followed in each of the other i/o domains (read, open,
and close).

	Both read and write are starting to be supported, although write is way
ahead of read. In particular, formatted reading is currently not implemented.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

14) PROBLEM: "If a function NAME is declared as external, then passed to a
subroutine, it is passed as its NAME (rather than as (function NAME)). I've
``fixed'' that, but don't know what will break as a consequence.

	Furthermore, if a function is passed to a subroutine (say, f(x)), it
is currently called as (f x), rather than (funcall f x) as it should be. In
other words, a subroutine may fail to use an 'external f' statement as in the
above example, and so we have a new problem.

	The code should recognize f(x) as a function, and use the appropriate
(funcall f x) if f came in as a subroutine argument.

failure to use funcall for functions passed to subroutines (with different
names: i.e., bessj0 is passed as fx)."

  SOLUTION: think that I've gotten that squared away by looking for the
arguments to subroutines and functions in the lists of declared functions and
intrinsics. If found, then we leave it as is: otherwise, we add the funcall.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

13) need to assume a program, unless otherwise: added a subroutine-flag, and
now I initialize program-flag to t. This is because the tacking on of *main*
occurs too late to fix up the prog-list.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

12) fixed a problem in the parsing of .false. and .true. - statements like

	ok = .false.

were not being tranlated correctly: as (setf ok false) rather than
(setf ok nil). I added a couple of lines to the check-t-or-pi function to take
care of this.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

11) PROBLEM: "data statements:

(declare (type (simple-array single-float (*)) cof))
(replace cof (quote (76.18009173 (- 86.50532033)
 24.01409822 (- 1.231739516)
 0.00120858003 (- 5.36382E-6)))
 :end 5)

failed because some of the quoted expressions are lists, not fixnums."

	SOLUTION: I think that I've got that licked. See data restrictions
above.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

10) PROBLEM: "formats like ~{ aren't working right (try the sfroid file in
~/tmp/numrec (although I've since fixed it up: run f2cl on sfroid.f and see)."

	SOLUTION: Made a change in that section of the code, and I'll be on the
look-out for more crazy zaniness.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

9) PROBLEM: "Conversion to type isn't automatic: for example, converting
badluk caused me trouble, because they do a declaration, but then a setf,
making the type change from fixnum to float automatically."

 (declare (type fixnum n))
FIXNUM
	(setf n (* 12.37 (+ (+ iyyy (- 1900))
			    (f2cl/ (+ im (- 0.5))
				   12.0))))
FLOAT

	I HAD a feeling that we need to revisit these: Luke defined them
in the file common.lsp. See f2cltest for the hacks I was working on (although I
went a different route).

	SOLUTION: I've taken care of the problem by checking the type of a
variable getting set by setf: if it's a declared or implicit integer, and the
rhs is not (obviously) an integer, then I tack on a call to int.

	This leads, of course, to a bunch of spurious int calls; these should
be pruned out later, if desired - but at least the code should work!

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

8) fixed up the external statement a bit: if an external function is used as a
symbol (i.e. being passed to a subroutine) it is replaced by (function name)
(in function id-factor). What will this break?

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

7) PROBLEM: support for the print statement doesn't exist.

	SOLUTION: I replaced prints by write statements, introducing it in
translate-line.
	p. 109, Effective Fortran 77

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

6) PROBLEM: Comments: are only allowed within the bodies of functions,
subroutines, programs, etc. Any leading comments MUST BE REMOVED, and trailing
comments will be turned into the function *main* which does nothing!

	I added a leading comment stripper to fort-fun in function
translate-and-write-subprog; and trailers are now being detected with a check
on margin in readsubprog-extract-format-stmts.

	Trailing comments (at the end of the file) are currently lost.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

5) PROBLEM: stop doesn't get replaced by something (e.g. a return) in the
following: IF(C2.EQ.999.)STOP

	I added a check for this case in the if-testing stuff, parse-if.

I changed the function TRANSLATE-LINE to return (return (values)) upon stop. I
think that I'll now remove the changes made to if-testing, and parse-if, and
see how it goes.

	Seems to be working fine.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

4) PROBLEM: can't use d format for numbers, e.g.

	D format is supposed to work in xlispstat - I've sent a note to Luke
about it: for the moment, it gets replaced by E format....

      DATA COF/76.18009173D0,-86.50532033D0,24.01409822D0,-.536382D-5
The last one is especially pernicious:

> -.536382D-5
-0.536382

Yikes! This one is in double jeopardy, however, as the preprocessing of
add-spaces turns this into - .536382D - 5!

	Need to add a preprocessor to turn those into constants that
xlispstat can handle.

SOLUTION? In preprocessing replaced d format by e format.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

3) Fixed a parameter problem (used parser because some parameters are
determined on the fly):
	"2) have a parameter problem with julday: there's some computation
going on in the value."

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

2) I HAD continuation problems:

        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *       /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P

	Because they used the * for the continuation and I'm replacing it by
" * ", which moved it out of the line of fire. I've changed add-space to only
worry about everything past the first six characters.

	A second continuation problem I had was due to the fact that they read
lines as symbols, and appended continuation line lists to the previous line's
list. If a name got split on a line, then it was read as two symbols. I took
care of this by doing the continuation preprocessing in the preprocess step,
jamming lines together for file f2clprep.tmp.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

1)	had to replace body by (rest body) in

(defun make-labels-form (local-vbles vble-decls body) ....)

to make stmt_fn work right (for example stmtfntest.for). The first part of the
body actually contained the function definition.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

0) I replaced

	logeqv --> equalp
	logxor --> (not (equalp ....)

especially in function  id-relational. Numerical recipes stuff is using eqv to
compare logicals, and they are not compared using logeqv in xlispstat.

	Also replaced the name "prep.tmp" with "f2clprep.tmp", to avoid the
possibility of destroying someone's file "prep.tmp" (the latter seems far less
likely to be just lying around in someone's directory).

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
&									&
&				todo:					&
&									&
&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

10)
	Data statements with names and indices will also fail, e.g.

      DATA NTOP,A(1)/0,1./

	I added a "fix" for repeated data values, i.e. 4*1.0 to indicate 4
1.0s. Added the function id-data.

now I think that I can use parse-implicit-do-loop to take care of this. We'll
see...

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

9) I'm changed parse-read so that it will handle int/float definitions: now I
need to take care of character variables.

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

7) PROBLEM: "Two things: the " causes trouble, and the $ doesn't have the
desired effect:

      write(*,'(a,$)') 'Type "y" if you want to try again: '

	Another thing:

 040  write(*,*) 'Try again with the same function '//
     *'but another interval/tolerance?'

	Clearly this will be a trouble-maker, as things can get much worse: for
example,

 040  write(*,*) 'Try again with the same function '//fmt//'hi'

PARTIAL SOLUTION:
;; ael - to replace read-line in preprocess:
(defun read-nasty-line(inport)

	Here I do some pre-processing, to take out these variables. I'm not
saying that this is a solution - just a quick and dirty fix that might get some
things to work that wouldn't otherwise. I should now post-process in fformat,
or the like, and strcat any such lists of strings that I see: i.e.,

      print *, 'type "y" if you''re'//' happy and you know it!'

    (FFORMAT I/O T
     (QUOTE
      ("~A~%")
      )

     (LIST "type ''y'' if you''re" "//" " happy and you know it!")
     )

At that late stage, we might also take care of the problems of things like

      print *, 'type "y" if you''re'//fmt

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

3) ael: things have to passed through id-factor if we want to strip off the e%
that we introduced. The following

           IF(R.GT.1.0E-20) THEN
                DELTA=.84*(TOL/R)**.25
           ELSE
                DELTA=10.0
           END IF

in dalg053.f led to

	      (1.0e%20 0.0)

being identified as a local variable! The if statement got translated
properly...

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

2) I still have a problem in formatting of, e.g.
	(f2cl-file "f2cl/validation/subprogtest.for")

&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                        Back to LISP:
;;
;; These are some functions that I needed to set up for one reason or another.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun set-up-faux()
  "
 Don't need this anymore, except for when testing certain routines:
"
  (setq external_function_names nil
	undeclared_vbles nil
	declared_vbles nil

	;; ael - changed this from nil
	implicit_vble_decls '((fixnum (i n)) (single-float (a h) (o z)))
	subroutine-arg-list nil
	function-arg-list nil
	f2cl-open-files nil
	;; ael

	explicit_vble_decls nil
	save_vbles nil
	key_params nil
	subprog_common_vars nil
	common-names nil
	subprog_stmt_fns nil
	subprog_stmt_fns_bodies nil
	function-flag nil
	subroutine-flag nil
	program-flag t
	)

  (setq common_array_dims nil)
  (setq format_stmts nil)
  )

(defun report-current-status()
  (dolist
   (var '(external_function_names
	  undeclared_vbles
	  declared_vbles
	  implicit_vble_decls
	  explicit_vble_decls
	  save_vbles
	  key_params
	  subprog_common_vars
	  common-names nil
	  subprog_stmt_fns
	  subprog_stmt_fns_bodies
	  function-flag
	  subroutine-flag
	  program-flag
	  common_array_dims
	  format_stmts))
   (format t "~a: ~s" (symbol-name var) (eval var))
   ))

;; ael: the following unsets all my favorite shortcuts (like ?, !, etc.):
(old-readtable)
;; I'll set it back at the end!

;; These need to be set to be used by parse-format-descriptor-list, for
;; example, and pattern-match-and-bind:
(setq left nil right nil)
(setq SP nil)

#|
;; I have to create the function member-if-not, and I'm not really sure how to
;; do that! This from the cl info from /usr/info:

 - Function: member ITEM LIST
     This MacLisp-compatible function searches LIST for an element
     which is `equal' to ITEM.  The `member' function is built-in to
     Emacs 19; this package defines it equivalently in Emacs 18.  See
     the following function for a Common-Lisp compatible version.

 - Function: member* ITEM LIST &key :test :test-not :key
     This function searches LIST for an element matching ITEM.  If a
     match is found, it returns the cons cell whose `car' was the
     matching element.  Otherwise, it returns `nil'.  Elements are
     compared by `eql' by default; you can use the `:test',
     `:test-not', and `:key' arguments to modify this behavior.  *Note
     Sequences::.

     Note that this function's name is suffixed by `*' to avoid the
     incompatible `member' function defined in Emacs 19.  (That
     function uses `equal' for comparisons; it is equivalent to
     `(member* ITEM LIST :test 'equal)'.)

   The `member-if' and `member-if-not' functions analogously search for
elements which satisfy a given predicate.

	There is member-if function in xlispstat, so I'm tempted to just use it
with negation:

MEMBER-IF
[function-doc]
Args: (test list &key (key #'identity))
Returns the tail of LIST beginning with the first element satisfying TEST.

;; Examples:
 (member-if 'numberp (iseq 2))
 (member-if 'null (iseq 2))

	Here we go...! (Added it to utility2.lsp... appears to do the job.)
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 prettiprint
;;
(defun prettiprint
  (xx &key (n 0) (stream t) (step 1) case)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          prettiprint Doc:
;;
;; Author: Andy Long
;; Created: Tue Dec 9 08:42:11 1997
;;
;; Description/Arguments:

 (prettiprint
   xx &key (n 0) (stream t) (step 1) case)

	:case :downcase
		for lower case file

;; Returns: nil

;; Notes:

;; See Also:
;; Examples:
 (prettiprint (iseq 4))
 (prettiprint '(((1 2) 3) 4))
 (prettiprint '(1 (2 (3 (4 (5))))))
 (pprint '(1 (2 (3 (4 (5))))))

 (prettiprint '(((((1 2) \"hi\") 4 5 6) 'yep) 0))
 (pprint '(((((1 2) \"hi\") 4 5 6) 'yep) 0))
"
  (if (= n 0) (terpri stream))
  (if (and (listp xx) (not (null xx)))
      (let (
	    (bunches (apply #'strcat (repeat " " n)))
	    (n (+ step n))
	    )
	(format stream (strcat "~%" bunches "("))
	(dolist
	 (x (butlast xx))
	 (prettiprint x :n n :stream stream)
	 (format stream " " xx)
	 )
	(prettiprint (final xx) :n n :stream stream)
	(format stream (strcat ")~%" bunches))
	)
    (if (eq case :downcase)
	(format stream "~a"
		(grep-replace "~a" "~A" (string-downcase (format nil "~s" xx)))
		)
      (format stream "~s" xx)
      )
    )
  (if (= n 0) (terpri stream))
  (values)
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                postprocess
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun postprocess(infile &optional (outfile infile))
  "
Just to pretty up the file.
"
  (let ((lines (read-file infile)))
    (with-open-file
     (outport outfile :direction :output)
     (mapcar
      (lambda(line)
	(let ((newline (space-trim line)))
	  (if (not (string= "" newline))
	      (let ()
		(princ line outport)
		(terpri outport)
		)))
	)
      lines
      )
     )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 check-line-for-comment
;;
(defun check-line-for-comment(line)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          check-line-for-comment Doc:
;;
;; Author: Andy Long
;; Created: Mon Dec 8 09:07:28 1997
;;
;; Description/Arguments:

       (check-line-for-comment line)

	Where line is a string, checked for whether it represents a commented
line of fortran code.

;; Returns: t or nil

;; Examples:
 (check-line-for-comment \"c This is a comment\")
 (check-line-for-comment \"C This is a comment\")
 (check-line-for-comment \"* This is a comment\")
 (check-line-for-comment \"\") ;; this is not a comment!
 (check-line-for-comment 'This-is-not-a-comment)
 (check-line-for-comment '(This is not a comment))
 (check-line-for-comment \" * This is not a comment\")
"
  (if (and (stringp line) (> (length line) 0))
      (or
       (char-equal (char line 0) '#\C)
       (char-equal (char line 0) '#\*))
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          check-line-for-include
;;
(defun check-line-for-include(line)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          check-line-for-include Doc:
;;
;; Author: Andy Long
;; Created: Mon Dec 8 09:07:28 1997
;;
;; Description/Arguments:

       (check-line-for-include line)

	Where line is a string, checked for whether it represents an include
statement

;; Returns: t or nil

;; Examples:
 (check-line-for-include \"          include \\\"file.dat\\\"\")
 (check-line-for-include 'This-is-not-an-include)
 (check-line-for-include '(This is not an include))
 (check-line-for-include \"\") ;; this is not an include!
 (check-line-for-include \" * This is not an include\")
"
  (if (stringp line)
      (if (eq (read (make-string-input-stream line) nil 'EOF) 'include)
	  (let* (
		 (line (string-right-trim (list #\Space) line))
		 (len (length line))
		 )
	    (subseq line (1+ (search (list #\') line)) (1- len))
	    )
	)
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                add-spaces
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun add-spaces(infile &optional (outfile infile))
  "
	I created this one to force a read to treat these as different
objects.

	We're still going to have the old 'is it a negation or is it a
subtraction?' problem with '-'. Need to fix that some day!

	I just changed it so that it leaves strings alone. This should work
fine as long as we don't find any escaped \" characters in the fortran code!
Those would wreak havoc. In that case, set

		*string-inside* to nil
"
  (let* (
	 (lines (read-file infile))
	 (nasties
	  (list #\: #\* #\= #\/ #\+ #\- #\^ #\< #\> #\[ #\] #\( #\) #\{ #\}
		#\! #\$ #\@ #\& #\~ #\' #\| #\` #\\ #\,))

	 (nasties (mapcar #'string nasties))
	 (new-nasties (mapcar #'(lambda(x) (strcat " " x " ")) nasties))
	 )
    (with-open-file
     (outport outfile :direction :output)
     (mapcar
      (lambda(line)
	(if (> (length line) 6)
	    (let* (
		   (first (subseq line 0 6))
		   (line  (subseq line 6))
		   (string-inside (if *string-inside* (grep "\"" line)))
		   (lines
		    (if string-inside
			(mapcar
			 (lambda(x) (coerce x 'string))
			 (list-split #\" (coerce line 'list)))
		      (list line)
		      )
		    )
		   (i 0)
		   )		
	      (princ first outport)
	      (dolist
	       (line lines)
	       (if (oddp (incf i))
		   (mapcar
		    (lambda(char char-with-space)
		      (setq line (grep-replace char char-with-space line)))
		    nasties new-nasties
		    )
		 (setq line (strcat "\"" line  "\""))
		 )
	       (princ line outport)
	       )
	      (terpri outport)
	      )))
      lines
      )
     )))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 post-nasties
;;
(defun post-nasties(line)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          post-nasties Doc:
;;
;; Author: Andy Long
;; Created: Wed Dec 17 20:43:37 1997
;;
;; Description/Arguments:

       (post-nasties line)

;; Returns:

;; Notes:

;; See Also: really-nasties

;; Examples:
 (post-nasties \"this '' \")
"
  (let (
	(really-nasties (list "''"))
	(new-really-nasties (list "\""))
	)
    (if (stringp line)	
	(if (= 0 (length line))
	    line
	  (let ()
	    (mapcar
	     (lambda(x y) (setq line (grep-replace x y line)))
	     really-nasties new-really-nasties
	     )
	    line)
	  ))
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                add-spaces-to-string
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun add-spaces-to-string(string)
  "
;; Examples:
 (add-spaces-to-string \"      string-1^)\")
 (add-spaces-to-string \"string-1^)\")
 (add-spaces-to-string \"stri \\\"ng\\\" -1^)\")
"
  (let* (
	 (lines (if (listp string) string (list string)))
	 (nasties
	  (list #\: #\* #\= #\/ #\+ #\- #\^ #\< #\> #\[ #\] #\( #\) #\{ #\}
		#\! #\$ #\@ #\& #\~ #\' #\| #\` #\\ #\,))
	 (nasties (mapcar #'string nasties))
	 (new-nasties (mapcar #'(lambda(x) (strcat " " x " ")) nasties))
	 (new-nasties (combine (butlast new-nasties) " , "))
	 newline newlines
	 )
    (mapcar
     (lambda(line)
       (let* (
	      (string-inside (if *string-inside* (grep "\"" line)))
	      (lines
	       (if string-inside
		   (mapcar
		    (lambda(x) (coerce x 'string))
		    (list-split #\" (coerce line 'list)))
		 (list line)
		 )
	       )
	      (i 0)
	      )		
	 (setq newline "")
	 (dolist
	  (line lines)
	  (if (oddp (incf i))
	      (mapcar
	       (lambda(char char-with-space)
		 (setq line (grep-replace char char-with-space line)))
	       nasties new-nasties
	       )
	    (setq line (strcat "\"" line  "\""))
	    )
	  (setq newline (strcat newline line))
	  )
	 (setq newlines (append newlines (list newline)))
	 ))
     lines
     )
    newlines
    ))
#|
			END OF MY PROVISIONAL STUFF
|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Hamilton, New Zealand 1992-95 - all rights reserved;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;check
;functions:
;errorset - commented out
;	f2cl
;	concaten
;	f-to-l
;---------------------------------------------------------------------------
(print "f2cl1.l")
(in-package :user)
;; Set this to true if you want lots of verbiage as you work
(defvar *verbose* t)
;; Set this to true if you use a version prior to 3.52 (and I'll only claim
;; that it might work if it's version 3.50!
(defvar pre-3.52 nil)
;; If you want things neatened up at the end, set this to true.
(defvar *postprocess* nil)
;; *string-inside* is a variable I created to take care of a special case (when
;; you have escaped double-quotes in your fortran code).
(defvar *string-inside* t)
;; Set this to true if you want to include the fortran comments as comments in
;; your lisp code:
(defvar *comments* t)

(eval-when (compile load eval)
(proclaim '(special *readtable* sentable))
(proclaim '(special intrinsic_function_names external_function_names
                    undeclared_vbles declared_vbles implicit_vble_decls
                    explicit_vble_decls function-flag subroutine-flag key_params
                    save_vbles program-flag subprog_name
                    subprog_common_vars  common_array_dims
                    format_stmts current_label
                    subprog_stmt_fns subprog_stmt_fns_bodies)))

;----------------------------------------------------------------------------
(defun f2cl (&rest args)
  (format t "Copyright(c) 92-95 University of Waikato - all rights reserved~%")
  (format t "Xlispstat Revision Copyright(c) 1997 IMSP, Porto-Novo, Benin~%")

  (when
   *verbose*
   (format t "~%")
   (format t "  - compiles for VAX LISP, LUCID, ALLEGRO, CLISP + simpletest~%")
   (format t "  - with-open-file now encapsulates fortran-to-lisp calls~%")
   (format t "  - all f2cl code is now explicitly in the :USER package~%")
   (format t "  - excess labels are removed, else set *prune_labels* to nil.~%")
   (format t "  - do loops have been fixed: these are very tricky so check!~%")
   (format t "  - f2cl has the keyword outfile with default value \"temp\"~%")
   (format t "  - set *print-right-margin* to 100 for deep expressions.~%")
   (format t "  - to include Fortran comments set *comments* to t~%")
   (format t "  - the EOF bug has now been fixed so bottoms can be ragged~%~%")

   ;; Now, about this special version:
   (format t "

	Now forget all that. This is a translation of the f2cl code for
xlispstat, which might be called f2xl..

	Andy Long has wasted a great deal of time trying to get this stuff
working for xlispstat, and has ironed out a number of bugs. The result is still
far from perfect, however, and you are advised to take note of the following:

	?) Any common statements involving arrays which do not occur also in
the main program are liable to errors (these are initialed in the main
program). The first time the arrays are defined, they must also be
initialed. Otherwise, reference to elements may be made when the array has not
yet been dimensioned.

	A related problem occurs if different names are given to the same
item in a common statement. for example, in the runge-kutta stuff of the
numerical recipes program, the driver they give (d15r4) uses

      common /path/ kmax,kount,dxsav,x(200),y(10,200)

while the actual routine (odeint) uses

      common /path/ kmax,kount,dxsav,xp(200),yp(10,200)

This led to an error: variable undefined.

	?) some fortran statements are completely and utterly untranslated.

	?) Only rudementary input via read is currently available.

	?) Some format statements (especially those involving lists/arrays) are
mangled.
")
   )

  (if (/= 2 (length args))
      (error "Error in f2cl: this function takes 2 arguments."))
  (prog (infile outfile)
	(setq infile (first args) outfile (second args))
	(if (not (stringp infile))
	    (error "Error in f2cl: the first argument should be a string."))
	(if (not (stringp outfile))
	    (error "Error in f2cl: the second argument should be a string."))
	(if (not (probe-file infile))
	    (error "Error in f2cl: the file represented by the first argument
   does not appear to exist."))
	
	(fortran-to-lisp
	 (preprocess infile)
	 outfile)
	;; ael - put back the preferred readtable:
	(new-readtable)
	;; ael - added this to tidy it up a bit:
	(if *postprocess* (postprocess outfile))
	;; delete the temporary file:
;;ael	(delete-file "f2clprep.tmp")
	;; ael
	(return outfile)))

;;;---------------------------------------------------------------------------
#+xxxx
(defun ccomment (x) (declare (ignore x)) nil)

;---------------------------------------------------------------------------
(defun process-data (x)
   (fortran-to-lisp
     (concatenate 'string
        "[.xnr]" (string-downcase (princ-to-string x)) ".for")
     (concatenate 'string
        "[.lnr]" (string-downcase (princ-to-string x)) ".l")))

;-----------------------------------------------------------------------------
; not the same as Senac's concat:
 (defun concaten (x &rest more-args)
  (intern
    (apply #'concatenate 'string
      (princ-to-string x) (mapcar #'princ-to-string more-args))
    (find-package :user)))
;----------------------------------------------------------------------------

; utilities
;	fortran-to-lisp
;       readsubprog-extract-format-stmts
;       translate-and-write-subprog
;	translate-line
;	setsyntax
;	single-macro-character
;	set-fortran-read
;	setlispread
;	lineread
;	read-six-chars
;	outfile
;	infile
;	const
;	introduce-continue
;	find-do
;----------------------------------
; identifiers
;       id-definition-prog
;	id-definition-sub
;	id-definition-fun-typed
;	id-definition-fun
;	id-declaration
;	id-parameter
;       id-implicit-decl
;	id-assignment
;	id-subroutine-call
;	id-do-loop
;       id-pause
;       id-return
;       id-predicate
;	id-if
;	id-endif
;       id-if-goto
;	id-if-then
;	id-goto
;       id-continue
;-----------------------------------
; parsers
;       parse-prog-definition
;	parse-subr-definition
;       parse-typed-fun-definition
;       parse-fun-definition
;       parse-declaration
;       parse-implicit-decl
;	parse-parameter
;	parse-assignment
;	parse-expression
;       parse-pause
;	parse-subroutine-call
;	parse-do-loop
;	parse-if
;       parse-if-goto
;	parse-if-then
;	parse-return
;	parse-goto
;       parse-save
;       parse-common
;       parse-char-decl
;       parse-data
;       parse-data1
;	princ-reset
;-------------------------------------
; parsing utilities
;       extract-atoms
;       tail-chop
;       head-chop
;       list-split
;       gen-list-split
;       list-split-multi
;       list-split-bin
;       concat-operators
;       brackets-check
;	subsequence
;-------------------------------------
; matching
;	binding-value
;	variablep
;	variable-value
;	unify - returns fail or a bindings list/nil
;	match - returns multiple values or nil
;	maybe-extend-bindings
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           fortran-to-lisp
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fortran-to-lisp (file ofile)
  (let (common_array_dims format_stmts)
    (if *verbose* (format t "beginning the main translation ...~%"))

    ;; open the input file
    (with-open-file
     (inport file :direction :input)

     ;; open the output file
     (with-open-file
      (outport ofile :direction :output :if-exists :rename-and-delete)

      ;; set common array dims to nil:
      (setq common_array_dims nil)

      (do
       ((char (peek-char nil inport nil 'EOF) (peek-char nil inport nil 'EOF)))
       ;; quit when we get to the end of the file:
       ((eq char 'EOF))

       ;; we set the format statements to nil for a new subprogram:
       (setq format_stmts nil)

       ;; translate-and-write-subprog takes care of one at a time:
       (translate-and-write-subprog

	;;
	(introduce-continue

	 ;;
	 (readsubprog-extract-format-stmts inport))

	outport))
      ))
    t))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                readsubprog-extract-format-stmts
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun readsubprog-extract-format-stmts (inport)
  (prog
   (input-list output-list (margin nil) (multiple-line-flag nil)
	       current-line current_label)
   (if *verbose* (format t "~&extracting format statements ...~%"))
   main-loop

   ;; label
   (if (not multiple-line-flag)
       (setq current_label
	     (if (integerp (read-from-string (coerce margin 'string) nil))
		 (read-from-string (coerce margin 'string) nil)
	       nil)))

   ;; set-fortran-read tells the program to read the following as single
   ;; letters, and not as a bunch. I think that the consequence of this is that
   ;; it will cause a space to be added to the symbols (they're supposed to be
   ;; read in as single character symbols):

   ;; the symbols:       , : * = / + - ^ < > [ ] ( ) { } ! $ @ & ~ ' | ` \

   ;;ael - change the readtable to read in things in a fortran kinda way:
   (unwind-protect
       (let ()
	 ;; This puts the readtable into special 'read-fortran' mode:
	 (set-fortran-read)

	 ;; read body of a line
	 (setq
	  input-list
	  (if multiple-line-flag
	      (progn (setq multiple-line-flag nil)
		     (setq current-line (lineread inport))
		     (append input-list current-line))
	    (lineread inport)))
	
	 ;; read newline character
	 (read-char inport nil 'EOF t)
	 )
     ;; This resets the readtable:
     (setlispread)
     )

   ;; read the next margin
   ;; I'm not sure if margin should be a string or list of characters: maybe it
   ;; doesn't matter....
   (cond ((not (eq (peek-char nil inport nil 'EOF) 'EOF))
	  (setq margin (read-six-chars inport))
	  (when (not (char-equal (nth 5 margin) #\space)) ;line continuation
		(setq multiple-line-flag t)
		(go main-loop)))
	 (t (setq margin nil)))

   ;; extract format-stmts
   (cond
    ((eq (car input-list) 'FORMAT)
     (parse-format
      (brackets-check
       (concat-operators input-list))))

    (t (setq output-list (cons (list current_label input-list) output-list)))
    )

   ;; check for end of subprogram
   (if (and (eq (car input-list) 'end) (null (cdr input-list)))
       (return (nreverse output-list)))

   ;; ael
   (if margin (go main-loop))))
;;ael   (go main-loop)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                introduce-continue
;;
#|
	
|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun introduce-continue (prog-list) ; ((margin line) (margin line) ...)
  (prog
   (ret labels next rest)
   (setq labels (remove nil (mapcar #'find-do prog-list)))
   (setq next (first prog-list) rest (rest prog-list))

   loop
   (if (and (member (car next) labels)
	    (multiple-do-labelp
	     (concatenate 'string "LABEL"
			  (princ-to-string (car next))) labels))
       (setq ret (append  (list (list (car next) '(continue)))
			  (list (list nil (second next)))  ret))
     (setq ret (cons next ret)))
   (if (null rest) (return (reverse ret)))
   (setq next (car rest) rest (cdr rest))
   (go loop)
   ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                find-do
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun find-do (margin-line)
  (if (eq (caadr margin-line) 'do) (cadadr margin-line) nil))

;------------------------------------------------------------------------------
; prog-list of form ((margin line) (margin line) ...)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                      translate-and-write-subprog
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun translate-and-write-subprog (prog-list outport)
  (prog
   (fort-fun
    external_function_names
    undeclared_vbles declared_vbles implicit_vble_decls explicit_vble_decls
    save_vbles key_params subprog_common_vars
    subprog_stmt_fns subprog_stmt_fns_bodies subprog_name
    subroutine-flag function-flag program-flag
    labels)

   ;; labels is the do integers:
   (setq labels (remove nil (mapcar #'find-do prog-list)))

   ;; Set up a bunch of variables that may prove useful:
   (setq
    external_function_names nil
    undeclared_vbles nil
    declared_vbles nil

    ;; ael
    ;; implicit_vble_decls nil
    ;; ael - changed this from nil to represent the default state of fortran:
    implicit_vble_decls '((fixnum (i n)) (single-float (a h) (o z)))
    ;; lea

    ;; ael - added these to provide me a list of those variables which are
    ;; being passed to these puppies, in order to verify that a passed variable
    ;; is a function (and so invoke funcall) when necessary.
    subroutine-arg-list nil
    function-arg-list nil
    ;; lea

    ;; ael - using this one for I/O: when I close a file, I may want to delete
    ;; it, in which case I need to know its name. For the moment I'm just going
    ;; to print the message "would have deleted such-and-such file", so I'll
    ;; see how it's working. Don't want to accidently delete f2cl.lsp or
    ;; something!
    f2cl-open-files nil
    ;; lea

    explicit_vble_decls nil
    save_vbles nil
    key_params nil
    subprog_common_vars nil
    common-names nil
    subprog_stmt_fns nil
    subprog_stmt_fns_bodies nil
    subroutine-flag nil
    function-flag nil
    program-flag t
    )

   ;; ael
   ;; the "check" which follows the next do loop will cause trouble
   ;; if there are any comments at the top of the file - it can add a program
   ;; *main* right in front of the actual program. I hope that I'll strip off
   ;; only the leading comments, and leave the rest okay!
   (setq
    prog-list
    (do*
     (
      (fun prog-list (rest fun))
      (first (second (first fun)) (second (first fun)))
      )
     ((or (not first)
	  (not (listp first))
	  (not (eq (first first) 'COMMENT)))
      fun)
     (format outport "#|~a|#~%" (second first))
     )
    )
   ;; ael

   ;; ael:
   ;; When the prog-list is empty, it was just full of comments!
   (when
    (not (equal prog-list '(nil)))
    (setq
     fort-fun
     (do
      ((lines prog-list (cdr lines))
       (fort-fun
	nil
	(append fort-fun
		(append (translate-label (caar lines))
			(translate-line
			 (brackets-check (concat-operators
					  (cadar lines)))))))
       )
      ((null (cdr lines))
       (append fort-fun
	       (cond (function-flag
		      `(end_label (return ,(cadr fort-fun))))
		     (program-flag
		      `(end_label (return nil)))
		     (t
		      `(end_label (return (values
					   ,@(caddr fort-fun))))))))))


    ;; check for missing PROGRAM stmt
    (if (not (eq (car fort-fun) 'defun))
	(setq fort-fun (append '(defun *main* nil) fort-fun)))

;;    (break)

    (special-print
     (insert-declarations
      (prune-labels
       (fix-structure
	fort-fun
	labels)))
     outport)

    (andy-print 'explicit_vble_decls explicit_vble_decls)

    ;;indicate which subprogram is being translated
    (print (cadr fort-fun))
    (write-char '#\newline outport)
    (write-char '#\newline outport)
    )
   )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                special-print
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun special-print (x o)
  ;;  (write x :escape t :stream o :pretty t :case :downcase)
  ;; ael - doesn't pretty-print, so wrote my own:
  (prettiprint x :stream o)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                princ-reset
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun princ-reset (x &optional (y "")) (print x) (princ  y))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                translate-label
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun translate-label (label)
  (if label
      (list (read-from-string
	     (concatenate 'string "label" (princ-to-string label))
	     nil))
    nil))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                translate-line
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun translate-line (x) ;; x is a list being a line body-> list of lisp
  "
zzz

;; Examples:
 (set-up-faux)
 (trace parse-assignment parse-arrayref-or-stmtfn parse-expression
   id-expression list-itp id-term)
 (translate-line '(a = fx(x)))
 (untrace parse-assignment parse-arrayref-or-stmtfn parse-expression
   id-expression list-itp id-term)
 (translate-line '(PRINT * |,| A))
 (translate-line '(stop))	;; (return (values))
 (translate-line '(end))
 (translate-line '(do i = 1 n))
 (translate-line '(INTEGER J))
 (translate-line '(IF(C2.EQ.999.)STOP))
 (parse-declaration '(INTEGER J |,| K))

 ;; (translate-line '(WRITE (* |,| 8000) |,| J |,| K))
 (translate-line '(WRITE (* |,| *) |,| J |,| K |,| K |,| K |,| K |,| K |,| K))
 (translate-line '(WRITE (*) |,| J |,| K))
 (translate-line '(WRITE (* |,| *) |,| J |,| K))
 (translate-line '(WRITE (* , 2(I3)) |,| J |,| K))
 (translate-line '(DO 13 J = i |,| n))
 ;; ((FDO (J I (+ J 1)) ((> J N) NIL) FDO_BODY_LABEL13))
 ;; doesn't work: (translate-line '(DO J = i |,| n))
 ;; doesn't work: (translate-line '(K=J*J))
 (translate-line '(K = J * J)) ;; ((SETF K (* J J)))
 (translate-line '(COMMENT \"this is a comment\"))
"
  (prog
   (bindings)

   ;; reduce any DOUBLE PRECISION, REAL*8 etc to one word data types
   (if (member (car x) '(double real integer complex))
       (setq x (reduce-data-type x)))

   ;;return
   (if *verbose* (format t "~a~%" (string-downcase (princ-to-string x))))
   (if (id-return x) (return '((go end_label))))

   ;;continue
   (setq bindings (id-continue x))
   (if (not (eq bindings 'fail)) (return `(continue_place_holder)))

   ;;definition
   (setq bindings (id-definition-prog-name x))
   (if (not (eq bindings 'fail)) (return (parse-prog-definition bindings)))
   (setq bindings (id-definition-prog x))
   (if (not (eq bindings 'fail)) (return (parse-prog-definition bindings)))
   (setq bindings (id-definition-sub x))
   (if (not (eq bindings 'fail)) (return (parse-subr-definition bindings)))
   (setq bindings (id-definition-fun x))
   (if (not (eq bindings 'fail)) (return (parse-fun-definition bindings)))
   (setq bindings (id-definition-fun-typed x))
   (if (not (eq bindings 'fail))
       (return (parse-typed-fun-definition bindings)))

   ;;goto/go to
   (if (id-assgn-goto x) (return (parse-assgn-goto x)))
   (if (id-comp-goto x) (return (parse-comp-goto x)))
   (setq bindings (id-goto x))
   (if (not (eq bindings 'fail)) (return (parse-goto bindings)))
   (if (id-assgn-go-to x) (return (parse-assgn-go-to x)))
   (if (id-comp-go-to x) (return (parse-comp-go-to x)))
   (setq bindings (id-go-to x))
   (if (not (eq bindings 'fail)) (return (parse-goto bindings)))

   ;;declarations
   (if (id-declaration x) (return (parse-declaration x)))

   ;;parameters
   (if (id-parameter x) (return (parse-parameter x)))

   ;;implicit declarations
   (if (id-implicit-decl x) (return (parse-implicit-decl x)))

   ;;do loop
   (if (id-do-loop x) (return (parse-do-loop (check_new_vbles x))))

   ;; if-then
   (if (id-if-then x) (return (parse-if-then (check_new_vbles x))))
   ;;ael - fixed this so it recognizes both else if and elseif. See also
   ;;changes to id-elseif.
   (if (id-elseif x)
       (return
	(if (eq (first x) 'elseif)
	    `((elseif_place_holder ,(id-logical (cadr (check_new_vbles x)))))
	  `((elseif_place_holder ,(id-logical (caddr (check_new_vbles x)))))
	  )
	)
     )
   ;;lea
	
   (if (id-else x) (return '((elseif_place_holder t))))
   (if (id-endif x) (return '(endif_place_holder)))

   ;;if
   (setq bindings (id-if-goto x))
   (if (not (eq bindings 'fail)) (return (parse-if-goto bindings)))
   (if (id-if x) (return (parse-if (check_new_vbles x))))

   ;;assignments or statement functions
   (if (id-assignment x) (return (parse-assignment x)))

   ;;subroutine call
   (if (id-subroutine-call x)
       (return (parse-subroutine-call x)))

   ;;pause
   (if (id-pause x) (return (parse-pause x)))

   ;;write
   (if (eq (car x) 'write) (return (parse-write x)))

   ;;ael - (just to get us started!)
   ;;read
   (if (eq (car x) 'read) (return (parse-read x)))
   ;;open
   (if (eq (car x) 'open) (return (parse-open x)))
   ;;close
   (if (eq (car x) 'close) (return (parse-close x)))
   ;;include
   (if (eq (car x) 'include) (return (parse-include x)))
   ;;lea

   ;; ael -
   ;; print - replaced by a call to parse-write; I've modified this to handle
   ;; the case of a
   ;; 		print i
   ;; line.
   ;; lea
   (if (eq (car x) 'print)
       (let* (
	      (format (second x))
	      (format (if (or (eq format '*) (listp format)) format))
	      )
	 (return
	  (parse-write
	   (if format
	       (append `(write (* |,| ,format )) (rest (rest x)))
	     (append `(write (*)) (rest x))
	     )))))
   ;;lea

   ;;format
   (if (eq (car x) 'format) (return (parse-format x)))

   ;;data
   (if (eq (car x) 'data) (return (parse-data x)))

   ;;save
   (if (eq (car x) 'save) (return (parse-save x)))

   ;;intrinsic
   (if (eq (car x) 'intrinsic) (return nil))

   ;;external
   (if (eq (car x) 'external) (return (parse-external x)))

   ;;common
   (if (eq (car x) 'common) (return (parse-common x)))

   ;;stop
   ;;ael
   ;; (if (eq (car x) 'stop) (return nil))
   (if (eq (car x) 'stop) (return `((return (values)))))
   ;;lea

   ;;fall out the bottom:
   (if (eq (car x) 'comment) (return (list x)))

   ;; (return (list '----> (check_new_vbles x)))
   (return (list
	    (list
	     'quote
	     (concatenate ' string  "****NOT TRANSLATED: "
			    (write-to-string (check_new_vbles x))))))
   )
  )

;------------------------------------------------------------------------------
;program
(defun id-definition-prog-name (x) (unify x '(program %name) nil))

(defun id-definition-prog (x) (unify x '(program) nil))

;subroutine s(x,...)
(defun id-definition-sub (x)
  (prog (bindings)
     (setq bindings (unify x '(subroutine %name %arg-list) nil))
     (if (eq bindings 'fail)
         (setq bindings (unify x '(subroutine %name) nil)))
     (return bindings)))

;type function f(x,...)
(defun id-definition-fun-typed (x)
  (unify x '(%type function %name %arg-list) nil))

;untyped function f(x,...)
(defun id-definition-fun (x)
  (unify x '(function %name %arg-list) nil))

; continue
(defun id-continue (x) (unify x '(continue) nil))

;goto label
(defun id-goto (x)
 (unify x '(goto %label) nil))
(defun id-assgn-goto (x)
 (and (eq (car x) 'goto)
      (listp (cadr x))))
(defun id-comp-goto (x)
 (and (eq (car x) 'goto)
      (or (and (not (listp (cadr x)))
               (cddr x))
          (not (numberp (cadr x))))))
;go to label
(defun id-go-to (x)
 (unify x '(go to %label) nil))
(defun id-assgn-go-to (x)
 (and (eq (car x) 'go)
      (eq (cadr x) 'to)
      (listp (caddr x))))
(defun id-comp-go-to (x)
 (and (eq (car x) 'go)
      (eq (cadr x) 'to)
      (or (and (not (listp (caddr x)))
               (cdddr x))
          (not (numberp (caddr x))))))


;integer x,y,z,...
(defun id-declaration (x)
  (member (first x)
	  '(integer double real character complex logical dimension) :test #'eq))

;------------------------------------------------------------------------------
(defun id-if-then (x) (and (eq (car x) 'if) (member 'then x :test #'eq)))
(defun id-if-goto (x) (unify x '(if %pred goto %label) nil))
;(defun id-if-assignment (x) (and (eq (car x) 'if) (member '= x :test #'eq)))
;(defun id-if-pause (x) (and (eq (car x) 'if) (member 'pause x :test #'eq)))
(defun id-if (x) (eq (car x) 'if))
(defun id-else (x) (eq (car x) 'else))

;;ael
;;(defun id-elseif (x) (and (eq (car x) 'else) (cadr x) (eq (cadr x) 'if)))
(defun id-elseif (x)
  (or
   (and (eq (car x) 'else) (cadr x) (eq (cadr x) 'if))
   (eq (car x) 'elseif)
   )
  )
;;lea

(defun id-endif (x)
       (or (eq (car x) 'endif)
           (and (eq (car x) 'end) (eq (cadr x) 'if))))

(defun id-assignment (x) (member '= x :test #'eq))
(defun id-subroutine-call (x) (eq (car x) 'call))
(defun id-do-loop (x) (eq (car x) 'do))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-implicit-do-loop
;;ael
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-implicit-do-loop(list &key (operation '((rread nil))))
  "
	Right now this is just for reads:

 (id-expression '(line ( i |,| j ) ))
 ;; (LINE I J)

 (parse-do-loop '(do 13 j = 1 |,| 3))
 results in:
 ((FDO (J 1 (+ J 1)) ((> J 3) NIL) FDO_BODY_LABEL13))

But I can't handle this one yet! (from alg125.for, in the dos_fortran dir)
            READ(4,*) (II(KK,J),NV(KK,J),J=1,LLL)

;; Examples:
 (parse-implicit-do-loop '( line ( i ) |,|  i = 1 |,| 9 ))
 (parse-implicit-do-loop '(( line ( i |,| j ) |,| j = 1 |,| 2 ) |,| i = 1 |,| 9))

 (parse-implicit-do-loop
   '(( line ( i |,| j ) |,|  wing ( i |,| j ) |,| j = 1 |,| 2 ) |,| i = 1 |,| 9))
"
  (if (listp list)
      (cond
       ((listp (first list))
	(let ((pl (parse-do-loop (combine 'do 31415666 (rest (rest list))))))
	  (setf
	   ;; I'm replacing fdo loops with do loops (this was mostly to avoid
	   ;; post-processing of fdos, to verify labels, etc.),
	   (elt (elt pl 0) 0) 'do
	   ;; which means that I have to change the variable list to a list of
	   ;; the variable list:
	   (elt (elt pl 0) 1) (list (elt (elt pl 0) 1))
	   ;; the first (and only) thing should be another do-loop:
	   (elt (first pl) (1- (length (first pl))))
	   (first (parse-implicit-do-loop (first list) :operation operation)))
	  pl
	  )
	)
       (t
	(let* (
	       (equal (search '(=) list))
	       (len (length list))
	       (pl
		(parse-do-loop
		 (combine 'do 31415666
			  (select list (iseq (1- equal) (1- len))))))
	       (args (list-split '|,| (select list (iseq (1- equal)))))
	       (args (if (null (final args)) (butlast args) args))
	       )
	  (setf
	   (elt (elt pl 0) 0) 'do
	   (elt (elt pl 0) 1) (list (elt (elt pl 0) 1))
	   (elt (elt pl 0) (1- (length (first pl))))
	   (append
	    (list 'setf)
	    (smoosh
	     (mapcar
	      (lambda(x)
		(append
		 (list (id-expression x))
		 operation)
		)
	      args
	      )
	     )
	    )
	   )
	  pl
	  )
	)
       )
    )
  )
#|
  (if (listp list)
      (cond
       ((listp (first list))
	(let ((pl (parse-do-loop (combine 'do 31415666 (rest (rest list))))))
	  (setf
	   (elt (first pl) (1- (length (first pl))))
	   (parse-implicit-do-loop (first list) :operation operation))
	  pl
	  )
	)
       (t
	(let (
	      (pl
	       (parse-do-loop
		(combine 'do 31415666 (rest (rest (rest list)))))))
	  (setf
	   (elt (elt pl 0) (1- (length (first pl))))
	   (append
	    (list 'setf
		  (combine
		   'aref
		   (id-expression (select list (iseq 2)))))
	    operation
	    )
	   )
	  pl
	  )
	)
       )
    )
  )
|#
;;lea

(defun id-pause (x) (eq (car x) 'pause))

(defun id-return (x) (and (eq (car x) 'return) (null (cdr x))))
(defun id-predicate (x) (id-logical x))

(defun id-implicit-decl (x) (eq (car x) 'implicit))
(defun id-parameter (x) (eq (car x) 'parameter))

;=============================================================================
; parsers

; program definition
(defun parse-prog-definition (bindings)
   (setq program-flag t)
   (setq subprog_name (variable-value '%name bindings))
   (list 'defun (if subprog_name subprog_name '*MAIN*)
         nil
         ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-subr-definition
;;
;; subroutine definition
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-subr-definition (bindings)
  ;; ael - turn off the program-flag
  (setq program-flag nil subroutine-flag t)
  ;; ael
  (prog (arg-list)
   (setq subprog_name (variable-value '%name bindings))
   (setq arg-list (remove '|,| (variable-value '%arg-list bindings)))
   ;;ael
   (setq subroutine-arg-list arg-list)
   ;;ael
   (return (list 'defun subprog_name
                    (if arg-list arg-list nil)))))

; typed function definition
(defun parse-typed-fun-definition (bindings)
  ;; ael - turn off the program-flag
  (setq program-flag nil function-flag t)
  ;; ael
  (prog (fun-name)
   (setq fun-name (variable-value '%name bindings)
         declared_vbles (list fun-name)
         explicit_vble_decls
              (list (list (convert-data-type (variable-value '%type bindings))
                          (list fun-name))))
   ;;ael
   (setq function-arg-list
	 (combine function-arg-list
		  (remove '|,| (variable-value '%arg-list bindings))))
   ;;ael
   (return
   (list 'defun
         fun-name
         (remove '|,| (variable-value '%arg-list bindings))))))

; untyped function definition
(defun parse-fun-definition (bindings)
   (setq function-flag t)
   ;;ael
   (setq function-arg-list
	 (combine function-arg-list
		  (remove '|,| (variable-value '%arg-list bindings))))
   ;;ael
   (list 'defun
         (variable-value '%name bindings)
         (remove '|,| (variable-value '%arg-list bindings))))

;goto
(defun parse-goto (bindings)
  `((go ,(read-from-string
	  (concatenate 'string "label"
		       (princ-to-string (variable-value '%label bindings)))
	  nil))) )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make-label
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-label (n)
  (read-from-string (concatenate 'string "label" (princ-to-string n))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-assgn-goto
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-assgn-goto (x)
  (prog
   (labels len)
   (setq labels (remove '|,| (cadr x)))
   (setq len (length labels))
   (return
    `((case
       ,(id-expression (cdddr x))
       ,@(mapcar
	  #'(lambda (x n) (list n (make-label x)))
	  labels (listn 1 len)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                listn
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun listn (a b)
  (prog
   (lis)
   (cond
    ((< b a) (return (reverse (listn b a))))
    ((eq a b) (return (append1 () a)))
    (t
     (setq lis (append1 () a))
     (do ((i (1+ a) (1+ i))) ((> i b)) (setq lis (append1 lis i)))
     (return lis))
    )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-comp-goto
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-comp-goto (x)
  (if (cddr x)
      `((computed-goto
	 ,(cadr x)
	 ',(mapcar #'(lambda (l)
		       (read-from-string
			(concatenate 'string "label" (princ-to-string l))))
		   (remove '|,| (cadddr x)))))
    `((computed-goto ,(cadr x)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-comp-go-to
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-comp-go-to (x)
  (if (cdddr x)
      `((computed-goto
	 ,(caddr x)
	 ',(mapcar #'(lambda (l)
		       (read-from-string
			(concatenate 'string "label" (princ-to-string l))))
		   (remove '|,| (car (cddddr x))))))
    `((computed-goto ,(caddr x)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-assgn-go-to
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-assgn-go-to (x)
  (prog (labels len)
	(setq labels (remove '|,| (caddr x)))
	(setq len (length labels))
	(return
	 `((case
	    ,(id-expression (cddddr x))
	    ,@(mapcar
	       #'(lambda (x n) (list n (make-label x)))
	       labels (listn 1 len)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-declaration
;;
;; declaration
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-declaration (x) ; x is the line
  (setq declared_vbles
	(append (if (eq (cadr x) '*)
		    (mapcar #'car (list-split '|,| (cdddr x)))
		  (mapcar #'car (list-split '|,| (cdr x))))
		declared_vbles))
  (cond
   ((eq (first x) 'integer)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'fixnum (cdr x))))
   ((eq (first x) 'double)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'double-float (cdr x))))
   ((eq (first x) 'real)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'single-float (cdr x))))
   ((eq (first x) 'character)
    (parse-char-decl x))
   ((eq (first x) 'complex)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'complex (cdr x))))
   ((eq (first x) 'logical)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'logical (cdr x))))
   ((eq (first x) 'dimension)
    (setq explicit_vble_decls
	  (build_decl_list explicit_vble_decls 'array (cdr x))))
   (t nil))
  nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-implicit-decl
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-implicit-decl (x)
  (if (eq (third x) '*)
      (setq
       x
       `(,(first x) (,(second x) ,(third x) ,(fourth x)) ,@(cddddr x))))

  (setq implicit_vble_decls
	(append (mapcar #'(lambda (y)
			    `(,(car (convert-data-type y))
			      ,@(list-split '|,| (remove '- (car (last y))))))
			(list-split '|,| (cdr x)))
		implicit_vble_decls))
  nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                              build_decl_list
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun build_decl_list (decl_list type decl)
  (cons `(,type
	  ,@(mapcar #'(lambda (y)
			`(,(car y) ,@(parse_dimension_specs (cadr y))))
					;,@(delete '|,| (cadr y))))
		    (list-split '|,| decl)))
	decl_list))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse_dimension_specs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse_dimension_specs (specs)
  (if (null specs) nil
    (mapcar #'parse_upper_and_lower_bounds (list-split '|,| specs))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse_upper_and_lower_bounds
;;
;; bounds will be either (l:u) or (u)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse_upper_and_lower_bounds (bds)
  (setq bds (list-split '|:| bds))
  (if (null (cdr bds)) (list 1 (id-expression (car bds)))
    (list (id-expression (car bds))
	  (id-expression (cdr bds)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-assignment
;;
;; expression is algebraic with function calls:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-assignment (x)
  "
zzz
	I imagine that this is the function that needs to be checking for
integer arguments, and any that it finds it needs to setf and then coerce to
integer.

	This leads to lots of extraneous int statements in the code, which will
slow it down - but at least it will work!

See Also: get-implicit-type, default-int-p, declared_vbles, explicit_vble_decls
"
  (prog
   ((lhs (parse-expression (tail-chop '= x)))
    (rhs (parse-expression (head-chop '= x))))
   (return
    (if (listp lhs)
	(parse-arrayref-or-stmtfn lhs rhs)
      (and (check_new_vbles (list lhs))
;;;ael
	   ;;ael `((setf ,lhs ,rhs)))))))
	   #| first I fixed it for just integers: now for floats too:
	   (if (and
		(it-is-an-integer-p lhs)
		(not (it-is-already-an-integer-p rhs)))
	       `((setf ,lhs (int ,rhs)))
	     `((setf ,lhs ,rhs))))))))
|#
	   (cond
	    ((and
	      (it-is-an-integer-p lhs)
	      (not (it-is-already-an-integer-p rhs)))
	     `((setf ,lhs (int ,rhs)))
	     )
	    ((and
	      (it-is-a-float-p lhs)
	      (not (it-is-already-a-float-p rhs)))
	     `((setf ,lhs (float ,rhs)))
	     )
	    (t `((setf ,lhs ,rhs)))))))))
;;;ael
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; it-is-an-integer-p
;; it-is-already-an-integer-p
;; explicitly-integer-p
;;
;; ael - added these to check for fixnum definition:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun it-is-an-integer-p(lhs)
  "
;; Examples:
 (set-up-faux)
 (it-is-an-integer-p 'a)
 (it-is-an-integer-p 'l)
"
  (let ((x (member lhs declared_vbles)))
    (or
     (and x (explicitly-integer-p lhs))
     (and (not x) (eq (get-implicit-type lhs) 'fixnum))
     )))
(defun it-is-already-an-integer-p(rhs)
  "
;; Examples:
 (it-is-already-an-integer-p 0)
 (it-is-already-an-integer-p '(mod 3.4))
 (it-is-already-an-integer-p '(f2cl/ 3.4 4))
"
  (cond
   ((integerp rhs))
   ((listp rhs)
    (if (member (first rhs)
		'(f2cl/ mod int floor round truncate))
	t
      nil)
    )
   ((it-is-an-integer-p rhs))))
(defun explicitly-integer-p(v) ;; explicit_vble_decls
  (let* (
	 ;; i is first a list of (nil nil t nil), etc.
	 (i (mapcar (lambda(x) (eq (first x) 'fixnum)) explicit_vble_decls))
	 ;; now i is the string starting with 'fixnum
	 (i (where i t))
	 (i (if i
		(combine
		 (mapcar
		  #'rest
		  (select explicit_vble_decls i)))))
	 )
    (member v i)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; ael - added these to check for float definition:
;;
;; (trace it-is-a-float-p it-is-already-a-float-p explicitly-float-p)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun it-is-a-float-p(lhs)
  "
;; Examples:
 (set-up-faux)
 (it-is-a-float-p 'a)
 (it-is-a-float-p 'l)
"
  (let ((x (member lhs declared_vbles)))
    (or
     (and x (explicitly-float-p lhs))
     (and (not x) (first
		   (member (get-implicit-type lhs)
			   '(single-float double-float))))
     )))
(defun it-is-already-a-float-p(rhs)
  "
;; Examples:
 (set-up-faux)
 (it-is-already-a-float-p 0)
 (it-is-already-a-float-p 0.0)
 (it-is-already-a-float-p pi)
 (it-is-already-a-float-p (float 1))
 (it-is-already-a-float-p '(mod 3.4))
 (it-is-already-a-float-p '(f2cl/ 3.4 4))
"
  (cond
   ((floatp rhs))
   ((listp rhs)
    (if (member (first rhs)
		'(float))
	t
      nil)
    )
   ((it-is-a-float-p rhs))))
(defun explicitly-float-p(v)
  "
;; Examples:
 (set-up-faux)
 (def explicit_vble_decls '((single-float (a)) (fixnum (c)) (single-float (b))))
 (explicitly-float-p 'a)
 (explicitly-float-p 0.0)
 (explicitly-float-p 'b)
 (explicitly-float-p 'c)
"
  (let* (
	 ;; i is first a string of (nil nil t nil), etc.
	 (i (mapcar (lambda(x)
		      (if (member (first x) '(single-float double-float))
			  t nil))
		    explicit_vble_decls))
	 (i (where i t))
	 (i (if i
		(combine
		 (mapcar
		  #'rest
		  (select explicit_vble_decls i)))))
	 )
    (member v i)))

;; ael
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-arrayref-or-stmtfn
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-arrayref-or-stmtfn (lhs rhs)
  "
;; Examples
 (set-up-faux)
 (trace parse-arrayref-or-stmtfn)
 (parse-arrayref-or-stmtfn '(fref testarr i) 'i)
 (parse-arrayref-or-stmtfn '(STMTFN X Y Z) '(MAX A (MAX A B)))
 (untrace parse-arrayref-or-stmtfn)
"
  ;;lhs is either an array ref or a statement function name
  (if (eq (car lhs) 'fref)
      ;;array_ref
      ;;ael - had problems because if t was used as an array, this wasn't
      ;;checked for those special values:
      ;; `((fset ,lhs ,rhs))
      (let ()
	(setf (elt lhs 1) (check-t-and-pi (elt lhs 1)))
	`((fset ,lhs ,rhs))
	)
    ;;ael

    ;;statement_function
    (let ()
      (setq subprog_stmt_fns
	    (append subprog_stmt_fns (list (car lhs)))
	    subprog_stmt_fns_bodies
	    (append subprog_stmt_fns_bodies `((,(car lhs) ,(cdr lhs) ,rhs)))
	    )
      nil
      )
    )
  )
;;       (and (setq subprog_stmt_fns (append subprog_stmt_fns (list (car lhs))))
;;            `((defun ,(read-from-string
;;                           (concatenate 'string
;;                                   (princ-to-string subprog_name)
;;                                   (princ-to-string (car lhs))))
;;                     ,(cdr lhs) ,rhs)))))

(defun parse-expression (x) (id-expression x))
(defun parse-pause (x) `((error ,(cadr x))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 parse-subroutine-call
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
(defun parse-subroutine-call (x)
  (prog
   (arglist)
   (setq arglist
	 (if (third x)
	     (mapcar  #'id-expression
		      (list-split '|,| (check_new_vbles (third x))))
	   nil))
   (return
    (if arglist
        `((multiple-value-setq
	   ,(mapcar #'(lambda (x)
			(cond
			 ;; ael: this one doesn't work, as it's probably an
			 ;; array reference.
			 ((not (symbolp x)) '*dummy_var*)
			
			 ;; ael: this one works okay:
			 ((vble-is-array-p x) '*dummy_var_array*)
			      (t x)))
		    arglist)
	   (,(second x) ,@arglist)))
      `((,(second x))))
    )))
|#
(defun parse-subroutine-call (x)
  (prog
   (arglist)
   (setq arglist
	 (if (third x)
	     (mapcar  #'id-expression
		      (list-split '|,| (check_new_vbles (third x))))
	   nil))
   (return
    (let (
	  (array-element-list (list 'setf))
	  array-element-list-entry
	  )
      (if arglist
	  `((multiple-value-setq
	     ,(mapcar
	       #'(lambda (x)
		   (cond
		    ;; ael: added this one to handle an array reference:
		    ((and (listp x) (eq (first x) 'fref))
		     (setq
		      array-element-list-entry (symbol (gensym "*dummy_var*"))
		      array-element-list (append
					  array-element-list
					  (list x array-element-list-entry))
		      )
		     array-element-list-entry
		     )
		    ((not (symbolp x))
		     '*dummy_var*)
		    ;; ael: this one works okay:
		    ((vble-is-array-p x) '*dummy_var_array*)
		    (t x)))
	       arglist)
	     (,(second x) ,@arglist)
	     )
	    ,(if (= (length array-element-list) 1) (values) array-element-list)
	    )
	`((,(second x))))
    ))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-do-loop
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-do-loop (x)
  "
;; Examples:
 (parse-do-loop '(do 13 j = 1 |,| 3))
"
  (let* ((limits (list-split '|,| (cddddr x))) (step (third limits)))
    `((fdo (,(third x)
	    ,(id-expression (first limits))
	    (+ ,(third x) ,(if (null step) 1 (id-expression step))))
	   ((> ,(third x) ,(id-expression (second limits))) nil)
	   ,(read-from-string
	     (concatenate 'string "fdo_body_label"
			  (princ-to-string (second x))) nil)
	   ))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-if-then
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-if-then (x)
  `((if-then ,(id-predicate (butlast (rest x)))  )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-if-goto
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-if-goto (bindings)
  `((if ,(id-predicate (variable-value '%pred bindings) )
	(go
	 ,(read-from-string
	   (concatenate
	    'string "label"
	    (princ-to-string (variable-value '%label bindings))) nil)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-if
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-if (x)
  (cond
   ;;arithmetic if
   (
    ;;(member '|,| (cddr x))
    (and (eq (length (remove '|,| (cddr x))) 3)
	 (not (member-if-not #'numberp (remove '|,| (cddr x)))))
    `((arithmetic-if ,(id-predicate (second x))
		     (go ,(read-from-string
			   (concatenate 'string
					"label"
					(princ-to-string (first (cddr x))))))
		     (go ,(read-from-string
			   (concatenate 'string
					"label"
					(princ-to-string (third (cddr x))))))
		     (go ,(read-from-string
			   (concatenate 'string
					"label"
					(princ-to-string (fifth (cddr x)))))))))
   ;;logical if
   (t
    #|
    ;; ael - added this to take care of the stop problem, I hope!
    (if (equal (cddr x) '(stop))
	  `((if ,(id-predicate (second x)) (return nil)))
      `((if ,(id-predicate (second x)) ,@(translate-line (cddr x))))
      )
|#
    `((if ,(id-predicate (second x)) ,@(translate-line (cddr x))))
    )
   )
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-return
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-return (x) x)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-parameter
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-parameter (x)
  (setq x (mapcar #'(lambda (l) (remove '= l)) (list-split '|,| (cadr x))))
  (setq
   key_params
   (append
    key_params
;;;ael - I changed this as certain parameters are evaluated at compile time. As
;;;defined below, this failed miserably....
;;;    (mapcar #'(lambda (l) (list (first l) (id-factor (second l)))) x)))
;;;ael
    (mapcar
     #'(lambda (l)
	 ;; ael
	 (let ((res (parser (rest l))))
	   (list (first l) (if (listp res) res (id-factor res)))))
     ;;ael
     x)))
  nil
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-save
;;
;; restrict SAVE stmts to
;;     SAVE a,b,...
;; or  SAVE /label/a,b,..
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-save (x)
  (setq save_vbles
        (append save_vbles
                (remove '|,| (if (eq (first (cdr x)) '/) (cddddr x) (cdr x)))))
  nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-common
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-common (x)
  (setq x (mapcar #'(lambda (l) (remove '|,| l))
		  (list-split '|/| (cdr x))))
  (setq x (if (null (car x)) (cdr x) (cons nil x)))
  ;; x now in form (cb nlist cb nlist ... )
  ;; pick out lists of vblenames and add to subprog_common_vars
  (setq
   subprog_common_vars
   (append
    subprog_common_vars
    (do ((list x (cddr list))
	 (ret nil (append (extract-atoms (cadr list)) ret)))
	((endp list) ret)
	;; look for common arrays and store dimensions of new common vars
	(setq common-names (append common-names (list list)))
	(do ((nlist (cadr list) (cdr nlist)))
	    ((endp nlist))
	    (cond ((and (cdr nlist) (listp (cadr nlist)))
		   ;; array dimensioned in COMMON stmt
		   (update_cm_array_dims (car nlist)
					 (remove '|,| (cadr nlist)))
		   (setq nlist (cdr nlist)))
		  ;; check if array dimensioned elsewhere
		  ((member (car nlist) declared_vbles)
		   (do ((decls explicit_vble_decls (cdr decls)))
		       ((null decls) nil)
		       (do ((vbles (cdar decls) (cdr vbles)))
			   ((null vbles) nil)
			   (if (and (eq (car nlist) (caar vbles))
				    (cdar vbles))
			       (update_cm_array_dims (car nlist)
						     (cdar vbles))))))
		  )))))
  nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                update_cm_array_dims
;;
;; append list of vble and dims to common_array_dims if vble not already in list
;; when vble in list check dims match with that stored
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun update_cm_array_dims (vble dims)
  (let ((stored-dims (member vble common_array_dims)))
    (if stored-dims
	(if (not (equal (cadr stored-dims) dims))
	    (error
	     "common array ~A dimensions not equivalent between subprograms"
	     vble))
      (setq common_array_dims (append (list vble dims) common_array_dims)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                extract-atoms
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun extract-atoms (x)
  (do ((l x (cdr l))
       (ret nil (if (atom (car l)) (cons (car l) ret) ret)))
      ((endp l) ret)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-char-decl
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-char-decl (x)
  "
;; Examples:
 (set-up-faux)
 (parse-char-decl '(CHARACTER * 2 ALPHA))
 explicit_vble_decls
 (set-up-faux)
 (parse-char-decl '(CHARACTER * 2 ALPHA |,| TXT))
 explicit_vble_decls
"
  (prog
   (first-bit decl-list)
   (cond ((eq (second x) '*)
	  (setq first-bit `(character ,(third x))
		decl-list (list-split '|,| (cdddr x))))
	 (t
	  (setq first-bit `(character 1)
		decl-list (list-split '|,| (cdr x)))))
   #| - Sun Feb 8 15:21:12 1998
   ;; the point here is that the grouped definition wasn't working, so I split
   ;; it up.
   (setq explicit_vble_decls
	 (cons
	  `(,first-bit
	    ,@(mapcar #'(lambda (decl) (remove '* decl)) decl-list)
	    )
	  explicit_vble_decls))
|#
   (mapcar (lambda(decl)
	     (setq explicit_vble_decls
		   (cons
		    `(,first-bit ,(list (first decl)))
		    explicit_vble_decls))) decl-list)
   )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-data
;;
;; DATA stmts
;;           DATA nlist/clist[,nlist/clist/]...
;; restricted to
;;   one vble name per nlist
;;   no implied do's
;;   clist either a alist or a repetition (not a combination of both)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-data (x)
  "
;; Examples:
 (set-up-faux)
 (PARSE-DATA '(DATA P1 |,| P2 / 1.0 |,| 0.183105E%2 /))
 (PARSE-DATA '(DATA P1 |,| P2 / 1.0 |,| 0.183105E2 /))
 (PARSE-DATA '(DATA P1 |,| P2 |,| P3 /  - 0.183105E%2 |,| 1.0 |,| - 0.183105E2 /))
 (PARSE-DATA '(DATA P1 |,| P2 / 1.0 |,| - 0.185E%2 / |,| P3 |,| p4 / 2.0 |,| 3.0 /))
"
  (let (z (y (list-split '|/| (cdr x))))
    (do* ((list y (cddr list))
	  (z nil (append z zz))
	  (zz nil nil)
	  (x (select list (iseq 2)) (select list (iseq 2))))
	 nil
	 (setq z (append z (parse-data-helper x)))
	 (if (<= (length list) 3) (return z))
	 )
    )
  )
(defun parse-data-helper (x)
  "
;; Examples:
 (parse-data-helper '((P1 |,| P2) (1.0 |,| 0.183105E%2)))
"
  ;;  (setq x (list-split '|/| (cdr x)))

  ;; ael - trying to take care of the case a,b/1,2/....
  ;; trying to get it set up just as it would have been if written "correctly":
;;  (if (and (= (length x) 3) (= (length (list-split '|,| (first x)))
  (let (
	(fx (first x))
	(sx (second x))
	)
    ;; strip off a begining comma, if there is one:
    (if (eq  '|,| (first fx)) (setq fx (rest fx)))

    (if (and (= (length (list-split '|,| fx))
		(length (list-split '|,| sx))))
	(setq
	 x
	 (transpose (list (list-split '|,| fx)
			  (list-split '|,| sx)))
	 x
	 ;;ael  (mapcar #'list (combine x))
	 ;; - think this will fix the - problem:
	 (smoosh x)
	 ;;lea
	 ))
    ;; ael
    (do ((list x (cddr list))
	 (ret nil
	      (cons (parse-data1 (car (remove '|,| (car list)))
				 (list-split '|,| (cadr list))) ret))
	 )
	((null (cdr list)) ret))
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-data1
;;
;; parse a (vble_name data1 data2 ...) list
;;    or a (vble_name n*x) list
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-data1 (v l)
  (cond
   ((and (listp (car l)) (eq (second (car l)) '*))
    `(fill ,v ,(id-expression (cddar l)) :end ,(1- (first (car l)))))
   (t (if (vble-is-array-p v)
	  ;;ael
	  #|
Needed to do something here to take care of the array data problem, that if,
for example, ,v is declared fixnum, then we won't get problems if we do a
replace with lists of the form (- 3) for example.

	This fix now gets repeated values (e.g. the 4*0. in the following:

      DATA WT/1.,0.,-3.,2.,4*0.,-3.,0.,9.,-6.,2.,0.,-6.,

in BCUCOF of the numrec stuff) right.
|#
	;; `(replace ,v ',(mapcar #'id-expression l) :end,(1- (length l)))
	;;ael
	(let ()
	  (if *verbose* (print "ael: data fix??"))
	  `(setq
	    ,v
	    (make-array
	     (array-dimensions ,v)
	     :initial-contents
	     ;; I'll check to see if we need to do any padding
	     (let* (
		    (initial
		     (replace
		      (combine ,v)
		      ',(combine (mapcar #'id-data (mapcar #'id-expression l)))
		      :end ,(1- (length l))))
		    (len (length initial))
		    (ardim (apply #'* (array-dimensions ,v)))
		    )
	       (if (= len ardim)
		   initial
		 (combine initial (repeat nil (- ardim len))))
	       ))
	    ;;ael - Sun Feb 8 14:38:27 1998
	    ;; added this to take care of the fact that matrix data is filled
	    ;; by column first, rather than row:
	    ,v (if (matrixp ,v)
		   (transpose (matrix (reverse (size ,v)) (combine ,v)))
		 ,v)
	    ;;lea
	    )
	  )
	;;ael
	`(setq ,v ,(id-expression (first l)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-data
;;
;; I added this to postprocess the parsed data (specifically to take care of
;; subtractions and repeated data). - ael
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-data(x)
  (if (listp x)
      (case
       (first x)
       ('-
	(eval x)
	)
       ('*
	(repeat (third x) (second x))
	)
       (nil nil)
       (t
	(trace id-data)
	(error "unknown data type in id-data. I've set trace for id-data
		(trace id-data)
Run it again and see what happens.")
	)
       )
    x))
;;ael

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-external
;;
;; parse EXTERNAL f1, f2, ...
;; by adding the function names to external_function_names
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-external (x)
  (setq
   external_function_names
   (append external_function_names (remove '|,| (cdr x))))
  nil)

;=============================================================================
					;parsing utilities
;=============================================================================
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                tail-chop
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun tail-chop (beta lis)
  (prog (retlist)
	(setq retlist nil)
	loop
	(cond ((or (equal lis nil) (equal (car lis) beta))
	       (return retlist))
	      (t (setq retlist (append1 retlist (car lis))
		       lis (cdr lis))
		 (go loop)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                head-chop
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun head-chop (beta lis) (cdr (member beta lis)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                list-split
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun list-split (beta lis)
  (cond ((equal (member beta lis)  nil) (list lis))
	(t `(,(tail-chop beta lis)
	     ,@(list-split beta (head-chop beta lis))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                gen-list-split
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun gen-list-split (beta lis)
  (prog
   (sym ops)
   (cond ((null (remove nil (mapcar 'member beta
				    (const lis (length beta)))))
	  (return (list (list lis) nil)))
	 (t (setq sym (gensym))
	    (setq ops (extract beta lis))
	    (setq lis (tpl-subpair (const sym (length beta)) beta lis))
	    (return
	     (list `(,(tail-chop sym lis)
		     ,@(list-split sym (head-chop sym lis))) ops))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                list-split-multi
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun list-split-multi (op lis)
  (prog (ret)
	(setq ret (match-separated (list op) lis))
	(cond ((null ret)
	       #|
	       (princ-reset
		(concat
		 '|Senac syntax error: failure to parse an expression
		 using the operator "| op '|"
		 Senac syntax: ... | op '| ... | op '| ... OR
		 ... | op '| ...|))
|#
		 (format t
			 "~%ael: in list-split-multi:~%Senac syntax error:~
 failure to parse an expression using the operator ~s,~%given list ~s" op lis)
		 )
	      (t (return (car ret))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                list-split-bin
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun list-split-bin (op lis)
  (prog (ret)
	(setq ret (match-separated (list op) lis))
	(cond ((null ret)
	       #|
	       (princ-reset
		(concat
		 '|Senac syntax error: failure to parse an expression
		 using the operator "| op '|"
		 Senac syntax:... | op '| ...|))
|#
		 (format t "in list-split-bin")
		 (format t
			 "Senac syntax error: failure to parse an expression
		 using the operator ~s~%" op)
		 (format t "Senac error;; ael: don't know concat:")
		 )
	      (t (return  (car ret))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 concat-operators
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun concat-operators (x)
  (prog
   (next rest done)
   (setq next (car x) rest (cdr x))
   loop
   (cond ((null rest) (return (reverse (cons next done)))))
   (cond
    ((and (eq next '*) (eq (car rest) '*))
     (setq rest (cdr rest) done (cons '^ done)))
    ((and (eq next '>) (eq (car rest) '=))
     (setq rest (cdr rest) done (cons '>= done)))
    ((and (eq next '<) (eq (car rest) '=))
     (setq rest (cdr rest) done (cons '<= done)))
    ((and (eq next '>) (eq (car rest) '<))
     (setq rest (cdr rest) done (cons '>< done))) ; needs to be defined
    ;;---->
    (t
     (setq done (cons next done))))
   (setq  next (car rest) rest (cdr rest))
   (go loop)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                convert-data-type
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun convert-data-type (x)
  (cond
   ((not (listp x))
    (car (convert-data-type (list x))))
   ((equalp (subsequence x 0 2) '(double precision))
    (remove 'precision x))
   ((or
     ;;ael - added this in
     (equalp (subsequence x 0 3) '(real * 4))
     ;;ael
     (equalp (subsequence x 0 3) '(real * 8))
     )
    (append '(single-float) (subsequence x 3)))
   ((or (equalp (subsequence x 0 3) '(integer * 2))
	(equalp (subsequence x 0 3) '(integer * 4)))
    (append '(fixnum) (subsequence x 3)))
   ((eq (car x) 'real)
    (append '(single-float) (cdr x)))
   ((eq (car x) 'integer)
    (append '(fixnum) (cdr x)))
   ((and (listp (car x)) (eq (caar x) 'character))
    (append `(character ,(third (car x))) (cdr x)))
   ((and (listp (car x)) (eq (caar x) 'real))
    (append '(single-float) (cdr x)))
   ((and (listp (car x)) (eq (caar x) 'integer))
    (append '(fixnum) (cdr x)))
   ((eq (car x) 'double)
    (append '(double-float) (cdr x)))
   ((eq (car x) 'logical)
    (append t (cdr x)))
   (t x)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                reduce-data-type
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun reduce-data-type (x)
  (cond
   ((equalp (subsequence x 0 2) '(double precision))
    (remove 'precision x))
   ((or
     ;;ael - don't know why they didn't have this, although I don't see it in my
     ;;standards:
     (equalp (subsequence x 0 3) '(real * 4))
     ;;ael
     (equalp (subsequence x 0 3) '(real * 8))
     )
    (append '(real) (subsequence x 3)))
   ((or
     (equalp (subsequence x 0 3) '(complex * 16))
     ;; ael - added this at the same time - why not!
     (equalp (subsequence x 0 3) '(complex * 32))
     ;; ael
     )
    (append '(complex) (subsequence x 3)))
   ((or (equalp (subsequence x 0 3) '(integer * 2))
	(equalp (subsequence x 0 3) '(integer * 4)))
    (append '(integer) (subsequence x 3)))
   (t x)))

;=============================================================================
					; unification pattern matcher
;=============================================================================
(defun binding-value (binding) (cdr binding))

(defun variablep (v)
  (and (symbolp v)
       (char= (schar (symbol-name v) 0) #\%)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                variable-value
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun variable-value (variable bindings)
  (let ((binding (assoc variable bindings)))
    (values (binding-value binding)
            (not (null binding)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                unify
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun unify (term-1 term-2 bindings)
  (cond
   ((eq bindings 'fail) bindings)
   ((variablep term-1)
    (maybe-extend-bindings term-1 term-2 bindings))
   ((variablep term-2)
    (maybe-extend-bindings term-2 term-1 bindings))
   ((or (atom term-1)
	(atom term-2))
    (if (equal term-1 term-2)
	bindings
      'fail))
   (t (unify (cdr term-1)
	     (cdr term-2)
	     (unify (car term-1)
		    (car term-2)
		    bindings)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                match
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun match (term-1 term-2 bindings)
  (let ((new-bindings (unify  term-1 term-2 bindings)))
    (if (eq 'fail new-bindings)
	nil
      (values t  new-bindings))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         maybe-extend-bindings
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun maybe-extend-bindings (variable value bindings)
  (multiple-value-bind (present-value found?)
		       (variable-value variable bindings)
		       (if found?
			   (unify present-value
				  value
				  bindings)
					; no occurs check !
			 (acons variable value bindings))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                setsyntax
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun setsyntax (x y)
  (declare (ignore y))
  ;; ael: replacing special characters by :constituent (the value for the
  ;; letter a)
  (setf (aref *readtable* (char-int x)) (aref *readtable* (char-int #\a))))
;;ael - formerly
#|
  (set-macro-character x #'single-macro-character))

(defun single-macro-character (stream char)
  (declare (ignore stream))
  (let ((x (intern (string char)))) x))
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         set-fortran-read
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun set-fortran-read ()
  (prog (vcs)
	(setq vcs 'vsingle-character-symbol)
	(setsyntax #\, vcs)
	(setsyntax #\: vcs)
	(setsyntax #\*  vcs)
	(setsyntax #\=  vcs)
	(setsyntax #\/  vcs)
	(setsyntax #\+  vcs)
	(setsyntax #\-  vcs)
	(setsyntax #\^  vcs)
	(setsyntax #\<  vcs)
	(setsyntax #\>  vcs)
	(setsyntax #\[  vcs)
	(setsyntax #\]  vcs)
	(setsyntax #\(  vcs)
	(setsyntax #\)  vcs)
	(setsyntax #\{  vcs)
	(setsyntax #\}  vcs)
	(setsyntax #\!  vcs)
					; reserved characters:
        (setsyntax #\$  vcs)
        (setsyntax #\@  vcs)
        (setsyntax #\&  vcs)
        (setsyntax #\~  vcs)
        (setsyntax #\' vcs)
        (setsyntax #\| vcs)
        (setsyntax #\` vcs)
        (setsyntax #\\ vcs)
	(return t)))

;;ael (defun setlispread nil (setq *readtable* (copy-readtable nil)))
(defun setlispread () (old-readtable))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                lineread
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(if pre-3.52
    (defun lineread  (stream)
      "
;; I created this to work in place of the previous lineread, when
;; read-preserving-whitespace didn't exist. Since Almy's introduced it, I'm
;; back to the previous lineread. But if the version is pre-3.52, this will
;; have to be substituted for it.

;; I think that lineread is supposed to read a single line, preserving
;; whitespace, and to return it as a reversed list of characters

;; Examples:
 (lineread (make-string-input-stream 
   \"      stop
	   end\"))

 (lineread (make-string-input-stream 
   \"       print *, 'failed to close unit 7'

      stop
      end
\"))
;; (lineread (make-string-input-stream \"      Print * |,| 'hi'\"))
"
      (prog (ans rans next-char)
	    
	    loop1
	    (setq ans (cons (read stream nil 'EOF) ans))
	    
	    loop2
	    (setq next-char (peek-char nil stream nil 'EOF nil))
	    (cond ((eql next-char #\Space) ;; dumps off spaces:
		   (read-char stream nil 'EOF t) (go loop2)))
	    (cond ((member next-char '(#\Newline EOF) :test #'eql)
		   (setq rans (nreverse ans))
		   (return rans)))
	    (go loop1)))
  (defun lineread (stream)
    "
;; TAA (Almy) introduced read-preserving-whitespace, which Luke wrapped up with
;; release 3-52: thus we're back where we started!

;; Examples:
 (lineread (make-string-input-stream 
   \"      stop
	   end\"))

 (lineread (make-string-input-stream 
   \"       print *, 'failed to close unit 7'

      stop
      end
\"))
 ;; (lineread (make-string-input-stream \"      Print * |,| 'hi'\"))
"
    (prog (ans rans next-char)
	  loop1
	  (setq ans (cons
		     (read-preserving-whitespace stream nil 'EOF nil) ans))
	  loop2
	  (setq next-char (peek-char nil stream nil 'EOF nil))
	  ;; dumps off spaces:
	  (cond ((eql next-char #\Space)
		 (read-char stream nil 'EOF t) (go loop2)))
	  (cond ((member next-char '(#\Newline EOF) :test #'eql)
		 (setq rans (nreverse ans))
		 (return rans)))
	  (go loop1)))
  )

;------------------------------------------------------------------------------
(defun read-six-chars (stream)
; (make-array '(6) :element-type 'string-char :initial-contents
    (list
       (read-char stream nil 'EOF t)
       (read-char stream nil 'EOF t)
       (read-char stream nil 'EOF t)
       (read-char stream nil 'EOF t)
       (read-char stream nil 'EOF t)
       (read-char stream nil 'EOF t)))

;-----------------------------------------------------------------------------
(defun outfile (x) (open x :direction :output :if-exists :rename-and-delete))

(defun infile (x) (open x :direction :input))

(defun tyipeek (u) (peek-char nil u nil -1))

(defun const (x n)
   (prog (lis)
      (setq lis ())
      (do ((i 1 (1+ i))) ((> i n)) (setq lis (cons x lis)))
      (return lis)
      ))
;------------------------------------------------------------------------------	

(defun brackets-check (x)
  "
;; Examples:
 (brackets-check '(write (*) j))
 (brackets-check '(write (* j)))
 (brackets-check '(U(I)=(6.0*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))))))
 (brackets-check '(2 |(| I3 |)|))
"
  (prog
   (path-stack ce check-list ret-list)

   (cond
    ((and
      (not (member '|(| x)) (not (member '|)| x))
      ;;ael             (not (member '|[| x)) (not (member '|[| x))
      (not (member '|[| x)) (not (member '|]| x))
      ;;ael has to be an error...
      (not (member '|{| x)) (not (member '|}| x))) (return x))
    )

   (setq path-stack '((0 0 0)) ;;;stack-top '(0 0 0)
	 check-list x ce (car x) ret-list nil)
   loop
   (cond
    ((null check-list)
     (cond
      ((greaterp (caar path-stack) 0)
       (princ-reset
	'|Syntax error: missing right parenthesis ")"|) )
      ((greaterp (cadar path-stack) 0)
       (princ-reset
	'|Syntax error: missing right bracket "]"|) )
      ((greaterp (caddar path-stack) 0)
       (princ-reset
	'|Syntax error: missing right brace "}"|))
      (t (return ret-list)))))

   (cond
    ((equal ce '|(|)
     (push (mapcar 'plus '(1 0 0) (car path-stack)) path-stack)
     (setq ret-list (gen-append ret-list nil (caadr path-stack))))
    ((equal ce '|[|)
     (push (mapcar 'plus '(0 1 0) (car path-stack)) path-stack)
     (setq ret-list (gen-append ret-list '|[| (caar path-stack))))
    ((equal ce '|{|)
     (push (mapcar 'plus '(0 0 1) (car path-stack)) path-stack)
     (setq ret-list (gen-append ret-list '|{| (caar path-stack))))
    ((and (equal ce '|)|) (or (nequal (mapcar 'diff (pop path-stack) '(1 0 0))
				      (car path-stack))
                              (lessp (caar path-stack) 0)))
     (princ-reset
      '|Syntax error: right parenthesis ")" in an invalid position or unmatched|))
    ((equal ce '|)|))
    ((and (equal ce '|]|) (or (nequal (mapcar 'diff (pop path-stack) '(0 1 0))
				      (car path-stack))
                              (lessp (caar path-stack) 0)))
     (princ-reset
      '|Syntax error: right bracket "]" in an invalid position or unmatched|))
    ((equal ce '|]|)
     (setq ret-list (gen-append ret-list ce (caar path-stack))))
    ((and (equal ce '|}|) (or (nequal (mapcar 'diff (pop path-stack) '(0 0 1))
				      (car path-stack))
                              (lessp (caar path-stack) 0)))
     (princ-reset
      '|Syntax error: right brace "}" in an invalid position or unmatched|))
    ((equal ce '|]|)
     (setq ret-list (gen-append ret-list ce (caar path-stack))))
    (t (setq ret-list (gen-append ret-list ce (caar path-stack))))

    )

   (setq check-list (cdr check-list) ce (car check-list))
   (go loop)))

;-----------------------------------------------------------------------------
(defun subsequence (seq start &optional (end (length seq)))
  (if (null seq) seq
                 (subseq seq start (min end (length seq)))))

;-----------------------------------------------------------------------------
(defun gen-append (lis x n)
  (cond ((equal n 0) (append1 lis x))
	(t (append1 (end-cdr lis) (gen-append (car (last lis)) x
					      (sub1 n))))))

(defun append1 (l x) (append l (list x)))
(defun plus (&rest args) (apply #'+ args))
(defun end-cdr (x) (butlast x))
(defun sub1 (x) (1- x))
(defun nequal (x y) (not (equal x y)))
(defun diff (x y) (- x y))
(defun lessp (x y) (< x y))
(defun greaterp (x y) (> x y))
;==============================================================================


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                f-to-l
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun f-to-l(file) (fortran-to-lisp (preprocess file) "temp"))


; f2cl2.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Hamilton, New Zealand 92-95 - all rights reserved;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; functions
;	id-expression
;	parse
;	expression-preparse
;	inner-preparse
;	id-assignment
;	comma-sep-listp  - within scope of restrict non-local
;	symbol-listp
;	id-term
;	id-factor
;       id-factor1
;	gen-list-split
;       id-expression-list-ifthen
;	id-array-store - check args eval to integers in range at eval time
;	restore-negative-numbers
;------------------------------------------------------------------------------
(print "f2cl2.l")
(in-package :user)
(eval-when (compile load eval)
 (proclaim '(optimize (speed 3) (safety 1)))

 (proclaim '(special f-store arg-store exp-store var-store init-store
                  next-user-function-address lis-store end-store step-store
                  body-store intrinsic_function_names external_function_names
                  subprog_name subprog_stmt_fns)))
;-----------------------------------------------------------------------------
; subst-splice substitutes the list b for the atom a in the list c via splicing
(defun subst-splice (b a c)
  (cond ((atom c) c)
        ((equal (car c) a) (append b (subst-splice b a (cdr c))))
        (t (cons (subst-splice b a (car c)) (subst-splice b a (cdr c))))))
;-----------------------------------------------------------------------------

(defun extract (alpha beta)
  (prog (retlist)
    (setq retlist nil)
    loop
    (cond ((null beta) (return retlist))
          ((member (car beta) alpha)
           (setq retlist (append1 retlist (car beta))
                 beta (cdr beta))
           (go loop))
          (t (setq beta (cdr beta))
           (go loop)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                list-itp
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun list-itp (lis signs)
  "ael:
;; used in
id-expression
id-factor1
id-term
"
  (cond
   ((member nil lis)
    ;;ael (princ-reset '|f2cl error: failure to parse an expression|)
    (if (neq lis '(nil))
	(format t "|f2cl error: failure to parse an expression|~%in list-itp
arguments
lis   = ~s
signs = ~s
" lis signs)
      )
    )
   )
  (prog (ret)
	(cond ((equal signs nil) (return (car lis))))
	(setq signs (subst 'f2cl/ '/ signs))
	(setq ret (list (car signs) (car lis) (cadr lis)))
	(setq lis (cdr lis))
	loop
	(setq lis (cdr lis))
	(setq signs (cdr signs))
	(cond ((null (car signs)) (return ret))
	      (t (setq ret (list (car signs) ret (car lis)))
		 (go loop)))))

(defun tpl-subst (x y lis)
   (cond
         ((null lis) nil)
         ((equal y (car lis))
           `(,x ,@(tpl-subst x y (cdr lis))))
         (t `(,(car lis) ,@(tpl-subst x y (cdr lis))))))

(defun tpl-subpair (lx ly lis)
   (prog (elx ely restx resty ret)
    (setq elx (car lx) ely (car ly) restx (cdr lx) resty (cdr ly) ret lis)
    loop
    (setq ret (tpl-subst elx ely ret))
    (cond ((null restx) (return ret)))
    (setq elx (car restx) ely (car resty) restx (cdr restx) resty (cdr resty))
    (go loop)))


;-----------------------------------------------------------------------------
(defun symbol-listp (x) (and (listp x) (symbolp (car x)) (null (cdr x))))

;------------------------------------------------------------------------------
(defun check-tags-go (x)
  (prog (tags gos)
   (setq tags (mapcar #'car (delete nil (mapcar #'(lambda (y) (cond ((symbol-listp y) y)
                                                     (t nil))) x))))
   (setq gos (mapcar #'car (find-gos x)))

   (return
    (cond ((eq (length tags) (length (unique-elements (append gos tags)))) t)
          (t nil)))))
;------------------------------------------------------------------------------
(defun find-gos (x)
 (cond ((atom x) nil)
       ((eq (car x) 'go)
        (cond ((null (symbol-listp (cadr x)))
               (princ-reset
'|f2cl error: the argument to a program "go" must be a valid tag.
Tag being parsed:| (cadr x))))
        (list (cadr x)))
       (t (append (find-gos (car x)) (find-gos (cdr x))))))

;------------------------------------------------------------------------------

; this didn't solve the fortify problem:
 (defun restore-negative-numbers (x)
  (prog (rest ret next)
   (cond ((not (memberq '- x)) (return x)))
   (setq rest x)
   loop
   (cond ((null rest) (return (reverse ret))))
   (setq next (car rest) rest (cdr rest))
   (cond ((and (eq '- next) (numberp (car rest)))
          (setq ret (cons (minus (car rest)) (cons '+ ret))
                    rest (cdr rest)))
         (t (setq ret (cons next ret))))
     (go loop)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-expression
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-expression (larg)
  "
zzz
	I'm doing some work here, to get calls to undeclared functions (passed
to subroutines) replaced by (funcall fx ...) rather than (fx ...)

;; Examples:
 (id-expression '(line ( i |,| j ) ))
"
  (prog (x y l)
	(setq l (subst-splice '(+ -1 *) '- larg))
	(cond
	 ((eq (car l) '+) (setq l (cdr l)))
	 ((eq (car l) '-)
	  (setq l (cons 0 l))))
	(setq x (list-split-multi '+ l))
	(setq x (list x (extract '(+ -) l)))
	(setq y (list-itp (mapcar #'id-term (car x)) (cadr x)))
	;;ael - at this point, we end up returning (fx x). We need to ask if fx
	;;is a known function - intrinsic, or defined.
	;;This needs to be made recursive. What do you mean ael? andy.
	(if (and (listp y) (symbolp (first y)))
	    (let ((sym (first y)))
	      (if (member sym
			  (remove nil
				  (combine
				   function-arg-list
				   subroutine-arg-list
				   external_function_names)))
		  (let ()
		    (print (list 'replacing
				 (first y)
				 'by
				 '(funcall ...)
				 'in-id-expression
				 subroutine-arg-list
				 function-arg-list
				 ))
		    (setq y (append (list 'funcall) y))
		    )
		)
	      )
	  )
	;;ael
	(return y)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-term
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-term (l)
  (prog (x)
	(setq x (apply #'append (mapcar #'(lambda (x) (list-split-bin '/ x))
					(list-split-multi '* l))))
	(setq x (list x (extract '(* /) l)))
	(if (and (equal (caar x) '(-1)) (equal (cadr x) '(*)))
	    (return `(- ,(id-factor1 (cadar x)))))
	(return (list-itp (mapcar #'id-factor1 (car x))
			  (cadr x)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-factor1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-factor1 (l)
  "
;; Examples:
 (id-factor1 '(f2cl_false))
 (id-factor1 '(ok))
 (id-factor1 '(-1.0e%3))
"
  (prog (x)
	(setq x (list-split-bin '^ l))
	(setq x (list x (extract '(^) l)))
	(return (list-itp (mapcar #'id-factor (car x))
			  (subst 'expt  '^ (cadr x))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-factor
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-factor (l)
  "
ael: things have to pass through id-factor if we want to strip off the e%
that we introduced. The following

           IF(R.GT.1.0E-20) THEN
                DELTA=.84*(TOL/R)**.25
           ELSE
                DELTA=10.0
           END IF

	led to

      (1.0e%20 0.0)

being identified as a local variable! The if statement got translated
properly...

 (id-factor '(f2cl_false))
 (id-factor '(ok))
"
   (cond
    ;; ((null l) nil)

    ;; number:
    ((numberp l) l)

    ;; string:
    ((stringp l) l)

    ;; x.xE%x (scientific notation) number - % is used to represent a minus sign:
    ((and (symbolp l)
	  (string-equal
	   (string-trim '(#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\.)
			(string l))
	   "E%"))
     (setq l
	   (read-from-string
	    (concatenate
	     'string
	     (string-right-trim
	      '(#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\%) l)
	     "-"
	     (string-left-trim
	      '(#\%)
	      (string-left-trim
	       ;;ael added #\e:
	       '(#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\. #\E #\e)
	       ;;lea
	       l)))))
     l)

    ;; symbol:
    ((symbolp l)
     (cond
      ;;ael - external function
      ((member l external_function_names)
       `(function ,l)
       )
      ;;lea
      ;;ael - external function
      #|
      ((member l '(f2cl_false f2cl_true))
       l
       )
|#
      ;;lea
      (t
       (check-t-and-pi l))))

    ;;number:
    ((and (null (cdr l)) (numberp (car l))) (car l))

    ;; bracketed symbol or string:
    ((and (null (cdr l)) (or (symbolp (car l)) (stringp (car l))))
     (id-factor (car l)))

    ;; function of no variables:
    ((and (symbolp (car l)) (eq nil (cadr l)))
     (list (car l)))

    ;; boolean expression:
    ((intersection l '(NOT EQUAL AND OR < > <= >= ><))
     (id-logical l))

    ;; intrinsic function call:
    ((and (symbolp (car l))
	  (listp (cadr l))
	  (member (car l) intrinsic_function_names))
     (cond ((not (null (cddr l))) (princ-reset
'|f2cl error: missing +, *, /, or ^ operator following a function call.| l)))
     (cons (if (eq (car l) 'char) 'fchar (car l)) ;special case intrinsic "char"
	   (mapcar #'id-expression
                   (list-split '|,| (cadr l)))))

    ;; array reference:
    ((and (symbolp (car l)) (listp (cadr l)) (vble-is-array-p (car l)))
     (cond ((not (null (cddr l)))
	    (princ-reset
    '|f2cl error: missing +, *, /, or ^ operator following a function call.| l)))
     ;;ael     (append (list 'fref (car l))
     (append (list 'fref (check-t-and-pi (car l)))
	     ;;lea
	     (mapcar #'id-expression
		     (list-split '|,| (cadr l)))))

    ;; function call:
    ((and (symbolp (car l)) (listp (cadr l)))
     (cond ((member (car l) external_function_names)
	    `(funcall ,(car l)
		      ,@(mapcar #'id-expression (list-split '|,| (cadr l)))))
	   (t
	    `(,(car l) ,@(mapcar #'id-expression (list-split '|,| (cadr l)))))))
    #|
;;;                ((member (car l) subprog_stmt_fns)
;;;                 `(,(read-from-string
;;;                       (concatenate 'string (princ-to-string subprog_name)
;;;                                            (princ-to-string (car l))))
;;;                   ,@(mapcar #'id-expression (list-split '|,| (cadr l)))))
|#
							
    ;; expression:
    ((and (listp (car l)) (null (cdr l)))
     (id-expression (car l)))

    ;; complex number:
    ((and (eq (length l) 3) (eq (second l) '|,|))
     (list 'complex (id-factor (first l)) (id-factor (third l))))

    ;; ael - it's a rread statement
    ((eq (first l) 'rread)
     (andy-print (list 'id-factor 'rread l))
     l
     )

    ;; error dropping out the bottom:
    (t
     (princ-reset '|f2cl syntax error| l))
    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                comma-sep-symb-listp
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; (a0 |,| a1 |,| a2 ..... |,| an) is checked:
(defun comma-sep-symb-listp (l)
 (prog (rest)
  (cond
   ((and
         (listp l)
         (neq '|,| (car l))
         (every #'symbolp l)
         (evenp (length (cdr l)))))
   (t (return nil)))
  (setq rest (cdr l))
  loop
  (cond ((null rest) (return t)))
  (cond ((or (neq (car rest) '|,|)
             (eq (cadr rest) '|,|))
          (princ-reset
'|f2cl syntax error: failure to parse the parameter list of a function
definition.| l) ))
  (setq rest (cddr rest))
  (go loop)))

;------------------------------------------------------------------------------

; (a0 |,| a1 |,| a2 ..... |,| an) is checked where a0 are anything :
(defun comma-sep-listp (l)
 (prog (rest)
  (cond
   ((and
         (listp l)
         (neq (car l) '|,|)
         (evenp (length (cdr l)))))
   (t (return nil)))
  (setq rest (cdr l))
  loop
  (cond ((null rest) (return t)))
  (cond ((or (neq (car rest) '|,|)
             (eq (cadr rest) '|,|))
          (princ-reset
'|f2cl syntax error: failure to parse a list.| l) ))
  (setq rest (cddr rest))
  (go loop)))

;------------------------------------------------------------------------------
; end of f2cl2.l


; f2cl3.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Copyright (c) University of  Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Hamilton, New Zeland 1992-95 - all rights reserved;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; pattern matching for the syntax checker

; functions:
;	restrict-test
;	exact-match
;	match-atoms
;	match-atoms-lists
;	match-store-atoms
;       match-store - for atoms and lists
;	match-restrict - restricts atoms and matches for lists
;             - to use insert (restrict >var predicate) instead of >var or >
;	atomcar, atomcdr
;	match-separated - matches (a1 s1 a2 s2 ...... an) where the si are
;	      separators , it delivers a list of two lists, the first being
;	      a list of lists of the ai and the second a list of the separators
;	      or returns nil if an ai is missing - this could be used to
;	      produce a syntax error.
;-----------------------------------------------------------------------------
(print "f2cl3.l")
(in-package :user)

;(declare (localf atomcar atomcdr))

(defun sub-string (x index &optional len)
  (cond ((null len) (subsequence x (sub1 index) (length x)))
        (t (subsequence x (sub1 index) (min (sub1 (+ index len)) (length x)) ))))

(defun match-separated (separators lis)
  (prog (ret)
  (setq ret (gen-list-split separators lis))
    (cond ((member nil (car ret)) (return nil))
          (t (return ret)))))

; exact match
(defun exact-match (p d)
   (cond ((and (null p) (null d)) t)  ; have we reached the end ?
         ((equal (car p) (car d))    ; check the first elements
                                     ; if not the same return nil
          (exact-match (cdr p) (cdr d)))))    ; recurse if the same


; match ">" against any atom
; we need a preliminary check to return nil if one list is shorter
(defun match-atoms (p d)
      (cond ((and (null p) (null d)) t)
            ((or (null p) (null d)) nil)   ; is one list shorter ?
            ((or (equal (car p) '>)
                 (equal (car p) (car d)))
             (match-atoms (cdr p) (cdr d)))))

; incorporate the feature of allowing "+" to match against any number of atoms
(defun match-atoms-lists (p d)
      (cond ((and (null p) (null d)) t)
            ((or (null p) (null d)) nil)
            ((or (equal (car p) '>)
                 (equal (car p) (car d)))
             (match-atoms-lists (cdr p) (cdr d)))
            ((equal (car p) '+)                 ; first element + ?
             (cond ((match-atoms-lists (cdr p) (cdr d)))   ; drop +
                   ((match-atoms-lists p (cdr d)))))))           ; keep +


; bind matched atoms to A etc if the pattern has >A
(defun atomcar (a) (nthchar a 1))
(defun atomcdr (a) (concaten (sub-string (symbol-name a) 2)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                match-store-atoms
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun match-store-atoms (p d)
  (cond
   ((and (null p) (null d)) t)
   ((or (null p) (null d)) nil)
   ((or (equal (car p) '>)
	(equal (car p) (car d)))
    (match-store-atoms (cdr p) (cdr d)))
   ((and (equal (atomcar (car p)) '>)  ; check for >a
	 (match-store-atoms (cdr p) (cdr d)))
    (set (atomcdr (car p)) (car d)) t) ; bind the pattern variables
					; value to the matched atom
   ((equal (car p) '+)
    (cond ((match-store-atoms (cdr p) (cdr d)))
	  ((match-store-atoms p (cdr d)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                match-store
;;
;; bind matched groups of atoms to B if the pattern has +B
;; the eval obtains the list of atoms seen so far and the cons adds the atom
;; matched at the current level
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun match-store (p d)
  (cond ((and (null p) (null d)) t)
	((or (null p) (null d)) nil)
	((or (equal (car p) '>)
	     (equal (car p) (car d)))
	 (match-store (cdr p) (cdr d)))
	((and (equal (atomcar (car p)) '>)
	      (match-store (cdr p) (cdr d)))
	 (set (atomcdr (car p)) (car d)) t)
	((equal (car p) '+)
	 (cond ((match-store (cdr p) (cdr d)))
	       ((match-store p (cdr d)))))
	((equal (atomcar (car p)) '+)
	 (cond ((match-store (cdr p) (cdr d))
		(set (atomcdr (car p)) (list (car d))) t) ; building begins
	       ((match-store p (cdr d))
		(set (atomcdr (car p))
		     (cons (car d) (eval (atomcdr (car p))))) t)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          restrict-test
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun restrict-test (predicates argument)
  (prog
   ()
   loop
   (cond ((null predicates) (return t)))   ; all tests t?
   (cond ((funcall (car predicates) argument) ; this test t?
	  (setq predicates (cdr predicates))
	  (go loop))                         ; then repeat
	 (t (return nil)))))                ; else fail

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                match-restrict
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun match-restrict (p d)
  (cond
   ((and (null p) (null d)) t)
   ((or (null p) (null d)) nil)
   ;; restricted >
   ((and (not (atom (car p)))
	 (equal (caar p) 'restrict)
	 (equal (cadar p) '>)
	 (restrict-test (cddar p) (car d)))
    (match-restrict (cdr p) (cdr d)))
   ;; restricted >var
   ((and (not (atom (car p)))
	 (equal (caar p) 'restrict)
	 (equal (atomcar (cadar p)) '>)
	 (restrict-test (cddar p) (car d))
	 (match-restrict (cdr p) (cdr d)))
    (set (atomcdr (cadar p)) (car d))
    t)
   ;; equality or >
   ((or (equal (car p) '>)
	(equal (car p) (car d)))
    (match-restrict (cdr p) (cdr d)))
   ;; >var
   ((and (atom (car p))
	 (equal (atomcar (car p)) '>)
	 (match-restrict (cdr p) (cdr d)))
    (set (atomcdr (car p)) (car d))
    t)
   ;; +
   ((equal (car p) '+)
    (cond ((match-restrict (cdr p) (cdr d)))
	  ((match-restrict p (cdr d)))))
   ;; +var
   ((and (atom (car p)) (equal (atomcar (car p)) '+))
    (cond ((match-restrict (cdr p) (cdr d))
	   (set (atomcdr (car p)) (list (car d)))
	   t)
	  ((match-restrict p (cdr d))
	   (set (atomcdr (car p))
		(cons (car d) (eval (atomcdr (car p)))))
	   t)))))

;;; f2cl4.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Hamilton, New Zealand 1992-95 - all rights reserved;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;----------------------------------------------------------------------------
; functions:
;	id-logical
;	id-logical-and
;	id-logical-not
;	id-relational
;	memberq
;-----------------------------------------------------------------------------
(print "f2cl4.l")
(in-package :user)
(defun memberq (x l) (member x l :test #'eq))

(defun id-logical (l)
   (cond ((member 'or l)
          `(or ,@(mapcar #'id-logical-and (list-split-multi 'or l))))
         (t (id-logical-and l))))

(defun id-logical-and (l)
   (cond ((member 'and l)
          `(and ,@(mapcar #'id-logical-not (list-split-multi 'and l))))
         (t (id-logical-not l))))

(defun id-logical-not (l)
     (cond ((equal (car l) 'not)
            `(not ,(id-relational (cdr l))))
           (t (id-relational l))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                id-relational
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun id-relational (l)
  (prog
   (lhs rhs tmplist)
   (return
    (cond

     ;; true and false
     ((equal l '(f2cl_true)) t)
     ((equal l '(f2cl_false)) nil)

     ;; bracketed logical expression:
     ((and (listp (car l)) (null (cdr l)))
      (id-logical (car l)))

     ;; logical equivalence
     ((memberq 'logeqv l)
      (setq tmplist (list-split 'logeqv l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      ;;ael             `(logeqv ,lhs ,rhs))
      `(equalp ,lhs ,rhs))
     ;;ael

     ;; logical non-equivalence
     ((memberq 'logxor l)
      (setq tmplist (list-split 'logxor l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      ;;ael             `(logxor ,lhs ,rhs))
      `(not (equalp ,lhs ,rhs)))
     ;;ael

     ;; greater than or equal:
     ((memberq '|>=| l)
      (setq tmplist (list-split '|>=| l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(>= ,lhs ,rhs))

     ;; less than or equal:
     ((memberq '|<=| l)
      (setq tmplist (list-split '|<=| l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(<= ,lhs ,rhs))

     ;; equality:
     ((memberq 'EQUAL l)
      (setq tmplist (list-split-bin 'EQUAL l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(= ,lhs ,rhs))

     ;; ael: added this, as I'm replacing logeqv with equalp:
     ;; equality:
     ((memberq 'EQUALP l)
      (setq tmplist (list-split-bin 'EQUALP l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(equalp ,lhs ,rhs))

     ;; not equal:
     ((memberq '|><| l)
      (setq tmplist (list-split '|><| l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(/= ,lhs ,rhs))

     ;; less than:
     ((memberq '< l)
      (setq tmplist (list-split-bin '< l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(< ,lhs ,rhs))

     ;; greater than:
     ((memberq '> l)
      (setq tmplist (list-split-bin '> l))
      (setq lhs (id-expression (car tmplist)))
      (setq rhs (id-expression (cadr tmplist)))
      `(> ,lhs ,rhs))

     ;; bracketed logical:
     ((and (listp (car l)) (null (cdr l)))
      (id-logical (car l)))
     (t
      (parse-expression l))
     ))))

; f2cl5.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Hamilton, New Zealand 1992-95 - all rights reserved;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;functions:
; declaration insertion
;      check_new_vbles
;      insert-declarations
;      make-initialisation
;      make-declaration
;      make-char-decl
;      make-char-init
;      get-implicit-type
;      get_array_type
;      default-int-p
;      vble-is-array-p
;      sym-is-fun-name
;      make-special-proclamation
;      make-special-var-decl
;      check-t-and-pi
; structured stmt fix
;      fix-structure
;      fix-ifthen
;      end-do-p
;      label-matches-dolabel-p
;      fix-do
;      fix-tagbodies
;      remove-prefix
;      multiple-do-labelp
; FORMAT parsing
;      parse-format
;      parse-format1
;      parse-write
;      parse-format-descriptor-list
;      fixnum-string
;      parse-format-descriptor-I
;      parse-format-descriptor-F
;      parse-format-descriptor-E
;      parse-format-descriptor-G
;      parse-format-descriptor-/
;      parse-format-descriptor-TR
;      parse-format-descriptor-X
;      parse-format-descriptor-S
;      parse-default-format-descriptor
;      fix-slashes

;-----------------------------------------------------------------------------
;; ael: this appeared to have been commented out (f2cl5.l):
(print "f2cl5.l")
(in-package :user)
; functions for setting up varaible declarations and initialisations
(eval-when (compile load eval)
(proclaim '(special keywords intrinsic_function_names external_function_names
                    declared_vbles undeclared_vbles key_params save_vbles
                    explicit_vble_decls implicit_vble_decls common_array_dims
                    subprog_common_vars program-flag
                    subprog_stmt_fns subprog_stmt_fns_bodies
		    )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                check_new_vbles
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun check_new_vbles (prog_list)
  (do
   ((exprs prog_list (cdr exprs))
    (vble_list
     nil
     (append vble_list
	     (cond ((listp (car exprs))
		    (check_new_vbles (car exprs)))
		   ((or (not (symbolp (car exprs)))
			(numberp (car exprs))
			(member (car exprs)
				'(\, \' + - * / ** // ^ = EQUAL > < >= <= ><))
			(member (car exprs) keywords)
			(member (car exprs) intrinsic_function_names)
			(member (car exprs) key_params :key #'car)
			(member (car exprs) external_function_names)
			(member (car exprs) declared_vbles)
			(member (car exprs) undeclared_vbles)
			(sym-is-fun-name exprs))
		    nil)
		   ;; special case of error messages
		   ((eq (car exprs) 'PAUSE) (return prog_list))
		   (t (setq undeclared_vbles
			    (cons (car exprs) undeclared_vbles)))))))
   ((null exprs) prog_list)))

(setq keywords
      '(ASSIGN
	IF THEN GO TO GOTO CALL CONTINUE DO FDO ELSE RETURN
	STOP PRINT READ WRITE BACKSPACE CLOSE ENDFILE INQUIRE
	OPEN REWIND FORMAT AND OR NOT))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                insert-declarations
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun insert-declarations (fort-fun)
  (prog (defun-bit arglist prog-bit formal-arg-decls common_var_decls
          local-vbles vble-decls body special-proclamation)
	(setq defun-bit (list (car fort-fun) (cadr fort-fun))
	      arglist (caddr fort-fun)
	      body (cdddr fort-fun))
	(setq undeclared_vbles
	      (set-difference undeclared_vbles subprog_common_vars))
	(setq special-proclamation
	      (make-special-proclamation subprog_common_vars))
	(setq common_var_decls
	      (mapcar #'make-special-var-decl subprog_common_vars))
	(setq formal-arg-decls
	      (append
               (mapcar
		#'(lambda
		    (vble)
		    (prog
		     (decl)
		     (setq decl (make-declaration vble :vble-is-formal-arg t)
			   declared_vbles (remove vble declared_vbles)
			   undeclared_vbles (remove vble undeclared_vbles))
		     (return decl)))
		(set-difference arglist external_function_names))
               (mapcar #'(lambda (param)
                           (make-declaration (car param)))
                       key_params)))
	(setq local-vbles
	      (mapcar
	       #'make-initialisation
	       ;; ael - remove-if is not working as the creators intended,
	       ;; I discover: remove-if requires a t answer,
	       ;; not just a list, say, which is what member returns: thus,
	       (remove-if
		#'(lambda (x)
		    (if (or (member x save_vbles)
			    ;; ael - added these just for fun: which will teach
			    ;; me to do something just for fun. If a user
			    ;; declares an array as t, e.g. t(4), then this
			    ;; prevents it from being initialized!
			    ;; (member x '(t nil pi F2CL_TRUE F2CL_false
			    ;; for the others, I think we're pretty safe that
			    ;; folks won't use them as array names... but don't
			    ;; bet on it!
			    (member x '(nil pi F2CL_TRUE F2CL_false
					  LOGXOR LOGEQV))
			    ;; lea
			    (member x key_params :key #'car))
			t
		      ))
		(set-difference (append declared_vbles undeclared_vbles)
				subprog_common_vars))))

	(setq vble-decls
	      (mapcar
	       #'(lambda
		   (vble)
		   (make-declaration vble :vble-is-formal-arg nil))
	       (set-difference (append (set-difference declared_vbles
						       (mapcar #'car key_params))
				       undeclared_vbles)
			       subprog_common_vars)))
	(setq arglist (mapcar #'check-t-and-pi arglist)
	      key_params (mapcar #'(lambda (x)
				     (list (check-t-and-pi (car x)) (cadr x)))
                                 key_params)
	      arglist (append arglist
			      (if key_params (append '(&key) key_params)))
	      prog-bit (if subprog_stmt_fns
			   ;;ael: I changed make-labels-form, to have a tagbody
			   ;;follow labels - this because labels doesn't
			   ;;support tags, which was the impetus behind using
			   ;;prog. Thus it is now
			   ;; prog - labels - tagbody:
			   ;;ael (make-labels-form local-vbles vble-decls body)
			   `(prog ,local-vbles ,@vble-decls
				  (labels ,subprog_stmt_fns_bodies
					  (tagbody ,@body)))
			 ;; otherwise, just prog:
                         `(prog ,local-vbles ,@vble-decls ,@body))
	      ;; ael - okay, let's introduce the usual streams, units numbered
	      ;; 1 to 99. The point is to a local I/O definition, so that we
	      ;; can clean up (using unwind-protect) at the end (that is, close
	      ;; all open streams). I/O will have to be explicitly added to the
	      ;; open and close macros, I suppose, and I have to define the
	      ;; clean-up-I/O function.
	      prog-bit `(let ((I/O (make-array 100)))
			  (unwind-protect
			      ,prog-bit
			    (clean-up-I/O I/O)
			    )
			  )
	      ;;lea
	      )
	;;lea
	
	;; construct the function
	(if save_vbles
	    (return
             (append
	      '(defvar)
	      (list (cadr defun-bit))
	      (if special-proclamation (list special-proclamation))
	      `((let ,(mapcar #'make-initialisation save_vbles)
		  #'(lambda ,arglist
		      ,@formal-arg-decls
		      ,@common_var_decls
		      ,prog-bit)))))
          (return
	   (append
	    defun-bit
	    `(,arglist)
	    (if special-proclamation (list special-proclamation))
	    formal-arg-decls
	    common_var_decls
	    `(,prog-bit))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make-initialisation
;;
;; given vble return (vble init-value)
;; for prog arglist
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-initialisation (vble)
  (prog
   (vble_name type decl1 decl2)
   (setq vble_name (check-t-and-pi vble))
   (return
    (cond ;check for vble with two declarations i.e. an array
     ((setq decl1
	    (member
	     vble
	     (cdr (setq decl2 (member vble explicit_vble_decls :key #'caadr)))
	     :key #'caadr))
      (setq decl1 (car decl1) decl2 (car decl2))
      (if (eq (car decl1) 'ARRAY)
	  `(,vble_name ,(make_make-array_stmt (cdadr decl1) (car decl2)))
	`(,vble_name ,(make_make-array_stmt (cdadr decl2) (car decl1)))))
     ;; check for declared variable
     ((member vble declared_vbles)
      (do
       ((type-clauses explicit_vble_decls (cdr type-clauses))
	(decl nil))
       ((null type-clauses) )
       (setq type (caar type-clauses))
       (cond ((and (listp type) (eq (car type) 'CHARACTER))
	      (if (setq decl (member vble (cdar type-clauses) :key #'car))
		  (return `(,vble_name ,(make-char-init (car decl) type)))))
	     ((eq type 'ARRAY)
	      (if (setq decl (member vble (cdar type-clauses) :key #'car))
		  (return
		   `(,vble_name
		     ,(make_make-array_stmt (cdar decl)
					    (get_array_type (caar decl) nil))))))
	     ((eq type 'LOGICAL)
	      (if (setq decl (member vble (cdar type-clauses) :key #'car))
		  (return
		   (if (cdar decl)
		       `(,vble_name ,(make_make-array_stmt (cadar decl) t))
		     `(,vble_name nil)))))
	     (t (if (setq decl (member vble (cdar type-clauses) :key #'car))
		    (return
		     (if (cdar decl)
			 `(,vble_name ,(make_make-array_stmt (cdar decl) type))
		       `(,vble_name ,(if (eq type 'fixnum) 0 0d0)))))))))
     (t
      (if (setq type (get-implicit-type vble))
	  `(,vble_name ,(cond ((eq type 'fixnum) 0)
			      ((eq type 'single-float) 0d0)
			      ((eq type 'double-float) 0d0)
			      ((eq type 'complex) '(complex 0 0))
			      ((and (listp type)
				    (eq (car type) 'character))
			       (make-char-init (list vble) type))
			      (t nil)))
	(if (default-int-p vble)
	    `(,vble_name 0)
	  `(,vble_name 0d0))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make_make-array_stmt
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make_make-array_stmt (dimens type)
  (list 'make-array
	(append '(list)
		(mapcar #'(lambda (x)
			    (cond ((member '* x) '*)
				  ((eq (car x) 1) (cadr x))
				  ((not (member nil (mapcar #'numberp x)))
				   (1+ (- (cadr x) (car x))))
				  (t `(1+ (- ,(cadr x) ,(car x))))))
			dimens))
	':element-type (list 'quote type)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make-labels-form
;;
;; create a labels form for when statement functions are present
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-labels-form (local-vbles vble-decls body)
  ;;ael:
  #| labels doesn't permit the use of go labels!
  `(prog ,local-vbles ,@vble-decls
	 (labels ,subprog_stmt_fns_bodies ,@body)))
|#
  `(prog ,local-vbles ,@vble-decls
	 (labels ,subprog_stmt_fns_bodies (tagbody ,@body))))
;;lea

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make-declaration
;;
;; make a declaration for vble which may or may not be a formal arg
;; vble_name is used to replace vbles called T with T_
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-declaration (vble &key vble-is-formal-arg)
  (prog
   (vble_name type decl1 decl2)
   (setq vble_name (check-t-and-pi vble))
   (return
    (cond ;check for vble with two declarations i.e. an array
     ((setq decl1
	    (member vble (cdr (setq decl2 (member vble explicit_vble_decls :key
						  #'caadr))) :key #'caadr))
      (setq decl1 (car decl1) decl2 (car decl2))

      (return (if (eq (car decl1) 'ARRAY)
		  `(declare (type (simple-array ,(car decl2) ,(cdadr decl1))
				  ,vble_name))
		`(declare (type (simple-array ,(car decl1) ,(cdadr decl2))
				,vble_name)))))
     ;; check for declared variable
     ((member vble declared_vbles)
      (do ((type-clauses explicit_vble_decls (cdr type-clauses))
	   (decl nil))
	  ((null type-clauses) )
	  (setq type (caar type-clauses))
	  (cond ((and (listp type) (eq (car type) 'CHARACTER))
		 (if (setq decl (member vble (cdar type-clauses) :key #'car))
		     (return (make-char-decl (car decl) type))))
		((eq type 'ARRAY)
		 (if (setq decl (member vble (cdar type-clauses) :key #'car))
		
		     (return `(declare
			       (type (simple-array
				      ,(get_array_type (caar decl)
						       vble-is-formal-arg)
				      ,(mapcar #'(lambda (x)
						   (declare (ignore x)) '*)
					       (cdar decl)))
				     ,vble_name)))))
		((eq type 'LOGICAL)
		 (if (setq decl (member vble (cdar type-clauses) :key #'car))
		     (return
		      (if (cdar decl)
			  `(declare (type (simple-array t ,(cadar decl))
					  ,vble_name))
			`(declare (type t ,vble))))))
		(t (if (setq decl (member vble (cdar type-clauses) :key #'car))
		       (return
			(if (cdar decl)
			    `(declare
			      (type (simple-array
				     ,type
				     ,(mapcar #'(lambda (x)
						  (declare (ignore x)) '*)
					      (cdar decl)))
				    ,vble_name))
			  `(declare (type ,type ,vble_name)))))))))
     ;; check implicitly declared variable
     ((and (not vble-is-formal-arg) (setq type (get-implicit-type vble)))
      (if (and (listp type) (eq (car type) 'CHARACTER))
	  (make-char-decl (list vble_name) type)
	`(declare (type ,type ,vble_name))))
     ;; otherwise use default declaration
     (t (if (default-int-p vble)
	    `(declare (type fixnum ,vble_name))
	  `(declare (type single-float ,vble_name))))))))

(defun make-char-decl (decl type)
  (cond
   ((null (cdr decl)) ; scalar, no length spec.
    (if (equal (cadr type) '(*))
	`(declare (type (simple-array string-char (*)) ,(car decl)))
      `(declare (type (simple-array string-char (,(cadr type))) ,(car decl)))))
   ((atom (cadr decl)) ; scalr, length spec.
    `(declare (type (simple-array string-char (,(cadr decl))) ,(car decl))))
   ((cddr decl) ; array with length spec
    `(declare (type (simple-array t (,(caadr decl))) ,(car decl))))
   ((equal (cadr decl) '(*)) ; unspecified length spec
    `(declare (type (simple-array string-char (*)) ,(car decl))))
   (t ; array, no length spec.
    `(declare (type (simple-array t (1)) ,(car decl))))))

(defun make-char-init (decl type)
  (cond

   ((null (cdr decl)) ; scalar, no length spec.
    `(make-array '(,(cadr type)) :element-type 'string-char))

   ((atom (cadr decl)) ; scalr, length spec.
    `(make-array '(,(cadr decl)) :element-type 'string-char))

   ((cddr decl) ; array with length spec
    ;;ael
    ;; `(make-array ',(remove '|,| (cadr decl)) :element-type
    ;;		 '(simple-array string-char '(,(caddr decl)))))
    `(make-array (list ,@(remove '|,| (cadr decl)) :element-type
		       '(simple-array string-char '(,(caddr decl))))))
   ;;ael	

   ((equal (cadr decl) '(*)) ; unspecified length spec
    "")

   (t ; array, no length spec.
    ;;ael
    ;; `(make-array ',(remove '|,| (cadr decl)) :element-type
    `(make-array (list ,@(remove '|,| (cadr decl))) :element-type
		       ;;ael
		       '(simple-array string-char ',(cdr type)))
    )
   )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                get-implicit-type
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-implicit-type (vble)
  "
;; Examples:
 (get-implicit-type 'vble)
 (get-implicit-type 'le)
"
  (do ((decls implicit_vble_decls (cdr decls))
       (vble-str (string vble)))
      ((null decls) nil)
      (if
	  (do ((vble-ranges (cdar decls) (cdr vble-ranges)))
	      ((null vble-ranges) nil)
	      (if (or (and (cdar vble-ranges)
			   (string>= vble-str (string (caar vble-ranges)))
			   (string<= vble-str (string (cadar vble-ranges))))
		      (string= vble-str (string (caar vble-ranges))))
		  (return t)))
	  (return (caar decls)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                get_array_type
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get_array_type (decl vble-is-formal-arg)
  (prog (type)
	(return
	 (cond
	  ((and (member decl common_array_dims)
		(setq type (car (member decl explicit_vble_decls :key #'caadr)))
		(not (eq (car type) 'array)))
	   (car type))
	  ((and (not vble-is-formal-arg)
		(setq type (get-implicit-type decl)))
	   type)
	  ((default-int-p decl) 'fixnum)
	  (t  'single-float)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                default-int-p
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun default-int-p (vble)
  (and (string>= (string vble) "I")
       (string< (string vble) "O")))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                vble-is-array-p
;;
;; test whether or not a given symbol has been defined as an array
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun vble-is-array-p (v)
  ;; check to see if v is explicitly declared and dimensioned
  (if (member v declared_vbles)
      (do ((decls explicit_vble_decls (cdr decls)))
	  ((null decls) nil)
	  (if (do ((vbles (cdar decls) (cdr vbles)))
		  ((null vbles) nil)
		  (if (and (eq v (caar vbles)) (cdar vbles))
		      (return t)))
	      (return t)))
    ;; else check if v is a common variable and an array
    (member v common_array_dims)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                sym-is-fun-name
;;
;; test if a symbol is a function call rather than an undeclared vble
;; used in check_new_vbles
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun sym-is-fun-name (expr)
  (and (listp (cadr expr)) (not (null (cdr expr)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                make-special-proclamation
;;
;; given a list of variables names proclaim them special
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-special-proclamation (vars)
  (if vars `(proclaim '(special ,@vars)) nil))

; declare a special (common) variable
(defun make-special-var-decl (v)
  (prog (dim)
	(return
	 (cond ; check if v is an array
	  ((setq dim (member v common_array_dims))
	   ;; ael
	   ;; I'm changing this so that the variable is actually
	   ;; initialized (if it's an array) in the first call. This will only
	   ;; take care of statements common to the main program! (But that's a
	   ;; start!
	   #|
	   `(declare (type (simple-array ,(get_array_type v nil) ',(cadr dim))
			   ,(check-t-and-pi v)))
|#
	   (if program-flag
	       `(let ()
		  (setq ,(check-t-and-pi v)
			(make-array (list ,@(cadr dim))
				    :element-type ',(get_array_type v nil)
				    ))
		  (declare (type (simple-array ,(get_array_type v nil)
					       ',(cadr dim))
				 ,(check-t-and-pi v)))
		  )
	     `(declare (type (simple-array ,(get_array_type v nil) ',(cadr dim))
			     ,(check-t-and-pi v)))
	     )
	   ;; ael
	   )
	  ;; else make ordinary declaration
	  (t (make-declaration v))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                check-t-and-pi
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun check-t-and-pi (x)
   (cond ((eq x 'T) 't_)
         ((eq x 'PI) 'pi_)
         ((eq x 'NIL) 'nil_)
	 ;;ael - need to get that replacement taken care of (replace
	 ;;      .false. with false, .true. with true)
         ((eq x 'f2cl_false) 'nil)
         ((eq x 'f2cl_true) 't)
	 ;;ael
         (t x)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fix-structure
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fix-structure (checklist labels) ; labels is the do labels
  "
;; functions for fixing DO and IF structures
;; sort out do loops and if-then-else structures
"
  (do ((retlist (list (third checklist) (second checklist) (first checklist))
		(if clause (cons clause retlist) retlist))
       (exprs (cdddr checklist))
       (clause))
      ((null exprs) (reverse retlist))
      (cond ((listp (car exprs))
	     (cond ((eq (caar exprs) 'if-then)
		    (multiple-value-setq (clause exprs)
					 (fix-ifthen exprs labels)))
		   ((eq (caar exprs) 'fdo)
		    (multiple-value-setq (clause exprs) (fix-do exprs labels)))
		   ((eq (caar exprs) 'continue_place_holder)
		    (setq clause nil
			  exprs (cdr exprs)))
		   (t (setq clause (car exprs)
			    exprs (cdr exprs)))))
            ((eq (car exprs) 'continue_place_holder)
	     (setq clause nil
		   exprs (cdr exprs)))
            (t (setq clause (car exprs)
                     exprs (cdr exprs))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fix-ifthen
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fix-ifthen (checklist labels)
  (do ((clause (cdar checklist))
       (exprs (cdr checklist))
       (ret nil) (subclause))
      ((eq (car exprs) 'endif_place_holder)
       (setq ret (cons (reverse clause) ret))
       (values (append '(cond) (fix-tagbodies (reverse ret))) (cdr exprs)))
      (cond ((listp (car exprs))
	     (cond ((eq (caar exprs) 'fdo)
		    (multiple-value-setq (subclause exprs)
					 (fix-do exprs labels))
		    (setq clause (cons subclause clause)))
		   ((eq (caar exprs) 'if-then)
		    (multiple-value-setq (subclause exprs)
					 (fix-ifthen exprs labels))
		    (setq clause (cons subclause clause)))
		   ((eq (caar exprs) 'elseif_place_holder)
		    (setq ret (cons (reverse clause) ret)
			  clause (list (cadar exprs))
			  exprs (cdr exprs)))
		   (t (setq clause (cons (car exprs) clause)
			    exprs (cdr exprs)))))
	    ((eq (car exprs) 'continue_place_holder)
	     (setq exprs (cdr exprs)))
	    (t (setq clause (cons (car exprs) clause)
		     exprs (cdr exprs))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                end-do-p
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun end-do-p (checklist do-label)
  "
; compare FDO_BODY_LABELx with LABELy
; return t if x = y
"
  (and (not (listp (car checklist)))
       (label-matches-dolabel-p (car checklist) do-label)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                        label-matches-dolabel-p
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun label-matches-dolabel-p (label do_label)
  "
; given (go labelx) does it match with current fdo_body_label

ael - I added the check, as I'm abusing fdo to do the implicit do loops,
for which there are no labels. Thus, I check to see if it's a list, and if
so, just merrily return t. This could obviously cause problems...!
"
  (and (eq 5 (string-lessp "LABEL" (string label)))
       (equal (string-left-trim "LABEL" label)
	      (string-left-trim "FDO_BODY_LABEL" do_label))))
#|
;; new hat:
  (if (listp do_label) ;; then it's probably my hack, and let's not worry...
      t
    (and (eq 5 (string-lessp "LABEL" (string label)))
	 (equal (string-left-trim "LABEL" label)
		(string-left-trim "FDO_BODY_LABEL" do_label))))
  )
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fix-do
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fix-do (checklist labels)
  (do ((do-expr (ldiff (car checklist) (last (car checklist))) )
       (loop-body '(tagbody)
		  (if subclause (cons subclause loop-body) loop-body))
       (exprs (cdr checklist))
       (subclause nil)
       (do-label (car (last (car checklist)))))

      ((end-do-p exprs do-label)
       (cond
	((multiple-do-labelp (car exprs) labels)
	 (values (append do-expr
			 (list (reverse loop-body))) exprs))
	
	((not (eq (second exprs) 'continue_place_holder))
	 (values
	  (append
	   do-expr
	   (list
	    (reverse (cons (second exprs)
			   (cons (intern (remove-prefix do-label)) loop-body)))))
	  (cddr exprs)))
	(t
	 (values
	  (append
	   do-expr
	   (list
	    (reverse (cons (intern (remove-prefix do-label)) loop-body))))
	  (cddr exprs))) ))
					;body
      (cond ((listp (car exprs))
	     (cond ((eq (caar exprs) 'if-then)
		    (multiple-value-setq (subclause exprs)
					 (fix-ifthen exprs labels)))
		   ((eq (caar exprs) 'fdo)
		    (multiple-value-setq (subclause exprs)
					 (fix-do exprs labels)))
		   ((and (eq (caar exprs) 'go)
			 (label-matches-dolabel-p (cadar exprs) do-label))
		    (setq subclause '(return)
			  exprs (cdr exprs)))
		   (t (setq subclause (car exprs)
			    exprs (cdr exprs)))))
            ((eq (car exprs) 'continue_place_holder)
             (setq subclause nil
                   exprs (cdr exprs)))
            (t (setq subclause (car exprs)
                     exprs (cdr exprs))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                remove-prefix
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun remove-prefix (x)
  "
ael - I added an if statement to make sure that we're dealing with a string,
rather than a list (which I'm using to hack implicit-do-loops).
"
  ;;ael (string-left-trim "FDO_BODY_" x))
  (if (stringp x)
      (string-left-trim "FDO_BODY_" x)
    ;; it wants a string for a response, even if it's the empty string
    ""
    ))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                multiple-do-labelp
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun multiple-do-labelp (labelnnn labels)
  (< 1
     (length
      (remove-if-not
       #'(lambda (x)
	   (label-matches-dolabel-p labelnnn (princ-to-string x)))
       labels))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fix-tagbodies
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fix-tagbodies (cond-expr)
  "
 if a cond clause contains a jump (from within to within) make a tagbody
"
   (do ((clauses cond-expr (cdr clauses))
        (new-clauses nil (cons clause new-clauses))
        (clause nil))
       ((null clauses) (reverse new-clauses))
       (setq clause (car clauses)) ;(<pred> expr expr ....)
       (if (member-if #'symbolp (cdr clause))
           (setq clause `(,(car clause) (tagbody ,@(cdr clause)))))))

;-----------------------------------------------------------------------------
(eval-when (compile load eval)
	   (proclaim '(special format_stmts current_label SP dlist-flag)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-format
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-format (x)
  "
;; Examples:
 (setq format_stmts nil)
 (setq current_label 7000)
 (parse-format
  '(FORMAT ( \"AT END OF LOOP J  =  \" |,| I |,| / )))
 (parse-format
  '(FORMAT ( \"AT END OF LOOP J  =  \" |,| I3 |,| / )))
"
  ;;ael
  #|
  (prog (SP)
	(declare (special SP))
|#
  (prog
   ()
   (setq format_stmts
	 (cons (list current_label
		     (parse-format1 (cadr x)))
	       format_stmts)))
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-write
;;
;; x is of form: '(WRITE (* |,| 8000) |,| J |,| K)
;;           or  '(WRITE (*) |,| J |,| K)
;;           or  '(WRITE (* |,| *) |,| J |,| K)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-write (x)
  "
;; Examples:
 (set-up-faux)
 (parse-write '(WRITE (* |,| 8000) |,| J |,| K))
 (parse-write '(WRITE (*) |,| J |,| K))
 (parse-write '(WRITE (* |,| *) |,| J |,| K))
 (parse-write '(WRITE (* |,| \" 2I3 \" ) |,| J |,| K))
"
  ;; check for comma before arguments
  (if (and (third x) (not (eq (third x) '|,|)))
      (setq x (append (list (first x) (second x) '|,|) (cddr x))))

  ;; ael - I added the I/O, and the following to allow for computed unit
  ;; numbers:
  (let* (
	 (fmt (second x))
	 (fmt (if (listp fmt) fmt (list fmt)))
	 (fmt (list-split '|,| fmt))
	 (unit (parser (first fmt)))
	 (fmt (first (second fmt)))
	 )

    `((fformat I/O ,(parse_format_dest unit)
	       (quote ,(if (null fmt)
			   '("~A~%")
			 (get_format_stmt fmt)))
	       (list ,@(mapcar #'parse-output-argument
			       (list-split '|,| (cdddr x))))))))

;;ael - these'ns're mine:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-open
;;
;; x is of form: '(open ( unit = 12 |,| file = "stable.dat" ) )
;;           or  '(open ( 12 |,| file |=| "stable.dat" ) )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-open (x)
  "
;; ael
;; Examples:
 (set-up-faux)
 (parse-open '(open ( unit = 12 |,| file = \"stable.dat\" ) ))
 (parse-open '(open ( 12 |,| \"stable.dat\" ) ))
 (parse-open '(open ( 6 |,| \"stable.dat\" ) ))

 ;; only \"new\" status is considered output:
 (parse-open '(open ( 12 |,| \"stable.dat\" |,| status = \"new\"  ) ))
 ;; unknown status is assumed to be input:
 (parse-open '(open ( 12 |,| \"stable.dat\" |,| status = \"unknown\"  ) ))
"
  (let* (
	 (lis (list-split '|,| (second x)))
	
	 ;; the unit number is always first:
	 (stream (head-chop '= (first lis)))
	 (stream (parser (if stream stream (first lis))))
	
	 ;; the file name is usually second, but doesn't have to be: we'll
	 ;; start by looking for a list that starts with the word 'file,
	 (file (first (select lis (where (mapcar #'first lis) 'file))))
	 ;; if that's nil, we'll assume the name is in the second spot:
	 (file (final (if file file (second lis))))
	
	 ;; direction stands for the fortran status: new, old, unknown, etc.
	 (direction
	  (final (first (select lis (where (mapcar #'first lis) 'status)))))
	 ;; as before, we look for it by name. There's no default position for
	 ;; the status: by default, it will be old, signifying input:
	 (direction (if (stringp direction) (string-downcase direction) "old"))
	 (direction
	  (cond
	   ((string= direction "old") :input)
	   ((string= direction "new") :output)
	   ((string= direction "unknown") :unknown)
	   ((string= direction "scratch") :delete)
	   (t :unknown) ;; this is the default
	   ))
	 )

    (if (and stream file)
	`((oopen I/O ,stream ,file :direction ,direction))))
  )
;;ael
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                oopen
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro oopen(I/O stream file &key (direction :input))
  "
;; Returns: changes the ith position of the I/O variable to a list containing
;; the stream, the filename, and the direction.
"
  (andy-print "in oopen" I/O stream file direction)
  `(oopen1 ,I/O ,stream ,file ,direction))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                oopen1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun oopen1 (I/O stream file direction)
  "
	We're going to finally open a file!
1) If the stream is already open, we'll take a break to let folks know that
   that's a no-no;
2) if the direction is either output or delete, we'll open the file as output;
   if it is new or unknown, we'll open it as input, and only change our mind
   later (in fformat1) if the user tries to write to it.
"
  (let ((defined (first (aref I/O stream))))
    (if (and (streamp defined) (open-stream-p defined))
	(break (format nil "Can't open stream ~d as it's already open." file))
      (setf (aref I/O stream)
	    (list
	     (open file
		   :direction
		   (case direction
			 (:output :output)
			 (:delete :output)
			 (:unknown (if (probe-file file) :input :output))
			 (t :input)
			 )
		   )
	     file direction))
      )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                clean-up-I/O
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun clean-up-I/O (I/O)
  "
 Clean-up-I/O just closes any stream that happen to be open when all's said and
done. Close should have done that already, but if not we want to make sure to
get them closed so that we don't bleed files (easy to get a 'too many files
open' error).
"
  (andy-print i/o)
  (dolist
   (i (iseq 1 99))
   (let ((stream-info (aref I/O i)))
     (if stream-info
	 (let (
	       (stream (elt stream-info 0))
	       (file (elt stream-info 1))
	       (direction (elt stream-info 2))
	       )
	   (if (streamp stream)
	       (let()
		 (close (first (aref I/O i)))
		 (if (eq direction :delete)
		     (format
		      t "I should be deleting file ~a in clean-up-I/O.~%" file)
		   ;;(delete-file file)
		   )
		 )
	     )
	   )
       )
     )
   )
  (andy-print i/o)
  )
;;lea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-close
;;
;; x is of form: '(close ( unit = 12 |,| status = "delete" ) )
;;           or  '(close ( 12 ) )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-close (x)
  "
;; Examples:
 (parse-close '(close ( unit = 12 |,| status = \"delete\" ) ))
 (parse-close '(close ( 12 ) ))
 (parse-close '(close ( 3 + 5 ) ))
"
  (let* (
	 (lis (list-split '|,| (second x)))

	 (stream (head-chop '= (first lis)))
	 (stream (parser (if stream stream (first lis))))
	
	 (status
	  (final (first (select lis (where (mapcar #'first lis) 'status)))))
	 (status (equalp "delete"
			 (if (stringp status) (string-downcase status))))
	 )
    `((cclose I/O ,stream ,status))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                cclose
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro cclose(I/O stream status)
  (andy-print (list "in cclose" I/O stream status))
  `(cclose1 ,I/O ,stream ,status))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                cclose1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun cclose1(I/O dest status)
  (let* (
	 (stream-info (aref I/O dest))
	 (stream (first stream-info))
	 (file (second stream-info))
	 (direction (third stream-info))
	 )
    (if stream
	(let ()
	  (if status
	      (format t "did not delete file ~a~%" file)) ;; (delete-file file)
	  (close stream)
	  )
      (format t "Can't close unit ~d, as it doesn't appear to be open.~%" dest)
      )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-read
;;
;;               '(READ (*) |,| J |,| K)
;;           or  '(READ (* |,| *) |,| J |,| K)
;;           or  '(READ (5 |,| *) |,| J |,| K)
;;
;; ael - I added parse-read to get us started on translating reads:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-read (x)
  "
	This parse read is hopefully better than the first, in that read can
fill elements of arrays, and will add float or int commands as necessary,
depending on the variable type of the assigned-to-be.

;; Examples:
 (parse-read '( read ( * |,| * ) a |,| aa))
"
  (let* (
	 (format (second x))
	 (format (if (listp format) format (list format)))

	 (stream (parser (first (list-split '|,| format))))
	 (stream (if (eq stream '*) t stream))
	
	 (args (remove nil (list-split '|,| (rest (rest x)))))
	
	 (reads
	  (split-list (repeat (list 'rread 'I/O stream) (length args)) 3)
	  )
	 )
    (mapcar #'(lambda(x y) (first (parse-assignment (smoosh (list x '= y)))))
	    args reads)
    ))

(defun parse-read (x)
  "
	This parse read is hopefully better than the first, in that read can
fill elements of arrays, and will add float or int commands as necessary,
depending on the variable type of the assigned-to-be.

;; Examples:
 (parse-read '( read ( * |,| * ) a |,| aa))
 (parse-read '( read ( * |,| * ) a |,| (aa ( i ) |,| i = 1 |,| 3 )))
"
  (let* (
	 (format (second x))
	 (format (if (listp format) format (list format)))

	 (stream (parser (first (list-split '|,| format))))
	 (stream (if (eq stream '*) t stream))
	
	 (args (remove nil (list-split '|,| (rest (rest x)))))

	 (reads
	  (split-list (repeat (list 'rread 'I/O stream) (length args)) 3)
	  )
	 )
    (mapcar
     #'(lambda(x y)
	 (if (listp (first x))
	     (first (parse-implicit-do-loop (first x) :operation (list y)))
	   (first (parse-assignment (smoosh (list x '= y))))))
     args reads)
    ))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                rread
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro rread(I/O stream)
  (andy-print "in rread" I/O stream)
  `(rread1 ,I/O ,stream))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                rread1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun rread1(I/O stream)
  "
ael:	I added the eval, as I couldn't use 'pi', for example, in a program.
Of course, this is supposed to be fortran code, not lisp code, so we need to
think like a fortran code! I.e., I wouldn't type 'pi' to a fortran program. So
maybe I shouldn't bother....

	I won't. I've decided that we risk too much: for example, if a text
file contains the word pi on a line, it would be replaced by an
numerical approximation to pi: that could be really painful.
"
  (let* (
	 (stream (first (aref I/O (if (numberp stream) stream 0))))
	 (what
	  (if stream
	      (read stream nil 'EOF)
	    ;; otherwise we'll try standard in:
	    (read nil nil 'EOF)
	    )
	  )
	 )
    ;; (if (and (symbolp what) (boundp what)) (eval what) what)
    what
    )
  )
;;ael

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fformat
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro fformat (I/O dest cilist args)
  "
ael:
	I just replaced the format statements by fformat1, so that I can check
for numerical arguments, and treat them appropriately.

	In the case of a ~4{ type argument, I need to add an additional layer
of listing.
"
  (andy-print "fformat" I/O dest cilist args)
  `(if (equal ,cilist '("~A~%"))
       (and (mapcar #'(lambda (arg) (fformat1 ,I/O ,dest "~A " arg)) ,args)
;;ael	    (format ,dest "~%"))
	    (fformat1 ,I/O ,dest "~%" nil))
     ;; loop through directives, consume arguments
     (do ((directives ,cilist (cdr directives))
	  (arglist ,args arglist))
	 ((null directives))
	 (cond
	  ((stringp (first directives))
	   ;;ael	(format ,dest (first directives)))
	   (fformat1 ,I/O  ,dest (first directives) nil))
	  #|
	  (t
	   ;; ael
	   ;; this is where we're screwed up: if we've got a repeater,
	   ;; then we're only pulling off the first of the whole list
	   ;; (which is supposed to be printed on a same line):
	   (fformat1 ,I/O ,dest
		     (car (first directives))
		     (first arglist))
	   (setq arglist (cdr arglist))
	   ;; so I'll modify things a little, opting for the additional case:
|#
	  ((and (listp (first directives))
		(char= #\~ (elt (first (first directives)) 0))
		(digit-char-p (elt (first (first directives)) 1))
		(search (list #\{) (coerce (first (first directives)) 'list))
		)
	   ;;ael - okay, we've got us a repeater! Now in fortran, you can give
	   ;;a repeater that pretends to need 4 values just 2 values, say, so
	   ;;we have to be ready to cut this down.
	   (let* (
		  (string (first (first directives)))
		  (wheres-a-brace (search (list #\{) (coerce string 'list)))
		  (how-many (read-from-string
			     (subseq string 1 wheres-a-brace)))
		  (len-args (length arglist))
		  (num-args (min how-many len-args))
		  (string (strcat
			   "~" (num-to-string num-args)
			   (subseq string wheres-a-brace)))
		  )
	     (andy-print string wheres-a-brace how-many num-args)
	     (fformat1 ,I/O ,dest
		       string
		       (select arglist (iseq num-args)))
	     (setq arglist
		   (if (/= num-args len-args)
		       (select arglist (iseq num-args (1- len-args)))))
	     )
	   )
	  (t
	   ;; this is still the default if we don't have a ~4{ or such format:
	   (fformat1 ,I/O ,dest
		     (car (first directives))
		     (first arglist))
	   (setq arglist (cdr arglist))
	  ;;lea
	  )
	  ))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fformat1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fformat1 (I/O dest directive arg)
  "
ael:
	The print statement in the original definition

 (defun fformat1 (dest directive arg)
   (if (arrayp arg)
       (print arg)
     (format dest directive arg)))

 (above) was really pernicious!

;; Examples:
 ;; Trying to figure out how these nested ~{ work:
 ;; this one doesn't work, and it's what the code is putting out:
 (fformat1 (coerce (repeat nil 10) 'vector) 6
	   \"~{~1@T~4{~15,8,2,0,,'*E~3@T~}~}\" (iseq 1 16))

 (fformat1 (coerce (repeat nil 10) 'vector) 6
	  \"~{~1@T~4{~15,8,2,0,,'*E~3@T~}~}\"
	  (mapcar (lambda(i) (iseq 1 4)) (iseq 4)))

 (fformat1 (coerce (repeat nil 10) 'vector) 6
	   \"~{~g ~}\" (iseq 1 16))
 (fformat1 (coerce (repeat nil 10) 'vector) 6
	   \"~16{~g ~}\" (iseq 1 16))
 (fformat1 (coerce (repeat nil 10) 'vector) 6
	  \"~{~{~g ~}~}\" (list '((1 2) (3 4))))

 (fformat1 (coerce (repeat nil 10) 'vector) 6
	  \"~{~{~g ~}~}\" (list '(1 2) '(3 4)))

 (fformat1 (coerce (repeat nil 10) 'vector) 6
	  \"~{~{~g ~}~}\" (combine '((1 2) (3 4))))
"
  (let* (
	 (is-stream (if (member dest (iseq 1 99)) (aref I/O dest)))
	 (file (second is-stream))
	 (direction (third is-stream))
	 (stream
	  (cond
	   ((streamp (first is-stream)) (first is-stream))
	   (t t)))
	 )
    (case
     direction
     (:input
      (error
       (format nil "Attempt to write to input file ~a, unit ~d" file dest)))
     (:unknown
      (format t "Re-opening file ~a with output status in fformat1.~%" file)
      (close stream)
      (setf (aref I/O dest)
	    (list (setq stream (open file :direction :output)) dest :output))
      (if (and (arrayp arg) (not (stringp arg)))
	  (print arg stream) ;; ael - talk about bailing!
	(format stream directive arg)
	))
     (t ;; it's already output!
      (if (and (arrayp arg) (not (stringp arg)))
	  (print arg stream) ;; ael - talk about bailing!
	(format stream directive arg)
	)
      )
     )
    )
  )
;;ael

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          get_format_stmt
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get_format_stmt (label)
  "
	This doesn't handle the case of a format given as the second part of a
 write call, e.g.
	write(*,'2I3') out, out

 I added the parse-format1 call.

;; Examples:
 (get_format_stmt '*)
 (get_format_stmt \"2I3\")
 (get_format_stmt \"(2I3)\")
 (new-readtable)
"
  (cond
   ((eq label '*) '("~A~%"))
   ((numberp label)
    (do ((lis format_stmts (cdr lis)))
        ((null lis) (error "format stmt ~A not found" label))
        (if (equal label (caar lis)) (return (cadar lis))))
    )
   (t
    (setq label (first (add-spaces-to-string label)))
    (set-fortran-read)
    (setq label
	  (rest
	   (butlast
	    (lineread (make-string-input-stream label)))))
    (setlispread)
    (parse-format1 (brackets-check label))
    )
   )
  )
  #|
;; ael - formerly
  (if (or (eq label '*) (not (numberp label)))
      '("~A~%")
    (do ((lis format_stmts (cdr lis)))
        ((null lis) (error "format stmt ~A not found" label))
        (if (equal label (caar lis)) (return (cadar lis))))))

|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse_format_dest
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse_format_dest (dest)
  (if (eq dest '*) t dest))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-output-argument
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-output-argument (arg)
   (cond ((null arg) nil)
         ((and (listp arg) (listp (car arg)) (member '= (car arg)))  ;implied-do
          (parse-implied-DO (list-split '|,| (car arg))))
         ((and (listp arg) (every #'listp arg)) ; dlist
          (parse-dlist arg))
         (t (id-expression arg))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-implied-DO
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-implied-DO (do-list)
  (prog (ctrl-vars dlist ivar e1 e2 e3 (dlist-flag nil))
	(setq ctrl-vars (member-if #'(lambda (x) (eq (second x) '=)) do-list)
	      dlist (parse-dlist (ldiff do-list ctrl-vars))
	      ivar (first (first ctrl-vars))
	      e1 (id-expression (cdr (member '= (first ctrl-vars))))
	      e2 (id-expression (second ctrl-vars))
	      e3 (if (third ctrl-vars) (third ctrl-vars) 1))
	(return
	 (if dlist-flag
	     `(do ((,ivar ,e1 (+ ,ivar ,e3))
		   (ret nil (append ret ,dlist)))
		  ((> ,ivar ,e2) ret))
	
	   `(do ((,ivar ,e1 (+ ,ivar ,e3))
		 (ret nil (cons ,dlist ret)))
		((> ,ivar ,e2) (reverse ret)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-dlist
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-dlist (x)
   (setq dlist-flag t)
   `(list ,@(mapcar #'parse-output-argument x)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-format1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-format1 (x)
  "
;; Examples:
 (setq format_stmts nil)
 (setq current_label 7000)
 (trace parse-format1 parse-format-descriptor-list)
 (parse-format1
  (second '(FORMAT ( \"AT END OF LOOP J  =  \" |,| I |,| / ))))
 (parse-format1
  (second '(FORMAT ( \"AT END OF LOOP J  =  \" |,| 2 ( I3 ) |,| / ))))

 (trace PARSE-FORMAT1 PARSE-FORMAT-DESCRIPTOR-LIST)
 (parse-format1 '(1X |,| I4 |,| 2F12.6 |,| (/ 5X |,| I5 |,| F12.6)))
 (untrace PARSE-FORMAT1 PARSE-FORMAT-DESCRIPTOR-LIST)
"
  (setq x (list-split '|,| (fix-slashes x)))
  (do ((desc-lists x (cdr desc-lists))
       (directive) (dl)
       (directive-list nil (append directive-list directive)))
      ((null desc-lists) (append directive-list '("~%")))
      (setq dl (car desc-lists))
      (setq
       directive
       (cond
	((null dl) nil) ;(list nil))
	((stringp (car dl)) (list (car dl)))
	((listp (car dl))
	 ;;ael - I didn't reason this out, just figured out what was needed in
	 ;;one problem case. Hope it works in general!
	 ;; (append  '("~{") (parse-format1 (car dl)) '("~}")))
	 (list
	  (list (apply #'strcat
		       (combine
			'("~{")
			;;ael - note that I'm also stripping off the last ~%:
			(butlast (parse-format1 (car dl)))
			;;lea
			'("~}"))))))
	;;lea
	((and (numberp (car dl)) (listp (cadr dl)))
	 ;; ael: this case is also messed up. I'll try the same trick (can't be
	 ;; any worse than failure!
	 #|
	 (append '("~") (list (car dl)) '("{")
		 (parse-format1 (cadr dl)) '("~}")))
|#
	 (list
	  (list (apply #'strcat
		       (combine
			'("~") (num-to-string (car dl)) '("{")
			;;ael - note that I'm also stripping off the last ~%:
			(butlast (parse-format1 (cadr dl)))
			;;lea
			'("~}"))))))
	;;lea
	((numberp (car dl))
	 (parse-format-descriptor-list
	  (car dl)
	  (destruct-descriptor-list (cadr dl))))
	(t (parse-format-descriptor-list
	    1
	    (destruct-descriptor-list (car dl))))
	)
       )
      )
  )

;--------------------------------------------------------------------------------

; given a symbol e.g I4 or P2G10.4E2 this function seperates it into numbers and
; symbols eg (#\I 4) or (#\P 2 #\G 10 4 #\E 2)

(defun destruct-descriptor-list (x)
  (prog (descriptor-list char atm)
   (if (not (symbolp x)) (return x))
   (setq x (make-string-input-stream (symbol-name x)))
    loop
   (setq char (peek-char nil x nil 'EOF t))
   (if (equal char 'EOF) (return (reverse descriptor-list)))
   (cond ((or (digit-char-p char) (member char '(#\+ #\-)))
          (multiple-value-setq (atm x) (read-number-from-stream x)))
         ((eq char #\.) (read-char x) (setq atm nil))
         (t (setq atm (read-char x))))
   (if atm (setq descriptor-list (cons atm descriptor-list)))
   (go loop)))

(defun read-number-from-stream (x)
   (prog ((number-str "") char)
     loop
   (setq char (peek-char nil x nil 'EOF t))
   (if (equal char 'EOF) (return (values (read-from-string number-str) x)))
   (if (or (digit-char-p char) (member char '(#\+ #\-)))
       (setq number-str (concatenate `string number-str (string (read-char x))))
       (return (values (read-from-string number-str) x)))
   (go loop)))

;--------------------------------------------------------------------------------
; pattern matching functions adapted from those in f3.l

; bind matched atoms to A etc if the pattern has (> A)
; bind matched groups of atoms to B if the pattern has (+ B)
; the eval obtains the list of atoms seen so far and the cons adds the atom
; matched at the current level
; e.g. > (setq x  '(#\P 2 #\G 10 4 #\E 2))
;      > (pattern-match-and-bind '((+ left) #\G (+ right)) x)
;      binds (#\P 2) to left and (10 4 #\E 2) to right
;      > (pattern-match-and-bind '(#\P (> A) #\G (> B) (> C) (+ D)) x)
;      binds 2 to A, 10 to B, 4 to C and '(#\E 2) to D

(defun pattern-match-and-bind (p d)
  "
;; Examples:

 (setq x  '(#\\\P 2 #\\\G 10 4 #\\\E 2))
 (pattern-match-and-bind '((+ left) #\\\G (+ right)) x)
 ;;      binds (#\\\P 2) to left and (10 4 #\\\E 2) to right
 (pattern-match-and-bind '(#\\\P (> A) #\\\G (> B) (> C) (+ D)) x)
 ;;      binds 2 to A, 10 to B, 4 to C and '(#\\\E 2) to D

 (setq left nil right nil)
 (setq x  '(#\\\I 2 #\\\G 10 4 #\\\E 2))
 (trace pattern-match-and-bind)
 (setq val (pattern-match-and-bind '((> left) #\\\I (+ right)) x))
 (untrace pattern-match-and-bind)
 val
 left
 right

 (setq left nil right nil)
 (setq x  '(1 #\\\I 2))
 (trace pattern-match-and-bind)
 (setq val (pattern-match-and-bind '((> left) #\\\I (+ right)) x))
 (untrace pattern-match-and-bind)
 val
 left
 right

 (setq x  '(1 #\\\I))
 (setq left nil right nil)
 (trace pattern-match-and-bind)
 (setq val (pattern-match-and-bind '(#\\\I (+ right)) x))
 (untrace pattern-match-and-bind)
 val
 left
 right
"
  (cond
   ((and (null p) (null d)) t)
   ((or (null p) (null d)) nil)
   ((or (equal (car p) '>)
	(equal (car p) (car d)))
    (pattern-match-and-bind (cdr p) (cdr d)))

   ((and (listp (car p))
	 (equal (caar p) '>)
	 (pattern-match-and-bind (cdr p) (cdr d)))
    (set (cadar p) (car d)) t)
   ((equal (car p) '+)
    (cond ((pattern-match-and-bind (cdr p) (cdr d)))
	  ((pattern-match-and-bind p (cdr d)))))
   ((and (listp (car p))
	 (equal (caar p) '+))
    (cond ((pattern-match-and-bind (cdr p) (cdr d))
	   (set (cadar p) (list (car d))) t) ; building begins
	  ((pattern-match-and-bind p (cdr d))
	   (set (cadar p)
		(cons (car d) (eval (cadar p)))) t)))))

;--------------------------------------------------------------------------------
; functions for parsing format stmts which are stored with their labels
; on a global list (referenced by calls to WRITE)

(defun parse-format-descriptor-list (a x)
  "
;; Examples:
 (trace parse-format-descriptor-I)
 (PARSE-FORMAT-DESCRIPTOR-LIST 1 '(#\\\I 3))
 (PARSE-FORMAT-DESCRIPTOR-LIST 1 '(#\\\I))
"
  #|
  (prog (left right)
   (declare (special left right))
|#
  (prog
   ()
   ;; Because special isn't working, the values of left and right are not being
   ;; set properly. These values, for left and right, when set by
   ;; pattern-match-and-bind, should be communicated to this program, but are
   ;; not.

   (if (numberp (car x)) nil (setq x (cons a x)))
   ; find most significant descriptor and parse
   (return
    (cond
     ;;((typep (cdr x) 'string)
     ;; (cdr x))
     ((pattern-match-and-bind '((+ left) #\H (+ right)) x)
      (parse-format-descriptor-H left right))
     ((pattern-match-and-bind '((> left) #\I (+ right)) x)
      (parse-format-descriptor-I left right)
      )
;;ael - I added this one to take care of the standard case (to prevent a format
;; of ~a from being used). I imagine that other formats using the (> left) will
;; also need to be fixed in a similar way....
     ((pattern-match-and-bind '((+ left) #\I) x)
      (parse-format-descriptor-I-short left)
      )
;;ael
     ((pattern-match-and-bind '((+ left) #\F (+ right)) x)
      (parse-format-descriptor-F left right))
     ((pattern-match-and-bind '((+ left) #\G (+ right)) x)
      (parse-format-descriptor-G left right))
     ((pattern-match-and-bind '((+ left) #\E (+ right)) x)
      (parse-format-descriptor-E left right))
     ;;ael - my "fix" of the d problem has caused another, namely that d format
     ;;should not be replaced by e, rather by f format as seen below:
     ((pattern-match-and-bind '((+ left) #\D (+ right)) x)
      (parse-format-descriptor-F left right))
     ;;ael - now what????
     ((pattern-match-and-bind '((> left) #\T #\R (+ right)) x)
      (parse-format-descriptor-TR right))
     ((pattern-match-and-bind '((> left) #\X) x)
      (parse-format-descriptor-X left))
     ((pattern-match-and-bind '((> left) #\S (> right)) x)
      (parse-format-descriptor-S right))
     ((equal (cadr x) '#\/)
      (parse-format-descriptor-/))
     (t (parse-default-format-descriptor x))
     ))))

(defun fixnum-string (x)
   (princ-to-string x))

(defun parse-format-descriptor-I (a w)
  (prog (directive)
	(if (listp w) (setq w (car w)))  ;ignore .m
	(setq directive (list (concatenate 'string "~" (fixnum-string w) "D")))
	(return
	 (do ((i 1 (1+ i))
	      (ret nil (append ret (list directive))))
	     ((> i a) ret)))))

;; ael - added this:
(defun parse-format-descriptor-I-short (a)
  (prog (directive)
	(setq directive (list "~D"))
	(return
	 (do ((i 1 (1+ i))
	      (ret (list directive) (append ret (list directive))))
	     ((> i a) ret)))))

;;<kP><a>Fw.d -> ~a{~w,d,k,,,[@]F}
(defun parse-format-descriptor-F (left right)
  #|
  (prog ((k 0) (a 1) directive)
     (declare (special k a))
|#
  (prog
   (directive)
   (setq k 0 a 1)
   (or (pattern-match-and-bind '((> k) #\P (> a)) left)
       (pattern-match-and-bind '((> k) #\P) left)
       (pattern-match-and-bind '((> a)) left))
   (setq directive
         (list (concatenate 'string
			    "~" (fixnum-string (car right)) ","     ;w
			    (fixnum-string (cadr right)) ","    ;d
			    (fixnum-string k) ",,"              ;k
			    (if SP "@F" "F"))))
   (return
    (do ((i 1 (1+ i))
	 (ret nil (append ret (list directive))))
	((> i a) ret)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       parse-format-descriptor-E
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-format-descriptor-E (left right)
  #|
  (prog ((k 0) (a 1) w d (e 2) directive)
     (declare (special k a w d e))
|#
  (prog
   (directive)
   (setq k 0 a 1 w nil d nil e 2)
   (or (pattern-match-and-bind '((> k) #\P (> a)) left)
       (pattern-match-and-bind '((> k) #\P) left)
       (pattern-match-and-bind '((> a)) left))
   (or (pattern-match-and-bind '((> w) (> d)) right)
       (pattern-match-and-bind '((> w) (> d) #\E (> e)) right))
   (setq directive
	 ;; ael - evidently this needs to be a list! See -G below
	 (list
	  ;; ael
	  (concatenate 'string
		       "~" (fixnum-string w) ","
		       (fixnum-string d) ","
		       (fixnum-string e) ","
		       (fixnum-string k) ",,'*"
		       (if SP "@E" "E")))
	 ;; ael
	 )
   ;; ael
   (return
    (do ((i 1 (1+ i))
	 (ret nil (append ret (list directive))))
	((> i a) ret)))))

(defun parse-format-descriptor-G (left right)
#|
  (prog ((k 0) (a 1) w d (e 2) directive)
     (declare (special k a w d e))
|#
  (prog
   (directive)
   (setq k 0 a 1 w nil d nil e 2)
   (or (pattern-match-and-bind '((> k) #\P (> a)) left)
       (pattern-match-and-bind '((> k) #\P) left)
       (pattern-match-and-bind '((> a)) left))
   (or (pattern-match-and-bind '((> w) (> d)) right)
       (pattern-match-and-bind '((> w) (> d) #\E (> e)) right))
   (setq directive
         (list (concatenate 'string
                            "~" (fixnum-string w) ","
                            (fixnum-string d) ","
                            (fixnum-string e) ","
                            (fixnum-string k) ",,'*"
                            (if SP "@G" "G"))))
   (return
    (do ((i 1 (1+ i))
	 (ret nil (append ret (list directive))))
	((> i a) ret)))))

(defun parse-format-descriptor-/ ()
   '("~%"))

(defun parse-format-descriptor-TR (s)
   (list (concatenate 'string "~" (fixnum-string s) "@T")))


(defun parse-format-descriptor-X (w)
   (list (concatenate 'string "~" (fixnum-string w) "@T")))

(defun parse-format-descriptor-S (right)
   (setq SP (if (eq right #\P) t nil))
   "")

(defun parse-format-descriptor-H (width string)
   (declare (ignore width string))
   (list "*Hollerith*"))

(defun parse-default-format-descriptor (x)
   (list (do ((i 1 (1+ i))
              (ret nil (append ret '("~A"))))
             ((> i (car x)) ret))))

; given a list containing /'s put commas on either side
; e.g. (x / y) -> ( |,| / |,| y)
;      (/ x) -> (/ |,| x)
(defun fix-slashes (x)
   (do ((lis x (cdr lis))
        (ret nil
             (append ret (if (eq (car lis) '/)
                             (cond ((and ret (cdr lis)) '(|,| / |,|))
                                   ((cdr lis) '(/ |,|))
                                   (t '(|,| /)))
                             (list (car lis))))))
       ((null lis) ret)))


;-----------------------------------------------------------------------------
; end of f2cl5.l

; f2cl6.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;
;;;;;;;;;;Hamilton, New Zealand 1992-95 - all rights reserved;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Suite of functions for replacing ".EQ.", ".AND." etc with "=", "AND" etc
;; as a preprocessor for fortran-to-lisp.
;; Numbers such as 6. are replaced with 6.0
;;                 .6                   0.6
;;                 -.6                  -0.6
;;                 6.D0                 6.0D0
;;  etc
;; Also replaces x.xE-x with x.xE%x and x.xE+x with x.xEx so that the lisp reader
;; when set to read FORTRAN can cope.
;; Replaces single quotes (') with double quotes (").

;; Comments are removed, unless *comments* is true.

; functions:
;     preprocess
;     adjust_nrs_and_dots
;     parse-logl-op
;     replace-str
;     parse-number
;	write-comment-line
;--------------------------------------------------------------------------
(print "f2cl6.l")
(in-package :user)
(eval-when (compile load eval) (proclaim '(special *verbose* *comments*)))
;--------------------------------------------------------------------------
#+xxxx
(defvar intrinsic_function_names
  '(int ifix idint real float sngl dble cmplx ichar char aint dint
    anint dnint nint idnint iabs abs dabs cabs mod amod dmod isign sign dsign
    idim dim ddim dprod max max0 amax1 dmax1 amax0 amax1 min min0 amini dmini
    amini min1 len index lge lgt lle llt aimag conjg sqrt dsqrt csqrt
    exp dexp cexp log alog dlog clog log10 alog10 dlog10 sin dsin csin
    cos dcos ccos tan dtan asin dasin acos dacos atan datan atan2 datan2
    sinh dsinh cosh dcosh tanh dtanh))
; global stream input for parse-number:
(defvar *inp* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                preprocess
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun preprocess (file &key (outfile-name "f2clprep.tmp")
			;; ael -experimental
			(include nil include-set)
			;; lea
			)
  "
ael: I'm re-writing the preprocess function to

	1) stuff continued lines onto long lines,
	2) to inline include files, and  - experimental
	3) add my spaces.
"
  (andy-print 'removing-string-upcase-in-preprocess)
  (prog
   (inport outport line next-line)
   (if *verbose* (format t "~&preprocessing begins ...~%"))
   (setq
    inport (infile file)
    ;; ael - experimental include
    outport (if include include (outfile outfile-name))
    ;; lea
    next-line (read-nasty-line inport)
    )

   loop

   ;; we do some initial trimming of the next-line, to get rid of comments,
   ;; short lines, etc.
   (setq
    next-line
    (do
     ((line next-line (read-nasty-line inport)))
     ;; we re-read if next-line is a comment or short:
     ((cond
       ((eq line 'EOF) t)
       ;; short:
       ((= (length line) 0) nil)
       ((check-line-for-comment line)
	;; comment: if *comments* is true, we write them out:
	(if *comments* (write-comment-line line outport))
	nil)
       ((< (length line) 7) nil)
       (t t)
       )
      ;; and we return the line
      line)
     )
    )

   (setq
    line
    (do
     ((line next-line
	    (cond
	     ;; ael - one last check to see if we've got a comment...
	     ((check-line-for-comment next-line)
	      (if *comments* (write-comment-line next-line outport))
	      line
	      )
	     (t
	      (strcat line (subseq next-line 6))))))
     ;; we head out if next-line is not a continuation, or we're at the end of
     ;; the file:
     ((let ()
	(setq next-line (read-nasty-line inport))
	(or (eq next-line 'EOF)
	    (< (length next-line) 7)
	    (string= (subseq next-line 5 6) " ")))
      ;; and we return the line
      line)
     )
    )

   (when (eq line 'EOF)
	 ;;ael
	 (if (not include-set) (close outport))
	 ;;ael
	 (close inport)
	 ;; ael - now we'll do a little preprocessing of our own!
	 (if (not include-set) (add-spaces "f2clprep.tmp"))
	 ;; ael
	 (return outfile-name))

   ;; leaving out short lines
   (if (< (length line) 7) (go loop))

   ;;ael   (setq line (string-upcase (string-right-trim '(#\Space) line)))
   (setq line (string-right-trim '(#\Space) line))
   ;;ael

   (cond
    ((check-line-for-comment line)
     (if *comments* (write-comment-line line outport)))
    ;; ael - experimental include
    ((check-line-for-include line)
     (preprocess (check-line-for-include line) :include outport)
     )
    ;; lea
    (t (when *verbose* (princ line) (terpri))
       (write-line (adjust_nrs (replace_logl_ops line)) outport)))

   (go loop)))

;; ael -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                read-nasty-line
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun read-nasty-line(inport)
  "
	ael: this is a replacement for read-line in preprocess. The point is to
change some nasties right up front.
"
  (let (
	(line (read-line inport nil 'EOF))
	(really-nasties (list "\"" "//"))
	(new-really-nasties (list "''" " ,'//', "))
	(under-conditions
	 (list
	  (lambda(x)
	    (let ((ga (grep "'" x))
		  (gq (grep "\"" x)))
	      ;; here I make sure that there are mixed quotes and apostrophes
	      ;; in the line, and that the apostrophe precedes the quotes:
	      (and gq ga (< ga gq))))
	  (lambda(x) t)
	  ))
	)
    (cond
     ((stringp line)
      (if (= 0 (length line))
	  line
	(let ()
	  (mapcar
	   (lambda(x y z)
	     (if (funcall z line)
		 (setq line (grep-replace x y line))))
	   really-nasties new-really-nasties under-conditions
	   )
	  line)
	))
     ((eq line 'eof) 'eof)
     (t nil)
     )
    )
  )
;;lea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                write-comment-line
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun write-comment-line (line outport)
  (if *verbose*
      (format
       t "      COMMENT \"~a\"~%" (string-downcase (subsequence line 1))))
  (format
   outport "      COMMENT \"~a\"~%" (string-downcase (subsequence line 1))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                replace_logl_ops
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun replace_logl_ops  (line)
  "
;; Examples:
 (replace_logl_ops \"hi there\")
 (replace_logl_ops \"hi \\\. there\")
"
  (prog (inport outport char)
	(setq inport (make-string-input-stream line)
	      outport (make-string-output-stream))
	loop
	(setq char (read-char inport nil 'EOF t))
	(cond ((eql char 'EOF)
	       (return (get-output-stream-string outport)))
	      ((char= char '#\.)
	       (parse-logl-op inport outport)
	       (go loop))
	      (t (write-char char outport)
		 (go loop)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                adjust_nrs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun adjust_nrs (line)
  "
	ael: I need to adjust this to take care of the case in which '' is used
to mean an apostrophe in a string, e.g.

       WRITE(OUP,*) 'EULER''S METHOD'
"
  (prog
   (outport char prev-char)
   (setq prev-char '#\space
	 *inp* (make-string-input-stream line)
	 outport (make-string-output-stream))
   loop
   (setq char (read-char *inp* nil 'EOF t))
   (cond ((eql char 'EOF) )
	
	 ;; check for single quote and pass over all char until next one
	 ((char= char '#\')
	  (setq prev-char '#\space)
	  (write-char '#\" outport)
	  (do (
	       ;;ael - my version of prev-char:
	       (pcar char char)
	       ;;lea
	       (char (read-char *inp* nil 'EOF t) (read-char *inp* nil 'EOF t))
	       ;;ael
	       (i 0 (incf i))
	       ;;lea
	       )
	      ;; ((char= char '#\') (write-char '#\" outport))
	      ;;ael
	      ((and
		(and (char= char '#\') (char/= pcar '#\'))
		(let ((pc (peek-char nil *inp* nil 'EOF t)))
		  (or (eq pc 'eof) (char/= pc '#\'))))
	       (write-char '#\" outport))
	      ;;lea
	      (write-char char outport))
	  (go loop))
	
	 ;; check for non-complex number
	 ((parse-number prev-char char outport)
	  (setq prev-char '#\space)
	  (go loop))
	
	 (t (write-char char outport)
	    (if (digit-char-p char)
		(setq prev-char '#\?)
	      (setq prev-char char))
	    (go loop)))
   (return (get-output-stream-string outport))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-logl-op
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-logl-op (inport outport)
  (prog
   (str nxt-char logl-op)
   (setq nxt-char (peek-char nil inport nil 'EOF t))
   (if (or (member nxt-char `(EOF #\space #\' #\.))
	   (digit-char-p nxt-char))
       (and (write-char '#\. outport)
	    (return)))
   (setq str (make-string-output-stream))
   loop
   (write-char (read-char inport nil 'EOF t) str)
   (setq nxt-char (peek-char nil inport nil 'EOF t))
   (if (and (not (eql nxt-char 'EOF))
	    (char/= nxt-char `#\.)) (go loop))
   (cond ((setq str (get-output-stream-string str)
		logl-op (replace-str str))
	  (read-char inport nil 'EOF t) ; read final dot
	  (write-char '#\space outport)

	  ;;ael
	  (write logl-op :stream outport)
	  #|
	  (cond
	   ((eq logl-op 'true)
	    (write 't :stream outport))
	   ((eq logl-op 'false)
	    (write 'nil :stream outport))
	   (t
	    (write logl-op :stream outport)
	    )
	   )	
|#
	  ;;ael

	  ;; write the converted string with spaces
	  (write-char '#\space outport))
	 ;; put the dot back
	 (t (write-char '#\. outport)
	    ;; put everything else back:
	    (write  str :stream outport :escape nil)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                replace-str
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun replace-str (str)
  "
	ael: I was replacing EQ by equalp, but it was not getting translated in
certain cases. I've decided to replace it by logeqv, which eventually gets
replaced by equalp anyway.

	I also replace NE with logxor, which is ultimately replace by (not
 (equalp ...)).

	They were using equal, which distinguishes between 'HI' and 'hi'; since
I'm no longer upcasing/downcasing, I've used equalp instead.

;; Examples:
 (replace-str \"EQ\")
 (replace-str \"eq\")

"
  (cond ((equalp str "GT")    '>)
	((equalp str "GE")    '>=)
	;;ael
	((equalp str "EQ")    'logeqv)
	;;lea
	((equalp str "LE")    '<=)
	((equalp str "LT")    '<)
	;;ael
	;;ael((equalp str "NE")    '><)
	((equalp str "NE")    'logxor)
	;;lea
	((equalp str "NOT")   'NOT)
	((equalp str "AND")   'AND)
	((equalp str "OR")    'OR)
	((or (equalp str "TRUE") (equalp str "T"))	 'f2cl_TRUE)
	((or (equalp str "FALSE") (equalp str "F"))	 'f2cl_FALSE)
	((equalp str "EQV")   'logeqv)
	((equalp str "NEQV")  'logxor)
	(t nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                parse-number
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun parse-number (prev-char char outport)
  (prog
   (str nxt-char)
   ;; first check prev-char suitable to precede a number
   (if (not (member prev-char
		    '(#\newline #\space #\. #\= #\+ #\- #\* #\/ #\( #\, )))
       (return nil))
   (setq str (make-string-output-stream))
   ;; examine first char and peek at second to ascertain this is a number
   (setq nxt-char (peek-char nil *inp* nil 'EOF t))
   (cond ((and (digit-char-p char)
	       (or (and (not (equalp nxt-char 'EOF))
			(digit-char-p nxt-char))
		   ;; ael - another problem that arose from letting things stay
		   ;; lower-case! added #\d #\e
		   (member nxt-char '(#\. #\D #\E #\d #\e))))
	  ;;lea
	  (write-char char str) )
	 ((and (or (char= char '#\+) (char= char '#\-))
	       (char= nxt-char '#\.))
	  (write-char char str) (write-char '#\0 str) )
	 ((and (or (char= char '#\+) (char= char '#\-))
	       (digit-char-p nxt-char))
	  (write-char char str))
	 ((and (char= char '#\.) (digit-char-p nxt-char))
	  (write-char '#\0 str) (write-char '#\. str) )
	 (t (return nil)))
   ;; parse rest of number;EOF
   loop
   (setq char (read-char *inp* nil 'EOF t)
	 nxt-char (peek-char nil *inp* nil 'EOF t))
   (if (eql nxt-char 'EOF) (setq nxt-char `#\space))
   (cond ((eql char 'EOF)
	  (write (get-output-stream-string str) :stream outport :escape nil)
	  (write-char '#\space outport)
	  (return t))
	 ((digit-char-p char)
	  (write-char char str)
	  (go loop))
	 ((and (char= char '#\.) (not (or (digit-char-p nxt-char)
					  ;;ael
					  (char= nxt-char '#\d)
					  (char= nxt-char '#\e)
					  ;;lea
					  (char= nxt-char '#\D)
					  (char= nxt-char '#\E))))
	  (write-char '#\. str) (write-char '#\0 str)
	  (write (get-output-stream-string str) :stream outport :escape nil)
	  (write-char '#\space outport)
	  (return t))
	 ((and (char= char '#\.) (digit-char-p nxt-char))
	  (write-char '#\. str)
	  (go loop))
	 ((and (char= char '#\.) (not (digit-char-p nxt-char)))
	  (write-char '#\. str) (write-char '#\0 str)
	  (go loop))
	 ;;ael((char= char '#\E)
	 ((or (char= char '#\E) (char= char '#\e))
	  (write-char '#\e str)
	  (cond ((char= nxt-char '#\+) (read-char *inp* nil 'EOF t))
		((char= nxt-char '#\-) (read-char *inp* nil 'EOF t)
		 (write-char '#\% str)))
	  (go loop))
	 ;;ael((char= char '#\D)
	 ((or (char= char '#\D) (char= char '#\d))
;;;ael
	  #|
	  (write-char '#\d str)
|#
;;;ael - I thought that we'd try replacing the d format with the e format,
;;; since it's read incorrectly anyway....
	  (write-char '#\e str)
	  (cond ((char= nxt-char '#\+) (read-char *inp* nil 'EOF t))
		((char= nxt-char '#\-) (read-char *inp* nil 'EOF t)
		 (write-char '#\% str)))
;;;ael
	  (go loop))
	 ((or (char= char '#\-) (char= char '#\+))
	  (write-char char str)
	  (go loop))
	 (t ;number complete
	  #+clisp
	  (if (equal (peek-char nil *inp* nil 'EOF t) 'EOF)
	      (setq *inp* (make-string-input-stream (string char)))
	    (setq *inp*
		  (make-string-input-stream
		   (concatenate 'string (string char) (read-line *inp*)))))
	  #-clisp (unread-char char *inp*)
	  (write (get-output-stream-string str) :stream outport :escape nil)
	  (write-char '#\space outport)
	  (return t)))))


;;;-----------------------------------------------------------------------------
; end of f2cl6.l

; f2cl7.l
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Hamilton, New Zealand 1992-95 - all rights reserved;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; optimization post processing phase
; functions:
;	find-go-labels
;	count-go-end
;	labelp
;	find-all-labels
;	remove-from-tree
;	prune-labels
;	cond-remove-end-label

(defvar *prune_labels* t)
(eval-when (compile load eval) (proclaim '(special *verbose*)))

;-----------------------------------------------------------------------
(defun find-go-labels (x)
  (cond
     ((atom x) nil)
     ((eq (car x) 'go) (cons (cadr x) (find-go-labels (cdr x))))
     (t (append (find-go-labels (car x))
                (find-go-labels (cdr x))))))

;-----------------------------------------------------------------------
(defun count-go-end (x)
  (cond
     ((atom x) 0)
     ((equal x  '(go end_label)) 1)
     (t (+ (count-go-end (car x))
           (count-go-end (cdr x))))))

;-----------------------------------------------------------------------
(defun labelp (x) (and (symbolp x) (eq 5 (string-lessp "LABEL" (string x)))))

;------------------------------------------------------------------------
(defun find-all-labels (x)
  (cond
     ((atom x) nil)
     ((labelp (car x)) (cons (car x) (find-all-labels (cdr x))))
     (t (append (find-all-labels (car x))
                (find-all-labels (cdr x))))))

;-----------------------------------------------------------------------
(defun remove-from-tree (s tree) ; s must be a symbol
  (setq tree (if (atom tree) tree (remove s tree :test #'eq)))
  (mapcar #'(lambda (y) (if (atom y) y (remove-from-tree s y))) tree))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                prune-labels
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun prune-labels (fun)
 (if *verbose* (format t "post-processing begins ...~%"))
 (if *prune_labels*
  (let* ((labels (find-all-labels fun))
         (golabels (find-go-labels fun))
         (spare-labels (set-difference labels golabels)))
        (setq fun (cond-remove-end-label fun))
        (dolist (s spare-labels fun)
           (setq fun (remove-from-tree s fun))))
  fun))

;-----------------------------------------------------------------------
; If "(go end_label)" appears just once in a subroutine the second and
; third to last exprs of the subroutine are removed if (go end_label)
; is third to last expr.
; Also if "(go end_label)" does not appear in the subroutine "end_label"
; is removed.
(defun cond-remove-end-label (fun)
  (let* ((name (second fun))
        (args (third fun))
        (body (nthcdr 3 fun))
        (rbody (reverse body)))
    (setq body
          (cond ((zerop (count-go-end body))
                 (remove 'end_label body))
                ((and (equal (third rbody) '(go end_label))
                      (= (count-go-end body) 1))
                 (reverse (cons (car rbody) (cdddr rbody))))
                (t body)))
    `(defun ,name ,args ,@body)))
;-----------------------------------------------------------------------
(defun find-declarations (fun)
 (remove nil
   (mapcar
      #'(lambda (x) (if (and (listp x) (or (eq (car x) 'declare)
                                           (eq (car x) 'proclaim)))
                        x nil))
      fun)))
;-----------------------------------------------------------------------
; end of f2cl7.l

; macros.l - all the basic macros
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Copyright (c) University of Waikato;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Hamilton, New Zeland 1992-95 - all rights reserved;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(print "macros.l")
(in-package :user)
(eval-when (compile load eval)
   (export '(do1 do! map-defvar double-cdr double-mapcar push
             fexport fproclaim fuse-package fin-package fdo arithmetic-if
             computed-goto assigned-goto)))

; macros:
;	rexpt
;	fexport
;	fproclaim
;	fuse-package
;	fin-package
;	map-defvar
;	do1
;	do!
;	double-cdr
;	putproperty
;	defprop
;	array-cl
;	store-cl
;	apply!

;	rfref
;	rfset
;	fref
;	fset

;	while
;       fdo
;	reset-vble - a defun
;       arithmetic-if
;	computed-goto
;	assigned-goto
;	eqv
;	constant-list
;       Fortran intrinsic functions imax, dabs,...
;;;----------------------------------------------------------------------------

(eval-when (compile load eval) (proclaim '(special *verbose*)))
;;;----------------------------------------------------------------------------
#+aclpc (defmacro rexpt (x y) `(realpart (expt ,x ,y)))
#-aclpc (defmacro rexpt (x y) `(expt ,x ,y))

(defmacro fexport (x) `(eval-when (compile load eval) (export ,x)))

(defmacro fproclaim (x) `(eval-when (compile load eval) (proclaim ,x)))

(defmacro fin-package (x)
  `(prog nil
     (defpackage ,x)
     (in-package ,x)))

(defmacro fuse-package (x) `(eval-when (compile load eval) ,x))
;-------------------------------------------------------------------------

(defmacro apply! (fun args) (eval `(cons ,fun ,args)))

(defmacro map-defvar (&rest l)
   `(progn ,@(mapcar #'(lambda (x y) (list 'defvar x y))
                     (car (odd-even l))
                     (cadr (odd-even l)))))
;;;-----------------------------------------------------------------------------

(defmacro do! (var init step end &rest body)
  `(do ((,var ,init ,step)) (,end) ,@body))

; the body is an unquoted list of the terms of the actual body
(defmacro do1 (var end body)
  `(do ((,var 1 (1+ i))) ((> ,var ,end)) ,@body))

(defmacro double-cdr (lis)
  `(mapcar #'cdr (cdr ,lis)))

(defun putproperty (a b c) (setf (get a c) b))

(defmacro defprop (sym prop ind)
  `(putproperty ',sym ',prop ',ind))

;;ael - I want to see if I can get away without redefining this!
;; (defmacro def (name body) `(defun ,name ,(cadr body) ,(caddr body)))
;;ael

(defmacro array-cl (name type &rest dims)
  `(set ',name
        (make-array
	 ',(mapcar #'eval dims)
	 :element-type ,(cond ((equal type 'fixnum-block) ''integer)
			      ((equal type 'flonum-block)  ''flonum) ;###
			      ((equal type t) t)))))

(defmacro store-cl (name-indices val)
  `(setf (aref ,(car name-indices) ,@(cdr name-indices)) ,val))
;;;-----------------------------------------------------------------------------

(defmacro fref (arr &rest indices)
  `(aref ,arr ,@(mapcar #'(lambda (x) (list '1- x)) indices)))

(defmacro fset (a b)
  `(setf (fref ,(second a) ,@(cddr a)) ,b))
#|
;; ael - trying to avoid an integer array problem:
(defmacro fset (a b)
  `(if (typep ,a 'fixnum)
       (setf (fref ,(second a) (int ,@(cddr a))) ,b)
     (setf (fref ,(second a) ,@(cddr a)) ,b)
     )
  )
|#

(defmacro rfref (arr &rest indices)
  `(aref ,arr ,@(mapcar #'(lambda (x) (list '1- x)) (reverse indices))))

(defmacro rfset (a b)
  `(setf (rfref ,(second a) ,@(cddr a)) ,b))

;;;----------------------------------------------------------------------------

#-aclpc (defmacro while (con &rest body)
            `(loop (if (not ,con) (return t)) ,@body))
;------------------------------------------------------------------

(defun ccomment (s) (when *verbose* (princ s) (terpri)))

;;;----------------------------------------------------------------------------
(defun reset-vble (pred-clause) ; ((> i 4) nil)
   `(,(first pred-clause)
          (setq ,(second (first pred-clause)) ,(third (first pred-clause)))
          ,(second pred-clause)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                fdo
;;
;; fdo has similar syntax as do except there will only be one do_vble
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro fdo (do_vble_clause predicate_clause &rest body)
   `(prog* ((step ,(third (third do_vble_clause)))
            (iteration_count
               (max (truncate (+ (- ,(third (first predicate_clause))
                                    ,(second do_vble_clause)) step) step) 0)))
           ; initialise loop variable
           (setq ,(first do_vble_clause) ,(second do_vble_clause))
           loop
           (return
           (cond ; all iterations done
                 ((zerop iteration_count) nil)
                 ; execute loop, in/de-crement loop vble and decrement cntr
                 ,(cons 't
                        (append
                         (append body
                             `((setq ,(first do_vble_clause)
                                     ,(third do_vble_clause)
                                     iteration_count
                                            (1- iteration_count))))
                         '((go loop))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                constant-list
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun constant-list (x n)
  (do  ((i 1 (1+ i))
        (ret nil (cons x ret)))
       ((> i n) ret)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                f2cl/
;;
;; macro for division
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro f2cl/ (x y)
  `(if (and (typep ,x 'fixnum) (typep ,y 'fixnum))
       (floor ,x ,y)
     (/ ,x ,y)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                arithmetic-if
;;
;; macro for a lisp equivalent of Fortran arithmetic IFs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro arithmetic-if (pred s1 s2 s3)
  `(cond ((< ,pred 0) ,s1)
	 ((= ,pred 0) ,s2)
	 (t ,s3)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                computed-goto
;;
;; macro for a lisp equivalent of Fortran computed GOTOs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro computed-goto (tag-lst i)
  `(let ((tag ,(nth (1- (eval i)) tag-lst)))
     (if tag (go tag) nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                assigned-goto
;;
;; macro for a lisp equivalent of Fortran assigned GOTOs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro assigned-goto (i &optional tag-lst)
  `(if ,tag-lst
       (if (member ,i ,tag-lst)
	   (go ,i)
	 (error "bad statement number in assigned goto"))
     (go ,i)))


;;;-----------------------------------------------------------------------------
; set up a list of intrinsic function names
;real xxx
(defvar intrinsic_function_names
  '(int ifix idint real float sngl dble cmplx ichar char aint dint
    anint dnint nint idnint iabs abs dabs cabs mod amod dmod isign sign dsign
    idim dim ddim dprod max max0 amax1 dmax1 amax0 amax1 min min0 amini dmini
    amini min1 len index lge lgt lle llt aimag conjg sqrt dsqrt csqrt
    exp dexp cexp log alog dlog clog log10 alog10 dlog10 sin dsin csin
    cos dcos ccos tan dtan asin dasin acos dacos atan datan atan2 datan2
    sinh dsinh cosh dcosh tanh dtanh))

;; ael - zzz
;; This collection of functions is supposed to help me figure out when I need
;; to use a funcall. If I don't find a symbol in this list, e.g. fx, and it's
;; supposed to
(setq all-kinds-of-functions
      (combine
       intrinsic_function_names
       '(+ - / *)
       '(f2cl/ function)
       '(expt
	 and or not
	 )
       '(rexpt
	 fexport
	 fproclaim
	 fuse-package
	 fin-package
	 map-defvar
	 do1
	 do!
	 double-cdr
	 putproperty
	 defprop
	 array-cl
	 store-cl
	 apply!
	
	 rfref
	 rfset
	 fref
	 fset
	
	 while
	 fdo
	 reset-vble - a defun
	 arithmetic-if
	 computed-goto
	 assigned-goto
	 eqv
	 constant-list
	 )
       ))
;;ael

; some macros for intrinsic functions
(defmacro int (x)
  `(floor ,x))
(defmacro ifix (x)
  `(floor ,x))
(defmacro idfix (x)
  `(floor ,x))

(defmacro real_ (x)
  `(coerce ,x 'single-float))

(defmacro sngl (x)
  `(coerce ,x 'single-float))

(defmacro cmplx (x &optional y)
  `(complex ,x ,(if y y 0)))

(defmacro ichar (c)
  `(char-int ,c))
(defmacro fchar (i)  ;intrinsic function char
  `(char-int ,i))

(defmacro aint (x)
  `(float (truncate ,x)))
(defmacro dint (x)
  `(coerce (truncate ,x) 'double-float))
(defmacro anint (x)
  `(float (round ,x)))
(defmacro dnint (x)
  `(coerce (round ,x) 'double-float))
(defmacro nint (x)
  `(round ,x))
(defmacro idnint (x)
  `(round ,x))

#-aclpc (defmacro iabs (x) `(abs ,x))
(defmacro dabs (x)
  `(abs ,x))
(defmacro cabs (x)
  `(abs ,x))

(defmacro amod (x y)
  `(mod ,x ,y))
(defmacro dmod (x y)
  `(mod ,x ,y))

(defmacro sign (x y)
  `(if (>= ,y 0) (abs ,x) (- (abs ,x))))
(defmacro isign (x y)
  `(if (>= ,y 0) (abs ,x) (- (abs ,x))))
(defmacro dsign (x y)
  `(if (>= ,y 0) (abs ,x) (- (abs ,x))))

(defmacro idim (x y)
  `(abs (- ,x ,y)))
(defmacro dim (x y)
  `(abs (- ,x ,y)))
(defmacro ddim (x y)
  `(abs (- ,x ,y)))

(defmacro dprod (x y)
  `(coerce (* ,x ,y) `double-float))

(defmacro max0 (&rest x)
  `(funcall #'max ,@x))
(defmacro amax1 (&rest x)
  `(funcall #'max ,@x))
(defmacro dmax1 (&rest x)
  `(funcall #'max ,@x))
(defmacro amax0 (&rest x)
  `(round (funcall #'max ,@x)))
(defmacro max1 (&rest x)
  `(float (funcall #'max ,@x)))

(defmacro min0 (&rest x)
  `(funcall #'min ,@x))
(defmacro amin1 (&rest x)
  `(funcall #'min ,@x))
(defmacro dmin1 (&rest x)
  `(funcall #'min ,@x))
(defmacro amin0 (&rest x)
  `(round (funcall #'min ,@x)))
(defmacro min1 (&rest x)
  `(float (funcall #'min ,@x)))

(defmacro len (s)
  `(length ,s))

;;ael
#|
(defmacro index (s1 s2)
  (declare (ignore s1 s2))
  `(error "macro for intrinsic INDEX not yet implemented"))
|#
;; I think that this has got it:
(defmacro index (s1 s2)
  `(let ((in (grep ,s1 ,s2))) (if in (1+ in) 0)))
;;ael

(defmacro lge (s1 s2)
  `(string>= ,s1 ,s2))
(defmacro lgt (s1 s2)
  `(string> ,s1 ,s2))
(defmacro lle (s1 s2)
  `(string<= ,s1 ,s2))
(defmacro llt (s1 s2)
  `(string< ,s1 ,s2))

(defmacro aimag (c)
  `(imagpart ,c))
(defmacro conjg (c)
  `(conjugate ,c))

(defmacro dsqrt (x)
  `(sqrt ,x))
(defmacro csqrt (x)
  `(sqrt ,x))

(defmacro dexp (x)
  `(exp ,x))
(defmacro cexp (x)
  `(exp ,x))

(defmacro alog (x)
  `(log ,x))
(defmacro dlog (x)
  `(log ,x))
(defmacro clog (x)
  `(log ,x))
(defmacro alog10 (x)
  `(log ,x 10))
(defmacro dlog10 (x)
  `(log ,x 10))

(defmacro dsin (x)
  `(sin ,x))
(defmacro csin (x)
  `(sin ,x))

(defmacro dcos (x)
  `(cos ,x))
(defmacro ccos (x)
  `(cos ,x))

(defmacro dtan (x)
  `(tan ,x))
(defmacro ctan (x)
  `(tan ,x))

(defmacro dasin (x)
  `(asin ,x))
(defmacro dacos (x)
  `(acos ,x))
(defmacro datan (x)
  `(atan ,x))
(defmacro atan2 (x y)
  `(atan (/ ,x ,y)))
(defmacro datan2 (x y)
  `(atan (/ ,x ,y)))

(defmacro dsinh (x)
  `(sinh ,x))
(defmacro dcosh (x)
  `(cosh ,x))
(defmacro dtanh (x)
  `(tanh ,x))
;;;-----------------------------------------------------------------------------  ; end of macros.l

;; ael: the following resets all my favorite shortcuts (like ?, !, etc.):
(new-readtable)

